/* DEVELOPMENT HISTORY */
/* Revision 1.12  1997/05/15 18:48:41  slywczak
 * Added the function prototype setScalingFactors_2A56.  This function will add
 * the scaling factors to the SDSs.
 *
 * Revision 1.11  1997/05/15 18:28:31  slywczak
 * Added the following function prototypes:  setScalingFactors_2A53,
 * setScalingFactors_2A55, setScalingFactors_3A53, setScalingFactors_3A54,
 * and setScalingFactors_3A55.  These functions will add the scaling factors to
 * the SDSs.
 *
 * Revision 1.10  1997/04/28 18:58:37  jt
 * Added prototypes for readGauge(), readDisdrometer(), and readNetworkDesc().
 *
 * Revision 1.9  1997/01/07 20:34:57  amak
 * Defined function prototype for writeNetworkDesc, writeDisdrometer and
 * writeGauge.
 *
 * Revision 1.8  1996/08/29  23:10:49  amak
 * Added one more parameter (productID) for writeGV_L1B_1C() and
 * readGV_L1B_1C() API.
 *
 * Revision 1.7  1996/06/07  14:53:44  amak
 * Defined function prototypes for more multiple radar sites.
 *
 * Revision 1.6  1996/03/21  20:09:23  amak
 * Added function prototype writeGV_3A_46 and readGV_3A_46
 *
 * Revision 1.5  1995/12/13  19:04:16  thyun
 * Removed the routines which are related to Level 1 GV access.
 *
 * Revision 1.4  1995/12/12  15:21:14  amak
 * Defined L1 GV function prototypes.
 *
 * Revision 1.3  1995/11/15  23:22:59  thyun
 * Defined prototypes of writeGV_L1B_1C and readGV_L1B_1C.
 *
 * Revision 1.2  1995/10/18  20:52:46  amak
 * Made modifications after some files need to be renamed.
 *
 * Revision 1.1  1995/10/18  20:17:01  amak
 * Renamed IO_INTERNAL_GV.h to IO_INTR_GV.h
 *
 * Revision 1.6  1995/10/10  14:52:02  thyun
 * Modified proto-type functions according to the changes in data structure
 * definitions in IO_GV.h.
 *
 * Revision 1.5  1995/08/29  15:01:35  amak
 * Modified the preprocessor statements.
 *
 * Revision 1.4  1995/08/25  18:32:16  thyun
 * Inserted file header comment blocks.
 *
 * Revision 1.3  1995/08/17  19:19:09  amak
 * Deleted FORTRAN interface because that is not necessary.
 *
 * Revision 1.2  1995/08/10  19:27:40  thyun
 * Changed the name of writeScan and readScan to writeGrid and readGrid.
 *
 * Revision 1.1  1995/08/03  18:25:53  thyun
 * Adding file.
 *
*/

/*******************************************************************************
*
*  FILE NAME:           IO_INTR_GV.h
*
*  DESCRIPTION:         This file contains the prototypes of the GV
*                       products routines in IO_INTR_GV.c file.
*
*******************************************************************************/

#ifndef __IO_INTR_GV_H
#define __IO_INTR_GV_H 1

int writeGV_L1B_1C(IO_HANDLE *sGranuleHandle, L1B_1C_GV *sL1b1c, int productID);
int readGV_L1B_1C(IO_HANDLE *sGranuleHandle, L1B_1C_GV *sL1b1c, int productID);

int writeGVGrid_2A_53_single(IO_HANDLE *sGranuleHandle, L2A_53_SINGLE_RADARGRID *sRadarGrid);
int readGVGrid_2A_53_single(IO_HANDLE *sGranuleHandle, L2A_53_SINGLE_RADARGRID *sRadarGrid);

int writeGVGrid_2A_53_TX_mult(IO_HANDLE *sGranuleHandle, L2A_53_MULT_TX_RADARGRID *sRadarGrid);
int readGVGrid_2A_53_TX_mult(IO_HANDLE *sGranuleHandle, L2A_53_MULT_TX_RADARGRID *sRadarGrid);

int writeGVGrid_2A_53_FL_mult(IO_HANDLE *sGranuleHandle, L2A_53_MULT_FL_RADARGRID *sRadarGrid);
int readGVGrid_2A_53_FL_mult(IO_HANDLE *sGranuleHandle, L2A_53_MULT_FL_RADARGRID *sRadarGrid);

int writeGVGrid_2A_54_single(IO_HANDLE *sGranuleHandle, L2A_54_SINGLE_RADARGRID *sRadarGrid);
int readGVGrid_2A_54_single(IO_HANDLE *sGranuleHandle, L2A_54_SINGLE_RADARGRID *sRadarGrid);

int writeGVGrid_2A_54_TX_mult(IO_HANDLE *sGranuleHandle, L2A_54_MULT_TX_RADARGRID *sRadarGrid);
int readGVGrid_2A_54_TX_mult(IO_HANDLE *sGranuleHandle, L2A_54_MULT_TX_RADARGRID *sRadarGrid);

int writeGVGrid_2A_54_FL_mult(IO_HANDLE *sGranuleHandle, L2A_54_MULT_FL_RADARGRID *sRadarGrid);
int readGVGrid_2A_54_FL_mult(IO_HANDLE *sGranuleHandle, L2A_54_MULT_FL_RADARGRID *sRadarGrid);

int writeGVGrid_2A_55_single(IO_HANDLE *sGranuleHandle, L2A_55_SINGLE_RADARGRID *sRadarGrid);
int readGVGrid_2A_55_single(IO_HANDLE *sGranuleHandle, L2A_55_SINGLE_RADARGRID *sRadarGrid);

int writeGVGrid_2A_55_TX_mult(IO_HANDLE *sGranuleHandle, L2A_55_MULT_TX_RADARGRID *sRadarGrid);
int readGVGrid_2A_55_TX_mult(IO_HANDLE *sGranuleHandle, L2A_55_MULT_TX_RADARGRID *sRadarGrid);

int writeGVGrid_2A_55_FL_mult(IO_HANDLE *sGranuleHandle, L2A_55_MULT_FL_RADARGRID *sRadarGrid);
int readGVGrid_2A_55_FL_mult(IO_HANDLE *sGranuleHandle, L2A_55_MULT_FL_RADARGRID *sRadarGrid);

int writeGVGrid_3A_53_single(IO_HANDLE *sGranuleHandle, L3A_53_SINGLE_RADARGRID *sRadarGrid);
int readGVGrid_3A_53_single(IO_HANDLE *sGranuleHandle, L3A_53_SINGLE_RADARGRID *sRadarGrid);

int writeGVGrid_3A_53_TX_mult(IO_HANDLE *sGranuleHandle, L3A_53_MULT_TX_RADARGRID *sRadarGrid);
int readGVGrid_3A_53_TX_mult(IO_HANDLE *sGranuleHandle, L3A_53_MULT_TX_RADARGRID *sRadarGrid);

int writeGVGrid_3A_53_FL_mult(IO_HANDLE *sGranuleHandle, L3A_53_MULT_FL_RADARGRID *sRadarGrid);
int readGVGrid_3A_53_FL_mult(IO_HANDLE *sGranuleHandle, L3A_53_MULT_FL_RADARGRID *sRadarGrid);

int writeGVGrid_3A_54_single(IO_HANDLE *sGranuleHandle, L3A_54_SINGLE_RADARGRID *sRadarGrid);
int readGVGrid_3A_54_single(IO_HANDLE *sGranuleHandle, L3A_54_SINGLE_RADARGRID *sRadarGrid);

int writeGVGrid_3A_54_TX_mult(IO_HANDLE *sGranuleHandle, L3A_54_MULT_TX_RADARGRID *sRadarGrid);
int readGVGrid_3A_54_TX_mult(IO_HANDLE *sGranuleHandle, L3A_54_MULT_TX_RADARGRID *sRadarGrid);

int writeGVGrid_3A_54_FL_mult(IO_HANDLE *sGranuleHandle, L3A_54_MULT_FL_RADARGRID *sRadarGrid);
int readGVGrid_3A_54_FL_mult(IO_HANDLE *sGranuleHandle, L3A_54_MULT_FL_RADARGRID *sRadarGrid);

int writeGVGrid_3A_55(IO_HANDLE *sGranuleHandle, L3A_55_RADARGRID *sRadarGrid);
int readGVGrid_3A_55(IO_HANDLE *sGranuleHandle, L3A_55_RADARGRID *sRadarGrid);

int writeGVGrid_3A_46(IO_HANDLE *sGranuleHandle, L3A_46_PLANETGRID *sPlanetGrid);
int readGVGrid_3A_46(IO_HANDLE *sGranuleHandle, L3A_46_PLANETGRID *sPlanetGrid);

int writeNetworkDesc(IO_HANDLE *sGranuleHandle, int nnet, NETDESC *sNetDesc);
int readNetworkDesc(IO_HANDLE *sGranuleHandle, int nnet, NETDESC *sNetDesc);

int writeGauge(IO_HANDLE *sGranuleHandle, L2A_56_RAINGAUGE *sGauge);
int readGauge(IO_HANDLE *sGranuleHandle, L2A_56_RAINGAUGE *sGauge);

int writeDisdrometer(IO_HANDLE *sGranuleHandle, L2A_57_DISDROMETER *sDisdrometer);
int readDisdrometer(IO_HANDLE *sGranuleHandle, L2A_57_DISDROMETER *sDisdrometer);

int setScalingFactors_2A53 ( VGROUP_LINK * );

int setScalingFactors_2A55 ( VGROUP_LINK * );

int setScalingFactors_2A56 ( VGROUP_LINK * );

int setScalingFactors_3A53 ( VGROUP_LINK * );

int setScalingFactors_3A54 ( VGROUP_LINK * );

int setScalingFactors_3A55 ( VGROUP_LINK * );
#endif
