/* DEVELOPMENT HISTORY */
/* Revision 1.8  1998/07/09 14:56:17  slywczak
 * Modified prototypes for routine setScalingFactors_2A23 and
 * setScalingFactors_2A25.  Added the second argument for the real time Flag.
 *
 * Revision 1.7  1998/06/26 17:03:22  slywczak
 * Added read/write routine prototypes for 2A23 and the two versions of 2A25.
 * The routines are called writeScan_2A_23_R1, readScan_2A_23_R1,
 * writeScan_2A_25_R1, readScan_2A_25_R1, writeScan_2A_25_R2, readScan_2A_25_R2.
 *
 * Revision 1.6  1997/05/15 14:26:53  slywczak
 * Added prototype for the following PR scaling functions:
 * setScalingFactors_1B21, setScalingFactors_2A21, setScalingFactors_2A25,
 * and setScalingFactors_2B31.
 *
 * Revision 1.5  1997/01/07 20:33:43  amak
 * Defined function prototype for readGrid_3A_25 and writeGrid_3A_25.
 *
 * Revision 1.4  1996/06/18  14:02:09  amak
 * Defined function prototypes for writeL2A25Header(), readL2A25Header(),
 * writeL1B21_L1C21Header(), and readL1B21_L1C21Header().
 *
 * Revision 1.3  1996/03/21  20:10:23  amak
 * Modified function prototype writeGrid_2B_31 and readGrid_2B_31.
 *
 * Revision 1.2  1995/10/18  20:52:46  amak
 * Made modifications after some files need to be renamed.
 *
 * Revision 1.1  1995/10/18  20:19:19  amak
 * Renamed IO_INTERNAL_PR.h to IO_INTR_PR.h
 *
 * Revision 1.13  1995/08/29  15:01:35  amak
 * Modified the preprocessor statements.
 *
 * Revision 1.12  1995/08/10  19:36:03  thyun
 * Gave only one line space between the routines.
 *
 * Revision 1.11  1995/08/08  20:15:58  amak
 * Modified L3A-25 and L3A_26 prototypes.
 *
 * Revision 1.10  1995/08/04  19:59:11  amak
 * Added new data structure based on the new file spec (8/3/95)
 *
 * Revision 1.9  1995/08/03  17:45:59  amak
 * Re-modified the code because CVS couldn't do version control nicely.
 *
 * Revision 1.8  1995/07/27  13:24:53  amak
 * Added underscores to the include file names in the preprocessor statements.
 *
 * Revision 1.7  1995/07/20  18:24:36  amak
 * Added prototypes readGrid_3A_25(), readGrid_3A_26(), readGrid_3B_31(), 
 * writeGrid3A_25(), writeGrid_3A_26(), and writeGrid_3B_31() for Level 3 API.
 *
 * Revision 1.6  1995/07/19  20:11:41  thyun
 * Changed the parameters of readScan_2B_31 and writeScan_2B_31.
 *
 * Revision 1.5  1995/07/07  14:06:25  thyun
 * Modified & added comments
 *
 * Revision 1.4  1995/07/05  18:56:00  amak
 * Added new data structure
 *
 * Revision 1.3  1995/06/26  21:14:16  amak
 * Structure Changed in File Spec -- SwathData
 *
 * Revision 1.2  1995/06/08  20:10:15  amak
 * Added log file header.
 * */

/*******************************************************************************
*
*  FILE NAME:           IO_INTR_PR.h
*
*  DESCRIPTION:         This file contains the prototypes of the PR
*                       product routines in IO_INTR_PR.c file.
*
*******************************************************************************/



#ifndef __IO_INTR_PR_H
#define __IO_INTR_PR_H 1




int writeScan_1B_21(IO_HANDLE *sGranuleHandle, L1B_21_SWATHDATA *sSwathData);

int readScan_1B_21(IO_HANDLE *sGranuleHandle,  L1B_21_SWATHDATA *sSwathData);

int writeScan_2A_21(IO_HANDLE *sGranuleHandle, L2A_21_SWATHDATA *sSwathData);

int readScan_2A_21(IO_HANDLE *sGranuleHandle,  L2A_21_SWATHDATA *sSwathData);

int writeScan_2A_23(IO_HANDLE *sGranuleHandle, L2A_23_SWATHDATA *sSwathData);

int writeScan_2A_23_R1(IO_HANDLE *sGranuleHandle, L2A_23_R1_SWATHDATA *sSwathData);

int readScan_2A_23(IO_HANDLE *sGranuleHandle, L2A_23_SWATHDATA *sSwathData);

int readScan_2A_23_R1(IO_HANDLE *sGranuleHandle, L2A_23_R1_SWATHDATA *sSwathData);

int writeScan_2A_25(IO_HANDLE *sGranuleHandle, L2A_25_SWATHDATA *sSwathData);
int writeScan_2N_25(IO_HANDLE *sGranuleHandle, L2N_25_SWATHDATA *sSwathData);

int writeScan_2A_25_R1(IO_HANDLE *sGranuleHandle, L2A_25_R1_SWATHDATA *sSwathData);

int writeScan_2A_25_R2(IO_HANDLE *sGranuleHandle, L2A_25_R2_SWATHDATA *sSwathData);

int readScan_2A_25(IO_HANDLE *sGranuleHandle, L2A_25_SWATHDATA *sSwathData);
int readScan_2N_25(IO_HANDLE *sGranuleHandle, L2N_25_SWATHDATA *sSwathData);

int readScan_2A_25_R1(IO_HANDLE *sGranuleHandle, L2A_25_R1_SWATHDATA *sSwathData);

int readScan_2A_25_R2(IO_HANDLE *sGranuleHandle, L2A_25_R2_SWATHDATA *sSwathData);

int writeScan_2B_31(IO_HANDLE *sGranuleHandle, L2B_31_SWATHDATA *sScanData);

int readScan_2B_31(IO_HANDLE *sGranuleHandle, L2B_31_SWATHDATA *sScanData);

int writeGrid_3A_25(IO_HANDLE *sGranuleHandle, L3A_25_GRID *sGrid);

int readGrid_3A_25(IO_HANDLE *sGranuleHandle, L3A_25_GRID *sGrid);

int writeGrid_3A_26(IO_HANDLE *sGranuleHandle, L3A_26_GRID *sGrid);

int readGrid_3A_26(IO_HANDLE *sGranuleHandle, L3A_26_GRID *sGrid);

int writeGrid_3A_27(IO_HANDLE *sGranuleHandle, L3A_27_GRID *sGrid);

int readGrid_3A_27(IO_HANDLE *sGranuleHandle, L3A_27_GRID *sGrid);

int writeGrid_3B_31(IO_HANDLE *sGranuleHandle, L3B_31_GRID *sGrid);

int readGrid_3B_31(IO_HANDLE *sGranuleHandle, L3B_31_GRID *sGrid);

int writeL2A25Header(IO_HANDLE *sGranuleHandle, CLUTTER_FLAGS *sHeader);

int readL2A25Header(IO_HANDLE *sGranuleHandle, CLUTTER_FLAGS *sHeader);

int writeL1B21_L1C21Header(IO_HANDLE *sGranuleHandle, L1B21_L1C21_HEADER *sHeader);

int readL1B21_L1C21Header(IO_HANDLE *sGranuleHandle, L1B21_L1C21_HEADER *sHeader);

int setScalingFactors_1B21 ( VGROUP_LINK * );

int setScalingFactors_2A21 ( VGROUP_LINK * );

int setScalingFactors_2A23 ( VGROUP_LINK *, int );

int setScalingFactors_2A25 ( VGROUP_LINK *, int );

int setScalingFactors_2B31 ( VGROUP_LINK * );

#endif
