/*Revision 1.6  1998/07/09 14:56:45  slywczak
 *Modified prototypes for routine setScalingFactors_1B11 and
 *setScalingFactors_2A12.  Added the second argument for the real time Flag.
 *
 *Revision 1.5  1998/06/26 17:05:01  slywczak
 *Added read/write function prototypes for 1B11 and 2A12.  The routines are
 *called writeScan_1B_11_R1, readScan_1B_11_R1, writeScan_2A_12_R1, and
 *readScan_2A_12_R1
 *
 *Revision 1.4  1997/05/29 03:06:40  slywczak
 *Added the include files for TK error handle.  This will allow the TKreport
 *function to be called from the TMI routines.
 *
 *Revision 1.3  1997/05/15 15:04:42  slywczak
 *Added the prototypes for the following functions:  setScalingFactors_1B11,
 *setScalingFactor_2A12, setScalingFactors_3A11.  These function will write the
 *scaling factors to the SDSs.
 *
 *Revision 1.2  1995/10/18 20:52:47  amak
 *Made modifications after some files need to be renamed.
 *
 * Revision 1.1  1995/10/18  20:20:18  amak
 * Renamed IO_INTERNAL_TMI.h to IO_INTR_TMI.h
 *
 * Revision 1.9  1995/08/29  15:01:36  amak
 * Modified the preprocessor statements.
 *
 * Revision 1.8  1995/08/03  17:46:00  amak
 * Re-modified the code because CVS couldn't do version control nicely.
 *
 * Revision 1.7  1995/07/27  13:25:18  amak
 * Added underscores to the include file names in the preprocessor statements.
 *
 * Revision 1.6  1995/07/20  18:25:09  amak
 * Added prototypes readGrid_3A_11() and writeGrid_3A_11() for Level 3 API.
 *
 * Revision 1.5  1995/07/07  14:07:20  thyun
 * Modified and addes comments
 **/


/********************************************************************************
*
*  FILE NAME:		IO_INTR_TMI.h
*
*  DESCRIPTION: 	This file contains the prototypes of the TMI
*                       product routines in IO_INTR_TMI.c file.
*
********************************************************************************/


#ifndef __IO_INTR_TMI_H
#define __IO_INTR_TMI_H 1

#include "TKerrHandle.h"

int writeScan_1B_11(IO_HANDLE *sGranuleHandle, L1B_11_SWATHDATA *sSwathData);

int writeScan_1B_11_R1(IO_HANDLE *sGranuleHandle, L1B_11_R1_SWATHDATA *sSwathData);

int readScan_1B_11(IO_HANDLE *sGranuleHandle, L1B_11_SWATHDATA *sSwathData);

int readScan_1B_11_R1(IO_HANDLE *sGranuleHandle, L1B_11_R1_SWATHDATA *sSwathData);


int writeScan_2A_12(IO_HANDLE *sGranuleHandle,L2A_12_SWATHDATA *sSwathData);

int writeScan_2A_12_R1(IO_HANDLE *sGranuleHandle,L2A_12_R1_SWATHDATA *sSwathData);

int readScan_2A_12(IO_HANDLE *sGranuleHandle, L2A_12_SWATHDATA *sSwathData);

int readScan_2A_12_R1(IO_HANDLE *sGranuleHandle, L2A_12_R1_SWATHDATA *sSwathData);


int writeGrid_3A_11(IO_HANDLE *sGranuleHandle, L3A_11_PLANETGRID *sPlanetGrid);

int readGrid_3A_11(IO_HANDLE *sGranuleHandle, L3A_11_PLANETGRID *sPlanetGrid);

int writeGrid_3A_12(IO_HANDLE *sGranuleHandle, L3A_12_GRID *sPlanetGrid);

int readGrid_3A_12(IO_HANDLE *sGranuleHandle, L3A_12_GRID *sPlanetGrid);


int setScalingFactors_1B11 ( VGROUP_LINK *, int );

int setScalingFactors_2A12 ( VGROUP_LINK *, int );

int setScalingFactors_3A11 ( VGROUP_LINK * );

#endif
