/* DEVELOPMENT HISTORY */
/* Revision 1.3  1997/05/16 14:12:32  slywczak
 * Added the function prototype for the routine setScalingFactors_1B01.  This
 * routine will write the scaling factors to the VIRS 1B01 HDF file.  The
 * scaling factors will be attached to the local direction and channels
 * SDS.
 *
 * Revision 1.2  1995/10/18 20:52:47  amak
 * Made modifications after some files need to be renamed.
 *
 * Revision 1.1  1995/10/18  20:21:12  amak
 * Renamed IO_INTERNAL_VIRS.h to IO_INTR_VIRS.h
 *
 * Revision 1.7  1995/08/29  15:01:36  amak
 * Modified the preprocessor statements.
 *
 * Revision 1.6  1995/08/03  17:46:00  amak
 * Re-modified the code because CVS couldn't do version control nicely.
 *
 * Revision 1.5  1995/07/27  13:33:29  amak
 * Added underscores to the include file names in the preprocessor statements.
 *
 * Revision 1.4  1995/07/20  18:26:32  amak
 * Added prototypes readGrid_3B_42(), readGrid_3B_43(), writeGrid3B_42(), and
 * writeGrid_3B_43() for Level 3 API.
 *
 * Revision 1.3  1995/06/30  17:55:31  thyun
 * Modified writeScan_1B_01
 *
 * Revision 1.2  1995/06/08  20:10:17  amak
 * Added log file header.
 * */

/*******************************************************************************
*
*  FILE NAME:           IO_INTR_VIRS.h
*
*  DESCRIPTION:         This file contains the prototypes of the VIRS 
*                       products routines in IO_INTR_VIRS.c file.
*
*******************************************************************************/


#ifndef __IO_INTR_VIRS_H
#define __IO_INTR_VIRS_H 1

int writeScan_1B_01(IO_HANDLE *sGranuleHandle, L1B_01_SWATHDATA *swathData);

int readScan_1B_01(IO_HANDLE *sGranuleHandle, L1B_01_SWATHDATA *swathData);


int writeGrid_3B_42(IO_HANDLE *sGranuleHandle, L3B_42_PLANETGRID *sPlanetGrid);

int readGrid_3B_42(IO_HANDLE *sGranuleHandle, L3B_42_PLANETGRID *sPlanetGrid);


int writeGrid_3B_43(IO_HANDLE *sGranuleHandle, L3B_43_PLANETGRID *sPlanetGrid);

int readGrid_3B_43(IO_HANDLE *sGranuleHandle, L3B_43_PLANETGRID *sPlanetGrid);

int setScalingFactors_1B01 ( VGROUP_LINK * );
#endif

