/* DEVELOPMENT HISTORY */

/*Revision 1.10  1999/10/12 20:03:37  slywczak
 *Added the prototypes for TKreadlsm and TKreadTopo.
 *
 *Revision 1.9  1999/10/05 21:50:25  pkolbe
 *added fortran wrapper for tk get alg id
 *
 *Revision 1.8  1997/10/14 21:13:43  okelley
 *        Modifications to the Toolkit to implement new
 *        GV utilities.
 *
 *Revision 1.7  1997/03/05 20:42:45  slywczak
 *Added the FORTRAN "function prototype" for the TKcopyScanHeader routine.
 *
 *Revision 1.6  1997/02/10 15:50:37  piper
 *Fixed TKseek; removed TK_BOO and TK_BOF and added TK_ABS_ORBIT_OFF
 *
 *Revision 1.5  1996/11/01 20:53:59  amak
 *Added declaration for routines TKwriteDBRainInfo, TKcopyScanHeader,
 *TKwriteGauge, and TKwriteNetHeader.
 *
 * Revision 1.4  1996/06/14  21:56:41  amak
 * Added function prototype for TKreadHeader and TKwriteHeader.
 *
 * Revision 1.3  1996/05/21  17:48:43  amak
 * Added function prototypes for TKreportError and TKreportWarning.
 *
 * Revision 1.2  1995/12/12  15:29:53  amak
 * Renamed function TKgetNumOfVOS(), TKgetNumOfSensor(), and TKgetNumOfParm()
 * to TKgetNvos(), TKgetNsensor(), and TKgetNparm() respectively.  This was
 * based on the naming consistency of the other routines.
 *
 * Revision 1.1  1995/11/29  22:31:57  thyun
 * Adding a new file.
 **/

#ifndef __TKFORTRANDECLARE_H
#define __TKFORTRANDECLARE_H 1


/********************************************************************************
*
*  FILE NAME:           TKfortranDeclare.h
*
*  DESCRIPTION:         This file contains the declaration of toolkit routines
*			for the fortran part of the program.  Any user who is
*			calling toolkit routines from fortran program, needs
*			to include this file. 
*
*********************************************************************************/

#ifdef LANGUAGE_FORTRAN

        /************************/
        /* Function prototypes  */
        /************************/

        INTEGER*4 TKopen
        INTEGER*4 TKgetAlgorithmID
        INTEGER*4 TKreadlsm
        INTEGER*2 TKreadTopo
        INTEGER*4 TKreadScan
        INTEGER*4 TKwriteScan
        INTEGER*4 TKreadGrid
        INTEGER*4 TKwriteGrid
	INTEGER*4 TKwriteHeader
	INTEGER*4 TKreadHeader
        INTEGER*2 TKreadL1GV
        INTEGER*2 TKwriteL1GV
        INTEGER*4 TKreadMetadataInt
        INTEGER*4 TKreadMetadataFloat
        INTEGER*4 TKreadMetadataChar
        INTEGER*4 TKwriteMetadataInt
        INTEGER*4 TKwriteMetadataFloat
        INTEGER*4 TKwriteMetadataChar
        INTEGER*4 TKclose
        INTEGER*4 TKseek
        INTEGER*2 TKendOfFile
	INTEGER*2 TKreportError
	INTEGER*2 TKreportWarning
        INTEGER*4 TKgetNvos
        INTEGER*4 TKgetNsensor
        INTEGER*4 TKgetNparm
        INTEGER*4 TKgetNcell
        INTEGER*4 TKgetNray
        INTEGER*4 TKgetNsweep
	INTEGER*4 TKwriteDBRainInfo
	INTEGER*4 TKwriteGauge
	INTEGER*4 TKwriteNetHeader
        INTEGER*4 TKcopyScanHeader

/*
	=====================================
	  	FORTRAN prototypes
	  of Toolkit wrapper functions in C
	           for TKutilGV.c
	=====================================
*/
	INTEGER*4 TKreadL1GVparam
	INTEGER*4 TKreadL1GV1byteParam

	INTEGER*4 TKreadL1GVbaseSweep
	INTEGER*4 TKpickL1GVvosNum
	INTEGER*4 TKreadL1GVdate

	INTEGER*4 TKreadL1GVsummary
	INTEGER*4 TKprintL1GVsummary

#endif

#endif
