/* DEVELOPMENT HISTORY */
/* Revision 1.3  1999/10/12 20:05:38  slywczak
 * Added the compiler directive around stdio.h so that it would interpret when
 * compiling FORTRAN programs.
 *
 * Revision 1.2  1995/09/18 14:28:27  thyun
 * Defined TK_E5_ETOPOFILE.
 *
 * Revision 1.1  1995/09/06  14:11:03  dbazell
 * adding etopo5 header file
 *
 */

/**********************************************************************
 * FILE NAME:     landsea.h
 *
 * DESCRIPTION:   Include file for landsea routines.  Contains several
 *                Constants used by the routine.
 *
 **********************************************************************/

#ifndef __LANDSEA_H
#define __LANDSEA_H 1

#ifndef LANGUAGE_FORTRAN
#include <stdio.h>
#include <stdlib.h>
#endif

/* Dimensions of the the data file */
#define TK_E5_COLS 4320
#define TK_E5_ROWS 2160

/* Parameters of the data file */
#define TK_E5_LATMIN -90
#define TK_E5_LATMAX 90
#define TK_E5_DLAT (1./12.)
#define TK_E5_LONMIN 0
#define TK_E5_LONMAX 360
#define TK_E5_DLON (1./12.)
#define TK_E5_ETOPOFILE "/data/etop05.dat"

/* Maximum path length to the data file */
#define TK_PATHLEN 100

#endif
