/*Revision 1.11  1997/05/14 19:19:52  slywczak
 *Changed the prototypes for the following routines:  manageFiles and
 *checkAllFiles.  Changed the sHandle element from an IO_HANDLE * to an
 *IO_HANDLE **.  The sHandle element was changed from void to IO_HANDLE.
 *
 *Revision 1.10  1996/11/01 20:52:47  amak
 *Defined macros DELETE_FILE & DELETE_ALL_LISTS.
 *Defined function prototypes deleteList and deleteAllLists.
 *Re-defined function prototypes manageFiles and addFile
 * - both added one more parameter to API
 *
 * Revision 1.9  1995/11/15  23:28:52  thyun
 * Inserted prototyp of getConfigFilenameAndScanline.
 *
 * Revision 1.8  1995/08/29  15:01:39  amak
 * Modified the preprocessor statements.
 *
 * Revision 1.7  1995/08/15  21:17:09  thyun
 * Added file header comments.
 *
 * Revision 1.6  1995/08/03  17:46:04  amak
 * Re-modified the code because CVS couldn't do version control nicely.
 *
 * Revision 1.5  1995/07/20  20:25:06  thyun
 * Changed the type of pGranuleHandle to IO_HANDLE to avoid address conflict
 * between c and fortran interface.
 *
 * Revision 1.4  1995/07/19  20:09:44  thyun
 * Changed the type of the field pGranuleHandle to int32 in the structure
 * FILE_PTR.
 *
 * Revision 1.3  1995/07/18  14:38:41  amak
 * Corrected typo errors in comment block.
 *
 * Revision 1.2  1995/07/05  17:12:07  thyun
 * Modified commets
 *
 * Revision 1.1  1995/06/30  17:37:41  thyun
 * adding file
 **/

/********************************************************************************
*
*  FILE NAME:	file_manager.h
*
*  DESCRIPTION:	This program contains the prototypes of routines which manage HDF
*		files being opened.
*
*******************************************************************************/

#ifndef __FILE_MANAGER_H
#define __FILE_MANAGER_H 1

#include <stdio.h>
#include "IO.h"

#define ADD_FILE		-1
#define DELETE_FILE	 	1
#define DELETE_ALL_FILES	2
#define CHECK_FILE_STATUS	3
#define DELETE_LIST		4
#define DELETE_ALL_LISTS	5

/********************************************************************************/
/* This structure is used to create a link list.  Each element of the link list */
/* is type of FILE_NODE.							*/
/********************************************************************************/

typedef struct FILE_NODE
{ 
   IO_HANDLE pGranuleHandle;
   struct FILE_NODE *next;
}  FILE_PTR; 


void  initializeFile(FILE_PTR **files);

int   manageFiles(IO_HANDLE *sGranuleHandle, IO_HANDLE **sHandle, int opType); 

int   addFile(IO_HANDLE *sGranuleHandle, FILE_PTR **file, FILE_PTR **ckList);

void  deleteAllFiles(FILE_PTR **files); 

int   deleteFile(IO_HANDLE *sGranuleHandle, FILE_PTR **file);

int32 getConfigFilenameAndScanline(int32 productID, char *fileName);

int checkAllFiles(IO_HANDLE *sGranuleHandle, IO_HANDLE **sHandle, 
			FILE_PTR **fileList, FILE_PTR **ckList);

void deleteList(FILE_PTR **ckList);
void deleteAllLists(FILE_PTR **ckList);

#endif
