/* Development History */
/* Revision 1.4  1999/10/12 20:04:49  slywczak
 * Added the compiler directive around stdio.h so that it would interpret when
 * compiling FORTRAN programs.
 *
 * Revision 1.3  1995/08/29 21:58:27  dbazell
 * added stdlib.h and TK_LS_PATHLEN
 *
 * Revision 1.2  1995/08/29 15:01:40  amak
 * Modified the preprocessor statements.
 *
 * Revision 1.1  1995/08/23  14:31:08  dbazell
 * Initial Version
 *
 */ 
/**********************************************************************
 * FILE NAME:     landsea.h
 *
 * DESCRIPTION:   Include file for landsea routines.  Contains several
 *                Constants used by the routine.
 *
 **********************************************************************/

#ifndef __LANDSEA_H
#define __LANDSEA_H 1

#ifndef LANGUAGE_FORTRAN
#include <stdio.h>
#include <stdlib.h>
#endif
/* Return values for routine TKreadlsm.  Values 1,2,3 are not used
 * for historical reasons
 */
#define TK_LAND   0   /* Land */
#define TK_ICE    4   /* Possible pack ice */
#define TK_OCEAN  5   /* Ocean */
#define TK_COAST  6   /* Coast */
#define TK_CICE   7   /* coast next to ice */

/* Set the array dimensions */
/* Number of 4 byte fields in the input data file */
#define TK_LS_FLDS 259200

/* Total bytes in the input data file (4*TK_LS_FLDS) */
#define TK_LS_ARRAY 1036800

/* Maximum length of complete path to dbglob93.grd */
#define TK_LS_PATHLEN 100

#endif
