/* DEVELOPMENT HISTORY */
/* Revision 1.45  1999/11/23 20:21:49  slywczak
 * Modified the function tkreadl1gvparm_, tkreadl1gv1byteparm_, and
 * tkreadl1gvbasesweep_.  The FORTRAN wrappers were not reformatting the string
 * for parameter name to handle the differences between string handling in
 * FORTRAN and C.
 *
 * Revision 1.44  1999/10/12 20:02:33  slywczak
 * Added routines tkreadlsm_ and tkreadtopo_.  These routines are wrapper routines
 * for the eqivalent C functions.
 *
 * Revision 1.43  1999/10/05 21:51:04  pkolbe
 * added fortran wrapper for TKgetAlgorithmID
 *
 * Revision 1.42  1997/11/13 16:05:13  slywczak
 * Changed the datatype in tkpickgvvos from int32 to int.
 *
 * Revision 1.41  1997/10/14 21:12:42  okelley
 * 	Modifications to the Toolkit to implement new
 * 	GV utilities.
 *
 * Revision 1.40  1997/06/23 22:11:06  slywczak
 * Modified the function tkwritedbraininfo_.  Update the function parameters
 * based on the prototype.
 *
 * Revision 1.39  1997/05/30 18:52:03  slywczak
 * Added the following wrapper routines:  TKqueryGVCoincidenceInfo,
 * TKreadNetHeader, and TKreadGauge.
 *
 * Revision 1.38  1997/03/06 03:33:43  slywczak
 * Added routines tkcopyscanheader_ (SUN & SGI) and tkcopyscanheader (HP).
 * Added the wrapper routines for the TKcopyScanHeader function.  Included
 * where the wrapper routine for the SUN, SGI, and HP.
 *
 * Revision 1.37  1996/12/24 14:30:57  amak
 * Incorporated walkthrough comments.
 * - Changed '<' and '>' to double quotes around the #include statements.
 *
 * Revision 1.36  1996/11/07  18:57:42  amak
 * Added prologue.
 *
 * Revision 1.35  1996/11/07  17:33:09  amak
 * Fixed syntax and typo error for routines tkwritemetadatachar(),
 * tkwritemetadatainc(), tkwritemetadatafloat(), tkreadmetadatachar(),
 * tkreadmetadatainc(), and tkreadmetadatafloat().
 *
 * Revision 1.34  1996/11/05  15:11:05  dbazell
 * Added check for end of string in metadataChar routines
 *
 * Revision 1.33  1996/11/01  20:36:11  amak
 * Added routines tkwritedbraininfo_() and tkwritedbraininfo() for Fortran-C
 * interface.
 *
 * Revision 1.32  1996/09/03  20:16:59  amak
 * Added new functions tkwritegauge_(), tkwritenetheader_(), tkwritegauge(),
 * and tkwritenetheader() for Fortran-to-C interface.
 *
 * Revision 1.31  1996/07/10  17:45:31  dbazell
 * Simplified the wrapper routines.  Eliminated need for the C version of
 * WRAPPER_HANDLE.  Eliminated the need for copying data between
 * WRAPPER_HANDLE and IO_HANDLE.  Modified the conversion of a fortran
 * string to a C string.  Added arguments that receive the length of
 * character strings to wrapper routines when a character string is
 * passed as an argument.
 *
 * Revision 1.30  1996/06/19  14:25:39  amak
 * Modified routines.  coreMetadataID and psMetadataID are obsolete.
 *
 * Revision 1.29  1996/06/18  14:22:19  dbazell
 * delelted cpmetadataID from wrapper functions.  This is obsolete.
 *
 * Revision 1.28  1996/06/18  13:37:55  dbazell
 * committed latest changes.
 *
 * Revision 1.27  1996/06/17  19:19:08  dbazell
 * added copy gidtokens to tkclose.
 *
 * Revision 1.26  1996/06/17  18:52:37  dbazell
 * Added copy gidtokens to tkopen
 *
 * Revision 1.25  1996/06/13  21:27:22  amak
 * Added Fortran-to-C interface for TKreadHeader and TKwriteHeader routines.
 *
 * Revision 1.24  1996/05/21  18:02:26  amak
 * Added TKreportError and TKreportWarning Fortran interface.
 *
 * Revision 1.23  1996/04/19  15:40:50  amak
 * Made modifications to the preprocessor #include statement.  Replaced
 * TKerrorRou.h and TKwarnRou.h to TKerrHandle.h and TS_TK_15.h for new
 * error handling calls.
 *
 * Revision 1.22  1996/03/21  22:01:47  amak
 * Added prologue.
 *
 * Revision 1.21  1996/03/04  19:18:38  amak
 * Made numerous modifications based on the new changes of the metadata
 * data structure.
 *
 * Revision 1.20  1995/12/15  15:18:55  thyun
 * Removed tksetl1gvtemplate_ and tksetl1gvtemplate.
 *
 * Revision 1.19  1995/12/13  23:01:28  thyun
 * Modified TKopen, TKreadGrid, and TKwriteGrid.
 * Removed main().
 *
 * Revision 1.18  1995/12/12  15:04:12  amak
 * Renamed functions tkgetnumofvos() and tkgetnumofsensor() to tkgetnvos() and
 * tkgetnsensor() for the naming consistency to the other routines.
 *
 * Revision 1.17  1995/12/06  18:04:56  amak
 * Took out Fortran to C interface for Coincidence.
 *
 * Revision 1.16  1995/12/05  22:06:12  thyun
 * Created the procedure cpMetadata, and modified any wrapper functions
 * which are related to metadata.
 *
 * Revision 1.15  1995/12/01  14:58:27  thyun
 * Modified some of the prolog.
 *
 * Revision 1.14  1995/11/30  21:08:47  amak
 * Added TKgetCoincidence() Fortran wrapper for HP, SUN and SGI platforms.
 *
 * Revision 1.13  1995/11/29  23:07:56  thyun
 * Updated all the routines due to the changes in IO_HANDLE and WRAPPER_HANDLE.
 * Modified the prolog comments for all the routines.  Finally, modified all
 * the routines to return value correctly.
 *
 * Revision 1.12  1995/11/22  20:13:25  thyun
 * Inserted wrappers for tkwritel1gv_, tkreadl1gv_, tkcopyheader_, tksetl1gvtemplate_,
 * setl1gvtemplate_, tkgetnvos_, tkgetnsensor_, tkgetncell_, tkgetnray_,
 * and tkgetNsweep_
 *
 * Revision 1.11  1995/10/18  14:32:36  amak
 * Added comments on prolog.
 *
 * Revision 1.10  1995/10/17  19:59:43  amak
 * Combined files wrapHP.c, wrapSunSgi.c, and TKfortranMain.c as this
 * single file.  Added preprocessor statements to limit the use of 
 * certain routines on different platforms.
 * */

/*******************************************************************************
*
*  FILE NAME:           wrapper.c
*
*  DESCRIPTION:         Fortran & C wrapper.  This program provides routines that
*			act as intermediate medium interface for Fortran to C programs.
*
*  ROUTINES CALLED:	
*       Routine Name            Description
*       ------------            -----------
*	tkopen_			This routine is used to call TKopen with
*				appropriate arguments.  This routine will only be
*				called when compiling on the SUN and SGI platforms.
*	tkreadscan_		This routine is used to call TKreadScan with
*				appropriate arguments.  This routine will only be
*				called when compiling on the SUN and SGI platforms.
*	tkwritescan_		This routine is used to call TKwriteScan with
*				appropriate arguments.  This routine will only be
*				called when compiling on the SUN and SGI platforms.
*	tkclose_		This routine is used to call TKclose with
*				appropriate arguments.  This routine will only be
*				called when compiling on the SUN and SGI platforms.
*	tkseek_			This routine is used to call TKseek in C toolkit 
*				programs.  This routine will only be called when
*				compiling on the SUN and SGI platforms.
*       tkcopyscanheader_       This routine is the wrapper for the C version of 
*                               TKcopyScanHeader (TKcopyScanHeadr.c).  This function
*                               will only be compiled on the SUN and SGI platforms.
*	tkendoffile_		This routine is used to call TKendOfFile in C toolkit
*				programs.
*	tkreadl1gv_		This routine is used to call TKreadL1GV in c toolkit
*				programs.
*	tkwritel1gv_		This routine is used to call TKwriteL1GV in c toolkit
*				programs.
*	tkgetnvos_		his routine is used to call TKgetNvos in C toolkit
*				programs.
*	tkgetnsensor_		This routine is used to call TKgetNsensor in C 
*				toolkit programs.
*	tkgetnparm_		This routine is used to call TKgetNparm in C 
*				toolkit programs.
*	tkgetncell_		This routine is used to call TKgetNcell in C toolkit
*				programs.
*	tkgetnray_		This routine is used to call TKgetNray in C toolkit
*				programs.
*	tkgetnsweep_		This routine is used to call TKgetNsweep in C toolkit
*				programs.
*	main			main() is a dummy declaration for fortran part 
*				of interface.  Since fortran does not have a way 
*				of defining main(), this routines has to be declared 
*				to create a executable file.  This routine will on be
*				called when compiling on the HP platform.
*	tkopen			This routine is used to call TKopen with
*				appropriate arguments.  This routine will only be 
*				called when compiling on the HP platform.
*	tkreadscan		This routine is used to call TKreadScan with
*				appropriate arguments.  This routine will only be
*				called when compiling on the HP platform.
*	tkwritescan		This routine is used to call TKwriteScan with
*				appropriate arguments.  This routine will only be
*				called when compiling on the HP platform.
*	tkclose			This routine is used to call TKclose with
*				appropriate arguments.  This routine will only be
*				called when compiling on the HP platform.
*	tkseek			This routine is used to call TKseek in C toolkit 
*				programs.  This routine will only be called when
*				compiling on the HP platform.
*

    For TKutilGV.c

	tkreadl1gvparam_
	tkreadl1gvparam

	tkreadl1gv1byteparam_
	tkreadl1gv1byteparam

	tkreadl1gvbasesweep_
	tkreadl1gvbasesweep

	tkpickl1gvvosnum_
	tkpickl1gvvosnum

	tkreadl1gvdate_
	tkreadl1gvdate

	tkreadl1gvsummary_
	tkreadl1gvsummary

	tkprintl1gvsummary_
	tkprintl1gvsummary

******************************************************************************/

#include <hdf.h>
#include "IO.h"
#include "IO_GV.h"
#include "TKerrHandle.h"

#include "TS_TK_15.h"

#ifndef HP9000
/**
 **	Using FORTRAN interface for SGI, SUN SOLARIS 2.4, and
 **	SUN O/S 4.1.3 machine.
 **/
/************************************************************************
*
*  FUNCTION STATEMENT:
* 	tkopen_(char *granuleID, int *dataType, char *fileMode,
*		IO_HANDLE *sGranuleHandle, int n1, int n2)
*
*  DESCRIPTION:
*       This routine is used to call TKopen in C toolkit programs.
*	This routine will only be called when compiling on the SUN and
*	SGI platforms.
*
*  INPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*	granuleID		Name of HDF file.
*	dataType		Product type.
*	filemode		File access mode
*
*  OUTPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*	sGranuleHandle		A structure passed to subsequent I/O routines.
*                               This structure is initialized by TKopen().
*
*       n1, n2                  These are the lengths of the strings
*                               granuleID and filemode.  The values are
*                               added automatically by the compiler
*
*  CALLED BY:  			main program from Fortran. 
*
*  RETURN VALUES:               TK_SUCCESS if TKopen is successful.
*                               TK_FAIL if TKopen is failed.
*
*  ROUTINES CALLED:     	
*	TKopen()
*
******************************************************************************/
int tkopen_(char *granuleID, int *dataType, char *fileMode, 
		IO_HANDLE *sGranuleHandle, int n1, int n2)
{  
  static int status;
  int i = 0;

  /* search for first whitespace in granuleID and put EOS there */
  while( !isspace(granuleID[i]) && (i<n1))
    i++;
  granuleID[i] = '\0';

  status = TKopen(granuleID, *dataType, fileMode[0], sGranuleHandle);

  return (status);
}


int tkgetalgorithmid_(char *granuleID , int n1)
{
  static int alg_id;
  int i = 0;

  /* search for first whitespace in granuleID and put EOS there */
  while( !isspace(granuleID[i]) && (i<n1))
    i++;
  granuleID[i] = '\0';

  alg_id = TKgetAlgorithmID(granuleID);

  return (alg_id);
}


/*****************************************************************************
*
*  FUNCTION STATEMENT:
*	tkreadscan_(IO_HANDLE *sGranuleHandle, void *sSwathData)
*
*  DESCRIPTION:
*       This routine is used to call TKreadScan in C toolkit programs.
*       This routine will only be called when compiling on the SUN and
*       SGI platforms.
*
*  INPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       sGranuleHandle		A structure containing information about the file
*                               from which data can be obtained.
*
*  OUTPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       sSwathData		A structure containing the complete scanline data
*                               which is obtained from the input file.  This
*                               structure must be declared to correspond to the
*                               data file being read.  The structure of sSwathData
*                               is manipulated by TKreadScan() and other toolkit
*                               routines.
*
*  CALLED BY:			main program from Fortran
*
*  RETURN VALUES:               TK_SUCCESS if TKreadScan is successful.
*                               TK_FAIL if TKreadScan is failed.
*
*  ROUTINES CALLED:     
*	TKreadScan()
*
******************************************************************************/

int tkreadscan_(IO_HANDLE *sGranuleHandle, void *sSwathData)
{
  static int status;

  status = TKreadScan(sGranuleHandle, sSwathData);

  return (status);
}


/*****************************************************************************
*
*  FUNCTION STATEMENT:
*	tkreadlsm_(float lat, float lon)
*
*  DESCRIPTION:
*       This routine is used to call TKreadlsm in FORTRAN toolkit programs.
*       This routine will only be called when compiling on the SUN and
*       SGI platforms.
*
*  INPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       lat 			The latitude value.
*	lon			The longitude value.
*
*  OUTPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*
*  CALLED BY:			main program from Fortran
*
*  RETURN VALUES:               The appropriate values to indicate the location
*				the value is on the earth.
*
*  ROUTINES CALLED:     
*	TKreadlsm()
*
******************************************************************************/

int32 tkreadlsm_(float lat, float lon)
{
  int32 status;

  status = TKreadlsm(lat, lon);

  return ((int32) status);
}


/*****************************************************************************
*
*  FUNCTION STATEMENT:
*	tkreadtopo_(float lat, float lon)
*
*  DESCRIPTION:
*       This routine is used to call TKreadTopo in FORTRAN toolkit programs.
*       This routine will only be called when compiling on the SUN and
*       SGI platforms.
*
*  INPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       lat 			The latitude value.
*	lon			The longitude value.
*
*  OUTPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*
*  CALLED BY:			main program from Fortran
*
*  RETURN VALUES:               The appropriate values to indicate the 
*				elevation value is on the earth.
*
*  ROUTINES CALLED:     
*	TKreadTopo()
*
******************************************************************************/

int16 tkreadtopo_(float lat, float lon)
{
  int16 status;

  status = TKreadTopo(lat, lon);
 
  return ((int16) status);
}

/*****************************************************************************
*
*  FUNCTION STATEMENT:
*       tkwritescan_(IO_HANDLE *sGranuleHandle, void *sSwathData)
*
*  DESCRIPTION:
*       This routine is used to call TKwriteScan in C toolkit programs.
*       This routine will only be called when compiling on the SUN and
*       SGI platforms.
*
*  INPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       sGranuleHandle		A structure containing information about the file
*                               from which data can be obtained. 
*	sSwathData		A structure containing the complete scanline data
*                               which is to be written to the output file.  This
*                               structure must be declared to correspond to the
*                               data file being written.  The structure of sScanData
*                               is manipulated by TKwriteScan() and other toolkit
*                               routines.
*
*  OUTPUT PARAMETERS:		None
*
*  RETURN VALUES:               TK_SUCCESS if TKwriteScan is successful.
*                               TK_FAIL if TKwriteScan is failed.
*
*  CALLED BY:			Main program from Fortran.
*
*  ROUTINES CALLED:     	TKwriteScan()
*
******************************************************************************/

int tkwritescan_(IO_HANDLE *sGranuleHandle, void *sSwathData)
{
  static int status;

  status = TKwriteScan(sGranuleHandle, sSwathData);

  return (status);
}


/*****************************************************************************
*
*  FUNCTION STATEMENT:
*       tkcopyscanheader_(IO_HANDLE *sInGranuleHandle, void *sInDataHandle,
*                         IO_HANDLE *sOutGranuleHandle, void *sOutDataHandle)
*
*  DESCRIPTION:
*       This routine is used to call the C version of TKcopyScanHeader.
*       This routine will only be called when compiling on the SUN and
*       SGI platforms.
*
*  INPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       sInGranuleHandle	A structure containing information about the file
*                               from which data can be obtained. 
*	sInDataHandle		A structure containing the complete data buffer
*                               from which the scan header is copied.
*
*  OUTPUT PARAMETERS:		
*       Parameter Name          Description
*       --------------          -----------
*       sOutGranuleHandle	A structure containing information about the file
*                               from which data can be obtained. 
*	sOutDataHandle		A structure containing the complete data buffer
*                               to which the scan header is copied.
*
*  RETURN VALUES:               TK_SUCCESS if TKcopyScanHeader is successful.
*                               TK_FAIL if TKcopyScanHeader is failed.
*
*  CALLED BY:			Main program from Fortran.
*
*  ROUTINES CALLED:     	TKcopyScanHeader()
*
******************************************************************************/

int tkcopyscanheader_ (IO_HANDLE *sInGranuleHandle, void *sInDataHandle,
		       IO_HANDLE *sOutGranuleHandle, void *sOutDataHandle)
{
  static int status;

  status = TKcopyScanHeader ( sInGranuleHandle, sInDataHandle, 
			     sOutGranuleHandle, sOutDataHandle );

  return ( status );
}

/*****************************************************************************
*
*  FUNCTION STATEMENT:
*	tkwritegrid_(IO_HANDLE *sGranuleHandle, void *sGrid)
*
*  DESCRIPTION:
*       This routine is used to call TKwriteGrid in C toolkit programs.
*       This routine will only be called when compiling on the SUN and
*       SGI platforms.
*
*  INPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       sGranuleHandle         A structure containing information about the file
*                               from which data can be obtained.
*       sGrid		        A structure containing the complete grid data
*                               which is obtained from the input file.  This
*                               structure must be declared to correspond to the
*                               data file being read.  The structure of sGrid
*                               is manipulated by TKreadGrid() and other toolkit
*                               routines.
*
*  OUTPUT PARAMETERS:		None
*
*  CALLED BY: 			main program from Fortran
*
*  RETURN VALUES:               TK_SUCCESS if TKrwriteGrid is successful.
*                               TK_FAIL if TKwriteGrid is failed.
*
*  ROUTINES CALLED:     	TKwriteGrid()
*
******************************************************************************/

int tkwritegrid_(IO_HANDLE *sGranuleHandle, void *sGrid)
{
  static int status;

  status = TKwriteGrid(sGranuleHandle, sGrid);

  return (status);
}




/*****************************************************************************
*
*  FUNCTION STATEMENT:
*       tkreadGrid_(IO_HANDLE *sGranuleHandle, void *sGrid)
*
*  DESCRIPTION:
*       This routine is used to call TKreadGrid in C toolkit programs.
*       This routine will only be called when compiling on the SUN and
*       SGI platforms.
*
*  INPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       sGranuleHandle         A structure containing information about the file
*                               from which data can be obtained.
*
*  OUTPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       sGrid	                A structure containing the complete grid data
*                               which is obtained from the input file.  This
*                               structure must be declared to correspond to the
*                               data file being read.  The structure of sGrid
*                               is manipulated by TKreadGrid() and other toolkit
*                               routines.
*
*  CALLED BY: 			main program from Fortran 
*
*  RETURN VALUES:               TK_SUCCESS if TKreadGrid is successful.
*                               TK_FAIL if TKreadGrid is failed.
*
*  ROUTINES CALLED:     	TKreadGrid()
*
******************************************************************************/

int tkreadgrid_(IO_HANDLE *sGranuleHandle, void *sGrid)
{
  static int status;

  status = TKreadGrid(sGranuleHandle, sGrid);

  return (status);
}

/*****************************************************************************
*
*  FUNCTION STATEMENT:
*       tkwriteheader_(IO_HANDLE *sGranuleHandle, void *sHeader)
*
*  DESCRIPTION:
*       This routine is used to call TKwriteHeader in C toolkit programs.
*       This routine will only be called when compiling on the SUN and
*       SGI platforms.
*
*  INPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       sGranuleHandle         A structure containing information about the file
*                               from which data can be obtained.
*       sHeader                 A structure containing the complete header info
*				for either L1B21, L1C21, or L2A25 which obtained 
*				from the input file.  This structure must be 
*				declared to correspond to the data file being read.  
*				The structure of sHeader is manipulated by 
*				TKreadHeader() and other toolkit routines.
*
*  OUTPUT PARAMETERS:           None
*
*  CALLED BY:                   main program from Fortran
*
*  RETURN VALUES:               TK_SUCCESS if TKrwriteHeader is successful.
*                               W_TK_BADPIDWH or W_TK_BADFILEMODEWH 
*				if TKwriteHeader is failed.
*
*  ROUTINES CALLED:             TKwriteHeader()
*
******************************************************************************/

int tkwriteheader_(IO_HANDLE *sGranuleHandle, void *sHeader)
{
  static int status;

  status = TKwriteHeader(sGranuleHandle, sHeader);

  return (status);
}


/*****************************************************************************
*
*  FUNCTION STATEMENT:
*       tkreadheader_(IO_HANDLE *sGranuleHandle, void *sHeader)
*
*  DESCRIPTION:
*       This routine is used to call TKreadHeader in C toolkit programs.
*       This routine will only be called when compiling on the SUN and
*       SGI platforms.
*
*  INPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       sGranuleHandle         A structure containing information about the file
*                               from which data can be obtained.
*
*  OUTPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       sHeader                 A structure containing the complete header info
*				for either L1B21, L1C21, or L2A25 which 
*				obtained from the input file.  This
*                               structure must be declared to correspond to the
*                               data file being read.  The structure of sHeader
*                               is manipulated by TKreadHeader() and other toolkit
*                               routines.
*
*  CALLED BY:                   main program from Fortran 
*
*  RETURN VALUES:               TK_SUCCESS if TKreadHeader is successful.
*                               W_TK_BADPIDRH or W_TK_BADFILEMODERH 
*				if TKreadHeader is failed.
*
*  ROUTINES CALLED:             TKreadHeader()
*
******************************************************************************/

int tkreadheader_(IO_HANDLE *sGranuleHandle, void *sHeader)
{
  static int status;

  status = TKreadHeader(sGranuleHandle, sHeader);

  return (status);
}


/*****************************************************************************
*
*  FUNCTION STATEMENT:
*       tkwritel1gv_(IO_HANDLE *sGranuleHandle, void *sGV)
*
*  DESCRIPTION:
*	This routines is used to call TKwriteL1GV in c toolkit program.
*       This routine will only be called when compiling on the SUN and
*       SGI platforms.
*
*  INPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       sGranuleHandle         A structure containing information about the file
*                               from which data can be obtained.
*       sGV	                A structure containing the complete L1 GV data
*                               which is obtained from the input file.  This
*                               structure must be declared to correspond to the
*                               data file being read.  The structure of sGrid
*                               is manipulated by TKwriteL1GV() and other toolkit
*                               routines.
*
*  OUTPUT PARAMETERS:		None.
*
*  CALLED BY:   		main program from Fortran
*
*  RETURN VALUES:               TK_SUCCESS if TKwriteL1GV is successful.
*                               TK_FAIL if TKwriteL1GV is failed.
*
*  ROUTINES CALLED:             TKwriteL1GV()
*
******************************************************************************/

int tkwritel1gv_(IO_HANDLE *sGranuleHandle, void *sGV)
{
  static int status;

  status = TKwriteL1GV(sGranuleHandle, sGV);

  return (status);
}



/*****************************************************************************
*
*  FUNCTION STATEMENT:
*       tkreadl1gv_(IO_HANDLE *sGranuleHandle, void *sGV)
*
*  DESCRIPTION:
*	This routine is used to call TKreadL1GV in c toolkit programs.
*       This routine will only be called when compiling on the SUN and
*       SGI platforms.
*
*  INPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       sGranuleHandle         A structure containing information about the file
*                               from which data can be obtained.
*
*  OUTPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       sGV                     A structure containing the complete L1 GV data
*                               which is obtained from the input file.  This
*                               structure must be declared to correspond to the
*                               data file being read.  The structure of sGrid
*                               is manipulated by TKreadL1GV() and other toolkit
*                               routines.
*
*  CALLED BY:  			main program from Fortran
*
*  RETURN VALUES:               TK_SUCCESS if TKreadL1GV is successful.
*                               TK_FAIL if TKreadL1GV is failed.
*
*  ROUTINES CALLED:             TKreadL1GV()
*
******************************************************************************/

int tkreadl1gv_(IO_HANDLE *sGranuleHandle, void *sGV)
{
  static int status;

  status = TKreadL1GV(sGranuleHandle, sGV);

  return (status);
}


/*****************************************************************************
*
*  FUNCTION STATEMENT:
*	tkreadmetadataint_(IO_HANDLE *sGranuleHandle,  int *parameter,
*                          void *value)
*
*  DESCRIPTION:
*       This routine is used to call TKreadMetadataInt in C toolkit programs.
*       This routine will only be called when compiling on the SUN and
*       SGI platforms.
*
*  INPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       sGranuleHandle         Structure containing information about the file
*                               which is to be closed.  sGranuleHandle is returned
*                               by TKopen().
*	parameter		Description of value to be read.
*
*  OUTPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       value			Value of the parameter.
*
*  CALLED BY:  			main program from Fortran
*
*  RETURN VALUES:               TK_SUCCESS if TKreadMetadataInt is successful.
*                               TK_FAIL if TKreadMetadataInt is failed.
*
*  ROUTINES CALLED:             
*	TKreadMetadataInt(), cpCoreMetadata(), cpPSMetadata()
*
******************************************************************************/
int tkreadmetadataint_(IO_HANDLE *sGranuleHandle, int *parameter, void *value)
{
  static int status;
  int i = 0;

  status = TKreadMetadataInt(sGranuleHandle, *parameter, value);

  return (status);
}


/*****************************************************************************
*
*  FUNCTION STATEMENT:
*       tkreadmetadatafloat_(IO_HANDLE *sGranuleHandle,  int *parameter,
*                            float *value)
*
*  DESCRIPTION:
*       This routine is used to call TKreadMetadataFloat in C toolkit programs.
*       This routine will only be called when compiling on the SUN and
*       SGI platforms.
*
*  INPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       sGranuleHandle         Structure containing information about the file
*                               which is to be closed.  sGranuleHandle is returned
*                               by TKopen().
*       parameter               Description of value to be read.
*
*  OUTPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       value                   Value of the parameter.
*
*  CALLED BY: 			main program from Fortran
*
*  RETURN VALUES:               TK_SUCCESS if TKreadMetadataFloa is successful.
*                               TK_FAIL if TKreadMetadataFloa is failed.
*
*  ROUTINES CALLED:             
*	TKreadMetadataFloat(), cpCoreMetadata(), cpPSMetadata()
*
******************************************************************************/
int tkreadmetadatafloat_(IO_HANDLE *sGranuleHandle, int *parameter, float *value)
{
  static int status;
  int i = 0;

  status = TKreadMetadataFloat(sGranuleHandle, *parameter, value);

  return (status);
}


/*****************************************************************************
*
*  FUNCTION STATEMENT:
*       tkreadmetadatachar_(IO_HANDLE *sGranuleHandle,  int *parameter,
*                           char *value, int n1)
*
*  DESCRIPTION:
*       This routine is used to call TKreadMetadataChar in C toolkit programs.
*       This routine will only be called when compiling on the SUN and
*       SGI platforms.
*
*  INPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       sGranuleHandle         Structure containing information about the file
*                               which is to be closed.  sGranuleHandle is returned
*                               by TKopen().
*       parameter               Description of value to be read.
*
*       n1                      Length of the value string.  The value of n1 is
*                               filled automatically by the compiler.
*
*  OUTPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       value                   Value of the parameter.
*
*  CALLED BY: 			main program from Fortran 
*
*  RETURN VALUES:               TK_SUCCESS if TKreadMetadataChar is successful.
*                               TK_FAIL if TKreadMetadataChar is failed.
*
*  ROUTINES CALLED:             
*	TKreadMetadataChar(), cpCoreMetadata(), cpPSMetadata()
*
******************************************************************************/
int tkreadmetadatachar_(IO_HANDLE *sGranuleHandle, int *parameter, 
			char *value, int n1)
{
  static int status;
  int i;

  /* search from the end of the value string looking for first 
   * non-whitespace.  Terminate the string with a null
   */
  i = n1-1;  /* value[n1]=\0 so skip it */
  while( (isspace(value[i]) || value[i]=='\"') && i > 0)
    value[i--]='\0';

  status = TKreadMetadataChar(sGranuleHandle, *parameter, value);

  return (status);
}


/*****************************************************************************
*
*  FUNCTION STATEMENT:
*       tkwritemetadataint_(IO_HANDLE *sGranuleHandle,  int *parameter,
*                          void *value)
*
*  DESCRIPTION:
*       This routine is used to call TKwriteMetadataInt in C toolkit programs.
*       This routine will only be called when compiling on the SUN and
*       SGI platforms.
*
*  INPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       sGranuleHandle         Structure containing information about the file
*                               which is to be closed.  sGranuleHandle is returned
*                               by TKopen().
*       parameter               Description of value to be read.
*	value			Value to be written in metadata using parameter.
*
*  OUTPUT PARAMETERS:		None
*
*  CALLED BY:  			main program from Fortran 
*
*  RETURN VALUES:               TK_SUCCESS if TKwriteMetadataInt is successful.
*                               TK_FAIL if TKwriteMetadataInt is failed.
*
*  ROUTINES CALLED:             
*	TKwriteMetadataInt(), cpCoreMetadata(), cpPSMetadata()
*
******************************************************************************/
int tkwritemetadataint_(IO_HANDLE *sGranuleHandle, int *parameter, void *value)
{
  static int status;
  int i = 0;

  status = TKwriteMetadataInt(sGranuleHandle, *parameter, value);

  return (status);
}


/*****************************************************************************
*
*  FUNCTION STATEMENT:
*       tkwritemetadatafloat_(IO_HANDLE *sGranuleHandle, int *parameter,
*                             float *value)
*
*  DESCRIPTION:
*       This routine is used to call TKwriteMetadataFloat in C toolkit programs.
*       This routine will only be called when compiling on the SUN and
*       SGI platforms.
*
*  INPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       sGranuleHandle         Structure containing information about the file
*                               which is to be closed.  sGranuleHandle is returned
*                               by TKopen().
*       parameter               Description of value to be read.
*       value                   Value to be written in metadata using parameter.
*
*  OUTPUT PARAMETERS:           None
*
*  CALLED BY:  			main program from Fortran
*
*  RETURN VALUES:               TK_SUCCESS if TKwriteMetadataFloat is successful.
*                               TK_FAIL if TKwriteMetadataFloat is failed.
*
*  ROUTINES CALLED:             
*	TKwriteMetadataFloat(), cpCoreMetadata(), cpPSMetadata()
*
******************************************************************************/

int tkwritemetadatafloat_(IO_HANDLE *sGranuleHandle, int *parameter, float *value)
{
  static int status;
  int i = 0;

  status = TKwriteMetadataFloat(sGranuleHandle, *parameter, value);

  return (status);
}


/*****************************************************************************
*
*  FUNCTION STATEMENT:
*       tkwritemetadatachar_(IO_HANDLE *sGranuleHandle,  int *parameter,
*                            char *value, int n1)
*
*  DESCRIPTION:
*       This routine is used to call TKwriteMetadataChar in C toolkit programs.
*       This routine will only be called when compiling on the SUN and
*       SGI platforms.
*
*  INPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       sGranuleHandle         Structure containing information about the file
*                               which is to be closed.  sGranuleHandle is returned
*                               by TKopen().
*       parameter               Description of value to be read.
*       value                   Value to be written in metadata using parameter.
*
*       n1                      The length of the value string.  The value of n1
*                               is filled automatically by the compiler
*
*  OUTPUT PARAMETERS:           None
*
*  CALLED BY:  			main program from Fortran
*
*  RETURN VALUES:               TK_SUCCESS if TKwriteMetadataChar is successful.
*                               TK_FAIL if TKwriteMetadataChar is failed.
*
*  ROUTINES CALLED:             
*	TKwriteMetadataChar(), cpCoreMetadata(), cpPSMetadata()
*
******************************************************************************/
int tkwritemetadatachar_(IO_HANDLE *sGranuleHandle,  
			int *parameter, char *value, int n1)
{
  static int status;
  int i = 0;

  /* search from the end of the value string looking for first 
   * non-whitespace.  Terminate the string with a null
   */
  i = n1-1;  /* value[n1] = \0 so skip it */
  while( (isspace(value[i]) || value[i]=='\"') && i > 0)
    value[i--]='\0';
  
  status = TKwriteMetadataChar(sGranuleHandle, *parameter, value);

  return (status);
}

/*****************************************************************************
*
*  FUNCTION STATEMENT:
*       tkclose_(IO_HANDLE *sGranuleHandle)
*
*  DESCRIPTION:
*       This routine is used to call TKclose in C toolkit programs.
*       This routine will only be called when compiling on the SUN and
*       SGI platforms.
*
*  INPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       sGranuleHandle		Structure containing information about the file
*                      		which is to be closed.  sGranuleHandle is returned
*                       	by TKopen().
*
*  OUTPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       sGranuleHandle		A null structure.
*
*  CALLED BY:			main program from Fortran
*
*  RETURN VALUES:               TK_SUCCESS if TKclose is successful.
*                               TK_FAIL if TKclose is failed.
*
*  ROUTINES CALLED:
*	TKclose(), cpCoreMetadata(), cpPSMetadata()
*
******************************************************************************/

int tkclose_(IO_HANDLE *sGranuleHandle)
{
  static int status;

  status = TKclose(sGranuleHandle);

  return (status);
}


/*****************************************************************************
*
*  FUNCTION STATEMENT:
*       tkseek_(IO_HANDLE *sGranuleHandle, int *offset, int *type)
*
*  DESCRIPTION:
*       This routine is used to call TKseek in C toolkit programs.
*       This routine will only be called when compiling on the SUN and
*       SGI platforms.
*
*  INPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       sGranuleHandle		Structure containing information about the file
*                      		and the file pointers. 
*	offset			An offset is used to interpret the relative position
*                               from the current postion.
*       type                    Type is used to select a specific TKseek to be performed.
*
*  OUTPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       sGranuleHandle		This structure contains updated file pointers which points
*				to the new currNumOfScanl position.
*
*  CALLED BY:			main program from Fortran
*
*  RETURN VALUES:               TK_SUCCESS if TKseek is successful.
*                               TK_FAIL if TKseek is failed.
*
*  ROUTINES CALLED:     	TKseek()
*
******************************************************************************/

int tkseek_(IO_HANDLE *sGranuleHandle, int *offset, int *type)
{
  static int status;

  status = TKseek(sGranuleHandle, *offset, *type);

  return (status);
}



/*****************************************************************************
*
*  FUNCTION STATEMENT:
*       tkendoffile_(IO_HANDLE *sGranuleHandle)
*
*  DESCRIPTION:
*       This routine is used to call TKendOfFile in C toolkit programs.
*       This routine will only be called when compiling on the SUN and
*       SGI platforms.
*
*  INPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       sGranuleHandle         Structure containing information about the file
*                               and the file pointers.
*
*  OUTPUT PARAMETERS:		None
*
*  CALLED BY:                   main program from Fortran
*
*  RETURN VALUES:               TK_EOF if the file pointer is at the end of file.
*                               TK_FAIL if the file pointer is not at the end of file.
*
*  ROUTINES CALLED:     	TKendOfFile()
*
******************************************************************************/

int tkendoffile_(IO_HANDLE *sGranuleHandle)
{
  static int status;

  status = TKendOfFile(sGranuleHandle);

  return (status);
}


/*****************************************************************************
*
*  FUNCTION STATEMENT:
*	tkgetnvos_(IO_HANDLE *sGranuleHandle)
*
*  DESCRIPTION:
*       This routine is used to call TKgetNvos in C toolkit programs.
*       This routine will only be called when compiling on the SUN and
*       SGI platforms.
*
*  INPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       sGranuleHandle         Structure containing information about the file
*                               and the file pointers.
*
*  OUTPUT PARAMETERS:           None
*
*  CALLED BY:                   main program from Fortran
*
*  RETURN VALUES:               Number of volume scans in the file.
*
*  ROUTINES CALLED:             TKgetNvos()
*
******************************************************************************/
int32 tkgetnvos_(IO_HANDLE *sGranuleHandle)
{
  static int32 value;

  value = TKgetNvos(sGranuleHandle);

  return (value);
}


/*****************************************************************************
*
*  FUNCTION STATEMENT:
*	tkgetnsensor_(IO_HANDLE *sGranuleHandle)
*
*  DESCRIPTION:
*       This routine is used to call TKgetNsensor in C toolkit programs.
*       This routine will only be called when compiling on the SUN and
*       SGI platforms.
*
*  INPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       sGranuleHandle         Structure containing information about the file
*                               and the file pointers.
*
*  OUTPUT PARAMETERS:           None
*
*  CALLED BY: 			main program from Fortran
*
*  RETURN VALUES:               Number of sensor which is always 1.
*
*  ROUTINES CALLED:             TKgetNsensor()
*
******************************************************************************/
int32 tkgetnsensor_(IO_HANDLE *sGranuleHandle)
{
  static int32 value;

  value = TKgetNsensor(sGranuleHandle);

  return (value);
}


/*****************************************************************************
*
*  FUNCTION STATEMENT:
*       tkgetnparm_(IO_HANDLE *sGranuleHandle, int32 *orderOfVOS)
*
*  DESCRIPTION:
*       This routine is used to call TKgetNparm in C toolkit programs.
*       This routine will only be called when compiling on the SUN and
*       SGI platforms.
*
*  INPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       sGranuleHandle         Structure containing information about the file
*                               and the file pointers.
*	orderOfVOS		The given volume scan number.
*
*  OUTPUT PARAMETERS:           None
*
*  CALLED BY:                   main program from Fortran
*
*  RETURN VALUES:               Number of parameters for a given volume scan.
*
*  ROUTINES CALLED:             TKgetNparm()
*
******************************************************************************/

int32 tkgetnparm_(IO_HANDLE *sGranuleHandle, int32 *orderOfVOS)
{
  static int32 value;

  value = TKgetNparm(sGranuleHandle, *orderOfVOS);

  return (value);
}


/*****************************************************************************
*
*  FUNCTION STATEMENT:
*	tkgetncell_(IO_HANDLE *sGranuleHandle, int32 *orderOfVOS, 
*			int32 *orderOfParm)
*
*  DESCRIPTION:
*       This routine is used to call TKgetNcell in C toolkit programs.
*       This routine will only be called when compiling on the SUN and
*       SGI platforms.
*
*  INPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       sGranuleHandle         Structure containing information about the file
*                               and the file pointers.
*       orderOfVOS              The given volume scan number.
*	orderOfParm		The given parameter.
*
*  OUTPUT PARAMETERS:           None
*
*  CALLED BY:          		main program from Fortran
*
*  RETURN VALUES:               Number of cells for the given parameter and the given
*				volume scan number.
*
*  ROUTINES CALLED:             TKgetNcell()
*
******************************************************************************/
int32 tkgetncell_(IO_HANDLE *sGranuleHandle, int32 *orderOfVOS, int32 *orderOfParm)
{
  static int32 value;

  value = TKgetNcell(sGranuleHandle, *orderOfVOS, *orderOfParm);

  return (value);
}


/*****************************************************************************
*
*  FUNCTION STATEMENT:
*	tkgetnray_(IO_HANDLE *sGranuleHandle, int32 *orderOfVOS)
*
*  DESCRIPTION:
*       This routine is used to call TKgetNray in C toolkit programs.
*       This routine will only be called when compiling on the SUN and
*       SGI platforms.
*
*  INPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       sGranuleHandle         Structure containing information about the file
*                               and the file pointers.
*       orderOfVOS              The given volume scan number.
*
*  OUTPUT PARAMETERS:           None
*
*  CALLED BY:                   main program from Fortran
*
*  RETURN VALUES:               Number of rays for the given volume scan number.
*
*  ROUTINES CALLED:             TKgetNray()
*
******************************************************************************/
int32 tkgetnray_(IO_HANDLE *sGranuleHandle, int32 *orderOfVOS)
{
  static int32 value;

  value = TKgetNray(sGranuleHandle, *orderOfVOS);

  return (value);
}


/*****************************************************************************
*
*  FUNCTION STATEMENT:
*	tkgetnsweep_(IO_HANDLE *sGranuleHandle, int32 *orderOfVOS)
*
*  DESCRIPTION:
*       This routine is used to call TKgetNsweep in C toolkit programs.
*       This routine will only be called when compiling on the SUN and
*       SGI platforms.
*
*  INPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       sGranuleHandle         Structure containing information about the file
*                               and the file pointers.
*       orderOfVOS              The given volume scan number.
*
*  OUTPUT PARAMETERS:           None
*
*  CALLED BY:			main program from Fortran
*
*  RETURN VALUES:               Number of nsweep for the given volume scan number.
*
*  ROUTINES CALLED:             TKgetNsweep()
*
******************************************************************************/

int32 tkgetnsweep_(IO_HANDLE *sGranuleHandle, int32 *orderOfVOS)
{
  static int32 value;

  value = TKgetNsweep(sGranuleHandle, *orderOfVOS);

  return (value);
}

/*****************************************************************************
*
*  FUNCTION STATEMENT:
*	tkreporterror_(int *mnemonic)
*
*  DESCRIPTION:
*       This routine is used to call TKreportError in C toolkit programs.
*       This routine will only be called when compiling on the SUN and
*       SGI platforms.
*
*  INPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*	mnemonic		Numeric value which generated by message
*				compiler (smfcompile).
*
*  OUTPUT PARAMETERS:           None
*
*  CALLED BY:                   main program from Fortran
*
*  RETURN VALUES:               None
*
*  ROUTINES CALLED:             TKreportError()
*
******************************************************************************/
void tkreporterror_(int *mnemonic)
{
  TKreportError(*mnemonic);
}

/*****************************************************************************
*
*  FUNCTION STATEMENT:
*       tkreportwarning_(int *mnemonic)
*
*  DESCRIPTION:
*       This routine is used to call TKreportWarning in C toolkit programs.
*       This routine will only be called when compiling on the SUN and
*       SGI platforms.
*
*  INPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*	mnemonic		Numeric value which generated by message
*				compiler (smfcompile).
*
*  OUTPUT PARAMETERS:           None
*
*  CALLED BY:                   main program from Fortran
*
*  RETURN VALUES:               None
*
*  ROUTINES CALLED:             TKreportWarning()
*
******************************************************************************/
void tkreportwarning_(int *mnemonic)
{
  TKreportWarning(*mnemonic);
}

/*****************************************************************************
*
*  FUNCTION STATEMENT:
*       tkwritenetheader_(IO_HANDLE *sGranuleHandle, int *nnet, void *sNetDesc)
*
*  DESCRIPTION:
*       This routine is used to call TKwriteNetHeader in C toolkit programs.
*       This routine will only be called when compiling on the SUN and
*       SGI platforms.
*
*  INPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       sGranuleHandle          A structure containing information about the file
*                               from which data to be written. 
*	nnet			The number of networks at a radar site.
*	sNetDesc		A structure containing the complete header data.
*				This structure must be declared to correspond to
*				the data file being written.
*
*  OUTPUT PARAMETERS:           None
*
*  RETURN VALUES:               TK_SUCCESS if TKwriteNetHeader is successful.
*
*  CALLED BY:                   Main program from Fortran.
*
*  ROUTINES CALLED:             TKwriteNetHeader()
*
******************************************************************************/
int tkwritenetheader_(IO_HANDLE *sGranuleHandle, int *nnet, void *sNetDesc)
{
  static int status;

  status = TKwriteNetHeader(sGranuleHandle, *nnet, sNetDesc);

  return (status);
}

/*****************************************************************************
*
*  FUNCTION STATEMENT:
*       tkreadnetheader_(IO_HANDLE *sGranuleHandle, int *nnet, void *sNetDesc)
*
*  DESCRIPTION:
*       This routine is used to call TKreadNetHeader in C toolkit programs.
*       This routine will only be called when compiling on the SUN and
*       SGI platforms.
*
*  INPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       sGranuleHandle          A structure containing information about the file
*                               from which data to be written. 
*	nnet			The number of networks at a radar site.
*	sNetDesc		A structure containing the complete header data.
*				This structure must be declared to correspond to
*				the data file being read.
*
*  OUTPUT PARAMETERS:           None
*
*  RETURN VALUES:               TK_SUCCESS if TKreadNetHeader is successful.
*
*  CALLED BY:                   Main program from Fortran.
*
*  ROUTINES CALLED:             TKreadNetHeader()
*
******************************************************************************/
int tkreadnetheader_(IO_HANDLE *sGranuleHandle, int *nnet, void *sNetDesc)
{
  static int status;

  status = TKreadNetHeader(sGranuleHandle, *nnet, sNetDesc);

  return (status);
}


/*****************************************************************************
*
*  FUNCTION STATEMENT:
*       tkwritegauge_(IO_HANDLE *sGranuleHandle, void *sGauge_Disdrometer)
*
*  DESCRIPTION:
*       This routine is used to call TKwriteGauge in C toolkit programs.
*       This routine will only be called when compiling on the SUN and
*       SGI platforms.
*
*  INPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       sGranuleHandle          A structure containing information about the file
*                               from which data to be written. 
*	sGauge_Disdrometer	A structure containing the complete header data.
*				This structure must be declared to correspond to
*				the data file being written.
*
*  OUTPUT PARAMETERS:           None
*
*  RETURN VALUES:               TK_SUCCESS if TKwriteGauge is successful.
*
*  CALLED BY:                   Main program from Fortran.
*
*  ROUTINES CALLED:             TKwriteGauge()
*
******************************************************************************/
int tkwritegauge_(IO_HANDLE *sGranuleHandle, void *sGauge_Disdrometer)
{
  static int status;

  status = TKwriteGauge(sGranuleHandle, sGauge_Disdrometer);

  return (status);
}

/*****************************************************************************
*
*  FUNCTION STATEMENT:
*       tkreadgauge_(IO_HANDLE *sGranuleHandle, void *sGauge_Disdrometer)
*
*  DESCRIPTION:
*       This routine is used to call TKreadGauge in C toolkit programs.
*       This routine will only be called when compiling on the SUN and
*       SGI platforms.
*
*  INPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       sGranuleHandle          A structure containing information about the file
*                               from which data to be written. 
*	sGauge_Disdrometer	A structure containing the complete header data.
*				This structure must be declared to correspond to
*				the data file being read.
*
*  OUTPUT PARAMETERS:           None
*
*  RETURN VALUES:               TK_SUCCESS if TKreadGauge is successful.
*
*  CALLED BY:                   Main program from Fortran.
*
*  ROUTINES CALLED:             TKreadGauge()
*
******************************************************************************/
int tkreadgauge_(IO_HANDLE *sGranuleHandle, void *sGauge_Disdrometer)
{
  static int status;

  status = TKreadGauge(sGranuleHandle, sGauge_Disdrometer);

  return (status);
}

/*****************************************************************************
*
*  FUNCTION STATEMENT:
*       tkwritedbraininfo_(int *instrID, struct tm *sStart_time,
*				struct tm *sEnd_time, int rain_percent)
*
*  DESCRIPTION:
*       This routine is used to call TKwriteDBRainInfo in C toolkit program.
*       This routine will only be called when compiling on the SUN and
*       SGI platforms.
*
*  INPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*	instrID			GV site identifier.
*	sStart_time		Start time of VOS.
*	sEnd_time		End time of VOS.
*	rain_percent		Percent rain.
*
*  OUTPUT PARAMETERS:           None
*
*  RETURN VALUES:               TK_SUCCESS if TKwriteDBRainInfo is successful.
*
*  CALLED BY:                   Main program from Fortran.
*
*  ROUTINES CALLED:             TKwriteDBRainInfo()
*
******************************************************************************/

int tkwritedbraininfo_(int instrID, struct tm *sStart_time, struct tm *sEnd_time,
			int rain_percent)
{
  static int status;

  status = TKwriteDBRainInfo(instrID, sStart_time, sEnd_time, rain_percent);

  return(status);
}

/*****************************************************************************
*
*  FUNCTION STATEMENT:
*        int tkquerygvcoincidenceinfo_(int instrID, DATE_STR *sStartDate, 
*		       TIME_STR *sStartTime, DATE_STR *sEndDate, 
*		       TIME_STR *sEndTime, char *coinFile, char *CoinDate,
*		       char *CoinTime, float *DistOfClosApp )
*
*
*  DESCRIPTION:
*       This routine is used to call TKqueryGVCoincidenceInfo in C toolkit 
*       program.  This routine will only be called when compiling on the SUN 
*       and SGI platforms.
*
*  INPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*	instrID			GV site identifier
*       sStartDate              Starting date
*	sStartTime		Starting time
*       sEndDate                Ending date
*	sEndTime		Ending time
*       coinFile                The name of the coincidence file (only used in TSU_ENV
*                               mode).
*
*  OUTPUT PARAMETERS:		
*       Parameter Name          Description
*       --------------          -----------
*       CoinDate                The date of coincidence
*       CoinTime                The time of coincidence
*       DistOfClosApp           The distance of closest approach
*
*  CALLED BY:                   main program
*
*  RETURN VALUES:               TK_SUCCESS, TK_FAIL, TK_NO_RECORD
*
*  ROUTINES CALLED:
*       Routine Called          Description
*       --------------          -----------
*       TKreportWarning()       This routine is used to report warning message to
*                               the console.
*       IMallocateRec()         This routine is used to allocate memory for the 
*                               data structure
*       IMopen                  Routine used to open the Database
*       IMfreeRec()             Routine to free the memory allocated earlier
*       IMclose                 Routine to close the database
*       IMquery                 Routine to query the database
*
******************************************************************************/

int tkquerygvcoincidenceinfo_(int *instrID, DATE_STR *sStartDate, 
		       TIME_STR *sStartTime, DATE_STR *sEndDate, 
		       TIME_STR *sEndTime, char *coinFile, char *CoinDate,
		       char *CoinTime, float *DistOfClosApp )
{
  static int status;

  status = TKqueryGVCoincidenceInfo(*instrID, sStartDate, sStartTime, 
				    sEndDate, sEndTime, coinFile,
				    CoinDate, CoinTime, DistOfClosApp );

  return(status);
}

/*
	==================================
	   non-HP wrapper functions for
		    TKutilGV.c
	==================================
*/

int tkreadl1gvparam_( IO_HANDLE * handle , L1_GV_2BYTE *vos ,
        int *VosNum , char param_name[ ], VosSizeSTRUCT * VosSize, int n )
{
	static int 	status;
	int		read_only_bottom_sweep = TK_FALSE ;
	char 		parmName[MAX_PARAM_LENGTH];
	int		i = 0;

	while ( !isspace ( param_name[i] ) && ( i < n ) )
		i++;

	if ( i > MAX_PARAM_LENGTH )
	{
		TKreportWarningParm ( W_TK_PARAM_LENGTH_EXCEEDED, param_name );
		return ( TK_FAIL );
	}

	strncpy ( parmName, param_name, i );
	parmName[i] = '\0';

	status	= TKreadL1GV_2byte_in_FORTRAN( handle, vos,
	  * VosNum, parmName, read_only_bottom_sweep, VosSize ) ;

	return( status ) ;
}

int tkreadl1gv1byteparam_( IO_HANDLE * handle , L1_GV_1BYTE *vos ,
        int *VosNum , char param_name[ ], VosSizeSTRUCT * VosSize, int n )
{
	static int 	status;
	int		read_only_bottom_sweep = TK_FALSE ;
	char 		parmName[MAX_PARAM_LENGTH];
	int		i = 0;

	while ( !isspace ( param_name[i] ) && ( i < n ) )
		i++;

	if ( i > MAX_PARAM_LENGTH )
	{
		TKreportWarningParm ( W_TK_PARAM_LENGTH_EXCEEDED, param_name );
		return ( TK_FAIL );
	}

	strncpy ( parmName, param_name, i );
	parmName[i] = '\0';

	status	= TKreadL1GV_1byte_in_FORTRAN( handle, vos,
	  * VosNum, parmName, read_only_bottom_sweep, VosSize ) ;

	return( status ) ;
}

int tkreadl1gvbasesweep_( IO_HANDLE * handle , L1_GV_2BYTE *vos ,
        int *VosNum , char param_name[ ], VosSizeSTRUCT * VosSize, int n )
{
	static int 	status;
	int		read_only_bottom_sweep = TK_FALSE ;
	char		parmName[MAX_PARAM_LENGTH];
	int 		i = 0;

	while ( !isspace ( param_name[i] ) && ( i < n ) )
		i++;

	if ( i > MAX_PARAM_LENGTH )
	{
		TKreportWarningParm ( W_TK_PARAM_LENGTH_EXCEEDED, param_name );
		return ( TK_FAIL );
	}

	strncpy ( parmName, param_name, i );
	parmName[i] = '\0';

	status	= TKreadL1GV_2byte_in_FORTRAN( handle, vos,
	  * VosNum, parmName, read_only_bottom_sweep, VosSize ) ;

	return( status ) ;
}

int tkpickl1gvvosnum_( IO_HANDLE * handle , DATE_TIME_STR * target_date,
        int *VosNum, int * diff_in_seconds ) 
{
	struct tm	target_date_in_C ;
	static int 	status;

	target_date_in_C.tm_year	= target_date->tkyear  -1900 ;
	target_date_in_C.tm_mon		= target_date->tkmonth -1 ;
	target_date_in_C.tm_mday	= target_date->tkday ;

	target_date_in_C.tm_hour	= target_date->tkhour ;
	target_date_in_C.tm_min		= target_date->tkminute ;
	target_date_in_C.tm_sec		= target_date->tksecond ;

	target_date_in_C.tm_isdst	= -1 ;

	status = TKpickL1GVvosNum( handle, target_date_in_C , VosNum, 
	  diff_in_seconds ) ;

	return( status ) ;
}

int tkreadl1gvdate_( IO_HANDLE * handle , 
	DATE_TIME_ARRAY_STR * date_array , 
	int * num_date )
{
	static int status;

	status = TKreadL1GVdate_in_FORTRAN( handle, date_array, num_date ) ;

	return( status ) ;
}

int tkreadl1gvsummary_( IO_HANDLE * handle ,
  int *VosNum, VosSummarySTRUCT *VosSummary )
{
	static int 	status ;

	status = TKreadL1GVsummary( handle, * VosNum , VosSummary ) ;

	return( status ) ;
}


int tkprintl1gvsummary_( VosSummarySTRUCT *VosSummary )
{
	static int status = TK_SUCCESS ;

	/* it is necessary that the fortran "function" return
	something.  So here we have it return TK_SUCCESS all
	the time. The same thing is done with TKclose in FORTRAN. */

	TKprintL1GVsummary( VosSummary ) ;

	return( status ) ;
}


#else

/**
 **	Using the FORTRAN interface for the HP9000 machine.
 **/


/*****************************************************************************
*
*  FUNCTION STATEMENT:
*       tkopen(char *granuleID, int *dataType, char *fileMode,
*               IO_HANDLE *sGranuleHandle, int n1, int n2)
*
*  DESCRIPTION:
*       This routine is used to call TKopen in C toolkit programs.
*       This routine will only be called when compiling on the HP platforms.
*
*  INPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*	granuleID		Name of HDF file.
*	dataType		Product type.
*	filemode		File access mode
*
*  OUTPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       sGranuleHandle         A structure passed to subsequent I/O routines.
*                               This structure is initialized by TKopen().
*
*  CALLED BY:                   main program from Fortran
*
*  RETURN VALUES:               TK_SUCCESS if TKopen is successful.
*                               TK_FAIL if TKopen is failed.
*
*  ROUTINES CALLED:             TKopen()
*
******************************************************************************/
int tkopen(char *granuleID, int *dataType, char *fileMode, 
	   IO_HANDLE *sGranuleHandle, int n1, int n2)
{
  static int status;
  int i = 0;

  /* search for first whitespace in granuleID and put EOS there */
  while( !isspace(granuleID[i]) && (i<n1))
    i++;
  granuleID[i] = '\0';

  status = TKopen(granuleID, *dataType, fileMode[0], sGranuleHandle);

  return (status);
}

int tkgetalgorithmid(char *granuleID , int n1)
{
  static int alg_id;
  int i = 0;

  /* search for first whitespace in granuleID and put EOS there */
  while( !isspace(granuleID[i]) && (i<n1))
    i++;
  granuleID[i] = '\0';

  alg_id = TKgetAlgorithmID(granuleID);

  return (alg_id);
}

/*****************************************************************************
*
*  FUNCTION STATEMENT:
*       tkreadscan(IO_HANDLE *sGranuleHandle, void *sSwathData)
*
*  DESCRIPTION:
*       This routine is used to call TKreadScan in C toolkit programs.
*       This routine will only be called when compiling on the HP platforms.
*
*  INPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       sGranuleHandle         A structure containing information about the file
*                               from which data can be obtained.
*
*  OUTPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       sSwathData              A structure containing the complete scanline data
*                               which is obtained from the input file.  This
*                               structure must be declared to correspond to the
*                               data file being read.  The structure of sSwathData
*                               is manipulated by TKreadScan() and other toolkit
*                               routines.
*
*  CALLED BY:			main program from Fortran 
*
*  RETURN VALUES:               TK_SUCCESS if TKreadScan is successful.
*                               TK_FAIL if TKreadScan is failed.
*
*  ROUTINES CALLED:     	TKreadScan()
*
******************************************************************************/
int tkreadscan(IO_HANDLE *sGranuleHandle, void *sSwathData)
{
  static int status;

  status = TKreadScan(sGranuleHandle, sSwathData);

  return (status);
}


/*****************************************************************************
*
*  FUNCTION STATEMENT:
*       tkwritescan(IO_HANDLE *sGranuleHandle, void *sSwathData)
*
*  DESCRIPTION:
*       This routine is used to call TKwriteScan in C toolkit programs.
*       This routine will only be called when compiling on the HP platforms.
*
*  INPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       sGranuleHandle         A structure containing information about the file
*                               from which data can be obtained.
*       sSwathData              A structure containing the complete scanline data
*                               which is to be written to the output file.  This
*                               structure must be declared to correspond to the
*                               data file being written.  The structure of sScanData
*                               is manipulated by TKwriteScan() and other toolkit
*                               routines.
*
*  OUTPUT PARAMETERS:		None
*
*  RETURN VALUES:               TK_SUCCESS if TKwriteScan is successful.
*                               TK_FAIL if TKwriteScan is failed.
*
*  CALLED BY:			main program from Fortran
*
*  ROUTINES CALLED:     	TKwriteScan()
*
******************************************************************************/
int tkwritescan(IO_HANDLE *sGranuleHandle, void *sSwathData)
{
  static int status;

  status = TKwriteScan(sGranuleHandle, sSwathData);

  return (status);
}


/*****************************************************************************
*
*  FUNCTION STATEMENT:
*       tkcopyscanheader (IO_HANDLE *sInGranuleHandle, void *sInDataHandle,
*                         IO_HANDLE *sOutGranuleHandle, void *sOutDataHandle)
*
*  DESCRIPTION:
*       This routine is used to call the C version of TKcopyScanHeader.
*       This routine will only be called when compiling on the HP platforms.
*
*  INPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       sInGranuleHandle	A structure containing information about the file
*                               from which data can be obtained. 
*	sInDataHandle		A structure containing the complete data buffer
*                               from which the scan header is copied.
*
*  OUTPUT PARAMETERS:		
*       Parameter Name          Description
*       --------------          -----------
*       sOutGranuleHandle	A structure containing information about the file
*                               from which data can be obtained. 
*	sOutDataHandle		A structure containing the complete data buffer
*                               to which the scan header is copied.
*
*  RETURN VALUES:               TK_SUCCESS if TKcopyScanHeader is successful.
*                               TK_FAIL if TKcopyScanHeader is failed.
*
*  CALLED BY:			Main program from Fortran.
*
*  ROUTINES CALLED:     	TKcopyScanHeader()
*
******************************************************************************/

int tkcopyscanheader (IO_HANDLE *sInGranuleHandle, void *sInDataHandle,
		       IO_HANDLE *sOutGranuleHandle, void *sOutDataHandle)
{
  static int status;

  status = TKcopyScanHeader ( sInGranuleHandle, sInDataHandle, 
			     sOutGranuleHandle, sOutDataHandle );

  return ( status );
}


/*****************************************************************************
*
*  FUNCTION STATEMENT:
*       tkwritegrid(IO_HANDLE *sGranuleHandle, void *sGrid)
*
*  DESCRIPTION:
*       This routine is used to call TKwriteGrid in C toolkit programs.
*       This routine will only be called when compiling on the HP platforms.
*
*  INPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       sGranuleHandle         A structure containing information about the file
*                               from which data can be obtained.
*       sGrid                   A structure containing the complete grid data
*                               which is obtained from the input file.  This
*                               structure must be declared to correspond to the
*                               data file being read.  The structure of sGrid
*                               is manipulated by TKreadGrid() and other toolkit
*                               routines.
*
*  OUTPUT PARAMETERS:		None
*
*  CALLED BY:			main program from Fortran
*
*  RETURN VALUES:               TK_SUCCESS if TKrwriteGrid is successful.
*                               TK_FAIL if TKwriteGrid is failed.
*
*  ROUTINES CALLED:             TKwriteGrid()
*
******************************************************************************/
int tkwritegrid(IO_HANDLE *sGranuleHandle, void *sGrid)
{
  static int status;

  status = TKwriteGrid(sGranuleHandle, sGrid);

  return (status);
}


/*****************************************************************************
*
*  FUNCTION STATEMENT:
*       tkreadGrid(IO_HANDLE *sGranuleHandle, void *sGrid)
*
*  DESCRIPTION:
*       This routine is used to call TKreadGrid in C toolkit programs.
*       This routine will only be called when compiling on the HP platforms.
*
*  INPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       sGranuleHandle         A structure containing information about the file
*                               from which data can be obtained.
*
*  OUTPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       sGrid                   A structure containing the complete grid data
*                               which is obtained from the input file.  This
*                               structure must be declared to correspond to the
*                               data file being read.  The structure of sGrid
*                               is manipulated by TKreadGrid() and other toolkit
*                               routines.
*
*  CALLED BY:  			main program from Fortran
*
*  RETURN VALUES:               TK_SUCCESS if TKreadGrid is successful.
*                               TK_FAIL if TKreadGrid is failed.
*
*  ROUTINES CALLED:             TKreadGrid()
*
******************************************************************************/
int tkreadgrid(IO_HANDLE *sGranuleHandle, void *sGrid)
{
  static int status;

  status = TKreadGrid(sGranuleHandle, sGrid);

  return (status);
}


/*****************************************************************************
*
*  FUNCTION STATEMENT:
*       tkwritel1gv(IO_HANDLE *sGranuleHandle, void *sGV)
*
*  DESCRIPTION:
*	This routines is used to call TKwriteL1GV in c toolkit program.
*       This routine will only be called when compiling on the HP platforms.
*
*  INPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       sGranuleHandle         A structure containing information about the file
*                               from which data can be obtained.
*       sGV                     A structure containing the complete L1 GV data
*                               which is obtained from the input file.  This
*                               structure must be declared to correspond to the
*                               data file being read.  The structure of sGrid
*                               is manipulated by TKwriteL1GV() and other toolkit
*                               routines.
*
*  OUTPUT PARAMETERS:		None
*
*  CALLED BY:                   main program from Fortran
*
*  RETURN VALUES:               TK_SUCCESS if TKwriteL1GV is successful.
*                               TK_FAIL if TKwriteL1GV is failed.
*
*  ROUTINES CALLED:             TKwriteL1GV()
*
******************************************************************************/
int tkwritel1gv(IO_HANDLE *sGranuleHandle, void *sGV)
{
  static int status;

  status = TKwriteL1GV(sGranuleHandle, sGV);

  return (status);
}


/*****************************************************************************
*
*  FUNCTION STATEMENT:
*       tkreadl1gv(IO_HANDLE *sGranuleHandle, void *sGV)
*
*  DESCRIPTION:
*	This routine is used to call TKreadL1GV in c toolkit programs.
*       This routine will only be called when compiling on the HP platforms.
*
*  INPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       sGranuleHandle         A structure containing information about the file
*                               from which data can be obtained.
*       sGV                     A structure containing the complete L1 GV data
*                               which is obtained from the input file.  This
*                               structure must be declared to correspond to the
*                               data file being read.  The structure of sGrid
*                               is manipulated by TKreadL1GV() and other toolkit
*                               routines.
*
*  OUTPUT PARAMETERS:		None
*
*  CALLED BY:                   main program from Fortran
*
*  RETURN VALUES:               TK_SUCCESS if TKreadL1GV is successful.
*                               TK_FAIL if TKreadL1GV is failed.
*
*  ROUTINES CALLED:             TKreadL1GV()
*
******************************************************************************/
int tkreadl1gv(IO_HANDLE *sGranuleHandle, void *sGV)
{
  static int status;

  status = TKreadL1GV(sGranuleHandle, sGV);

  return (status);
}


/*****************************************************************************
*
*  FUNCTION STATEMENT:
*       tkclose(IO_HANDLE *sGranuleHandle)
*
*  DESCRIPTION:
*       This routine is used to call TKclose in C toolkit programs.
*       This routine will only be called when compiling on the HP platforms.
*
*  INPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       sGranuleHandle         Structure containing information about the file
*                               which is to be closed.  sGranuleHandle is returned
*                               by TKopen().
*
*  OUTPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       sGranuleHandle         A null structure.
*
*  CALLED BY: 			main program from Fortran 
*
*  RETURN VALUES:               TK_SUCCESS if TKclose is successful.
*                               TK_FAIL if TKclose is failed.
*
*  ROUTINES CALLED:             
*	TKclose(), cpCoreMetadata(), cpPSMetadata()
*
******************************************************************************/
int tkclose(IO_HANDLE *sGranuleHandle)
{
  static int status;

  status = TKclose(sGranuleHandle);

  return (status);
}


/*****************************************************************************
*
*  FUNCTION STATEMENT:
*       tkseek(IO_HANDLE *sGranuleHandle, int *offset, int *type)
*
*  DESCRIPTION:
*       This routine is used to call TKseek in C toolkit programs.
*       This routine will only be called when compiling on the HP platforms.
*
*  INPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       sGranuleHandle         Structure containing information about the file
*                               and the file pointers.
*       offset                  An offset is used to interpret the relative position
*                               from the current postion.
*       type                    Type is used to select a specific TKseek to be performed.
*
*  OUTPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       sGranuleHandle         This structure contains updated file pointers which points
*                               to the new currNumOfScanl position.
*
*  CALLED BY:                   main program from Fortran
*
*  RETURN VALUES:               TK_SUCCESS if TKseek is successful.
*                               TK_FAIL if TKseek is failed.
*
*  ROUTINES CALLED:             TKseek()
*
******************************************************************************/
int tkseek(IO_HANDLE *sGranuleHandle, int *offset, int *type)
{
  static int status;

  status = TKseek(sGranuleHandle, *offset, *type);

  return (status);
}


/*****************************************************************************
*
*  FUNCTION STATEMENT:
*       tkendoffile(IO_HANDLE *sGranuleHandle)
*
*  DESCRIPTION:
*       This routine is used to call TKendOfFile in C toolkit programs.
*       This routine will only be called when compiling on the HP platforms.
*
*  INPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       sGranuleHandle         Structure containing information about the file
*                               and the file pointers.
*
*  OUTPUT PARAMETERS:           None
*
*  CALLED BY:                   main program from Fortran
*
*  RETURN VALUES:               TK_EOF if the file pointer is at the end of file.
*                               TK_FAIL if the file pointer is not at the end of file.
*
*  ROUTINES CALLED:             TKendOfFile()
*
******************************************************************************/

int tkendoffile(IO_HANDLE *sGranuleHandle)
{
  static int status;

  status = TKendOfFile(sGranuleHandle);

  return (status);
}


/*****************************************************************************
*
*  FUNCTION STATEMENT:
*       tkgetnvos(IO_HANDLE *sGranuleHandle)
*
*  DESCRIPTION:
*       This routine is used to call TKgetNvos in C toolkit programs.
*       This routine will only be called when compiling on the HP platforms.
*
*  INPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       sGranuleHandle         Structure containing information about the file
*                               and the file pointers.
*
*  OUTPUT PARAMETERS:           None
*
*  CALLED BY:                   main program from Fortran
*
*  RETURN VALUES:               Number of volume scans in the file.
*
*  ROUTINES CALLED:             TKgetNvos()
*
******************************************************************************/
int32 tkgetnvos(IO_HANDLE *sGranuleHandle)
{
  static int32 value;

  value = TKgetNvos(sGranuleHandle);

  return (value);
}


/*****************************************************************************
*
*  FUNCTION STATEMENT:
*       int32 tkgetnsensor(IO_HANDLE *sGranuleHandle)
*
*  DESCRIPTION:
*       This routine is used to call TKgetNsensor in C toolkit programs.
*       This routine will only be called when compiling on the HP platforms.
*
*  INPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       sGranuleHandle         Structure containing information about the file
*                               and the file pointers.
*
*  OUTPUT PARAMETERS:           None
*
*  CALLED BY:                   main program from Fortran
*
*  RETURN VALUES:               Number of sensor which is always 1.
*
*  ROUTINES CALLED:             TKgetNsensor()
*
******************************************************************************/
int32 tkgetnsensor(IO_HANDLE *sGranuleHandle)
{
  static int32 value;

  value = TKgetNsensor(sGranuleHandle);

  return (value);
}


/*****************************************************************************
*
*  FUNCTION STATEMENT:
*       int32 tkgetnparm(IO_HANDLE *sGranuleHandle, int32 *orderOfVOS)
*
*  DESCRIPTION:
*       This routine is used to call TKgetNparm in C toolkit programs.
*       This routine will only be called when compiling on the HP platforms.
*
*  INPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       sGranuleHandle         Structure containing information about the file
*                               and the file pointers.
*       orderOfVOS              The given volume scan number.
*
*  OUTPUT PARAMETERS:           None
*
*  CALLED BY:                   main program from Fortran
*
*  RETURN VALUES:               Number of parameters for a given volume scan.
*
*  ROUTINES CALLED:             TKgetNparm()
*
******************************************************************************/
int32 tkgetnparm(IO_HANDLE *sGranuleHandle, int32 *orderOfVOS)
{
  static int32 value;

  value = TKgetNparm(sGranuleHandle, *orderOfVOS);

  return (value);
}

/*****************************************************************************
*
*  FUNCTION STATEMENT:
*       tkgetncell(IO_HANDLE *sGranuleHandle, int32 *orderOfVOS, int32 *orderOfParm)
*
*  DESCRIPTION:
*       This routine is used to call TKgetNcell in C toolkit programs.
*       This routine will only be called when compiling on the HP platforms.
*
*  INPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       sGranuleHandle         Structure containing information about the file
*                               and the file pointers.
*       orderOfVOS              The given volume scan number.
*       orderOfParm             The given parameter.
*
*  OUTPUT PARAMETERS:           None
*
*  CALLED BY:                   main program from Fortran
*
*  RETURN VALUES:               Number of cells for the given parameter and the given
*                               volume scan number.
*
*  ROUTINES CALLED:             TKgetNcell()
*
******************************************************************************/
int32 tkgetncell(IO_HANDLE *sGranuleHandle, int32 *orderOfVOS, int32 *orderOfParm)
{
  static int32 value;

  value = TKgetNcell(sGranuleHandle, *orderOfVOS, *orderOfParm);

  return (value);
}


/*****************************************************************************
*
*  FUNCTION STATEMENT:
*       tkgetnray(IO_HANDLE *sGranuleHandle, int32 *orderOfVOS)
*
*  DESCRIPTION:
*       This routine is used to call TKgetNray in C toolkit programs.
*       This routine will only be called when compiling on the HP platforms.
*
*  INPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       sGranuleHandle         Structure containing information about the file
*                               and the file pointers.
*       orderOfVOS              The given volume scan number.
*
*  OUTPUT PARAMETERS:           None
*
*  CALLED BY:                   main program from Fortran
*
*  RETURN VALUES:               Number of rays for the given volume scan number.
*
*  ROUTINES CALLED:             TKgetNray()
*
******************************************************************************/
int32 tkgetnray(IO_HANDLE *sGranuleHandle, int32 *orderOfVOS)
{
  static int32 value;

  value = TKgetNray(sGranuleHandle, *orderOfVOS);

  return (value);
}


/*****************************************************************************
*
*  FUNCTION STATEMENT:
*	tkgetnsweep(IO_HANDLE *sGranuleHandle, int32 *orderOfVOS)
*
*  DESCRIPTION:
*	This routine is used to call TKgetNsweep in C toolkit programs.
*	This routine will only be called when compiling on the HP platforms.
*
*  INPUT PARAMETERS:
*	Parameter Name          Description
*	--------------          -----------
*       sGranuleHandle         Structure containing information about the file
*                               and the file pointers.
*       orderOfVOS              The given volume scan number.
*
*  OUTPUT PARAMETERS:           None
*
*  CALLED BY: 			main program from Fortran
*
*  RETURN VALUES:               Number of nsweep for the given volume scan number.
*
*  ROUTINES CALLED:             TKgetNsweep()
*
******************************************************************************/
int32 tkgetnsweep(IO_HANDLE *sGranuleHandle, int32 *orderOfVOS)
{
  static int32 value;

  value = TKgetNsweep(sGranuleHandle, *orderOfVOS);

  return (value);
}


/*****************************************************************************
*
*  FUNCTION STATEMENT:
*       tkreadmetadataint(IO_HANDLE *sGranuleHandle,  int *parameter,
*                          void *value)
*
*  DESCRIPTION:
*       This routine is used to call TKreadMetadataInt in C toolkit programs.
*       This routine will only be called when compiling on the SUN and
*       SGI platforms.
*
*  INPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       sGranuleHandle         Structure containing information about the file
*                               which is to be closed.  sGranuleHandle is returned
*                               by TKopen().
*
*       parameter               Description of value to be read.
*
*  OUTPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       value                   Value of the parameter.
*
*  CALLED BY:			main program from Fortran
*
*  RETURN VALUES:               TK_SUCCESS if TKreadMetadataInt is successful.
*                               TK_FAIL if TKreadMetadataInt is failed.
*
*  ROUTINES CALLED:
*	TKreadMetadataInt(), cpCoreMetadata(), cpPSMetadata()
*
******************************************************************************/
int tkreadmetadataint(IO_HANDLE *sGranuleHandle,  int *parameter, void *value)
{
  static int status;

  status = TKreadMetadataInt(sGranuleHandle, *parameter, value);

  return (status);
}


/*****************************************************************************
*
*  FUNCTION STATEMENT:
*       tkreadmetadatafloat(IO_HANDLE *sGranuleHandle,  int *parameter,
*                            float *value)
*
*  DESCRIPTION:
*       This routine is used to call TKreadMetadataFloat in C toolkit programs.
*       This routine will only be called when compiling on the SUN and
*       SGI platforms.
*
*  INPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       sGranuleHandle         Structure containing information about the file
*                               which is to be closed.  sGranuleHandle is returned
*                               by TKopen().
*
*       parameter               Description of value to be read.
*
*  OUTPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       value                   Value of the parameter.
*
*  CALLED BY:  			main program from Fortran
*
*  RETURN VALUES:               TK_SUCCESS if TKreadMetadataFloa is successful.
*                               TK_FAIL if TKreadMetadataFloa is failed.
*
*  ROUTINES CALLED:
*	TKreadMetadataFloat(), cpCoreMetadata(), cpPSMetadata()
*
******************************************************************************/
int tkreadmetadatafloat(IO_HANDLE *sGranuleHandle,  
		int *parameter, float *value)
{
  static int status;

  status = TKreadMetadataFloat(sGranuleHandle, *parameter, value);

  return (status);
}


/*****************************************************************************
*
*  FUNCTION STATEMENT:
*       tkreadmetadatachar(IO_HANDLE *sGranuleHandle,  int *parameter,
*                           char *value, int n1)
*
*  DESCRIPTION:
*       This routine is used to call TKreadMetadataChar in C toolkit programs.
*       This routine will only be called when compiling on the SUN and
*       SGI platforms.
*
*  INPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       sGranuleHandle         Structure containing information about the file
*                               which is to be closed.  sGranuleHandle is returned
*                               by TKopen().
*       parameter               Description of value to be read.
*
*       n1                      Length of the value string.  This value of n1 is
*                               filled in automatically  by the compiler
*
*  OUTPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       value                   Value of the parameter.
*
*  CALLED BY:  			main program from Fortran
*
*  RETURN VALUES:               TK_SUCCESS if TKreadMetadataChar is successful.
*                               TK_FAIL if TKreadMetadataChar is failed.
*
*  ROUTINES CALLED:
*	TKreadMetadataChar(), cpCoreMetadata(), cpPSMetadata()
*
******************************************************************************/
int tkreadmetadatachar(IO_HANDLE *sGranuleHandle,  int *parameter, 
		       char *value, int n1)
{
  static int status;
  int        i;

  /* search from the end of the value string looking for first 
   * non-whitespace.  Terminate the string with a null
   */
  i = n1;
  while( isspace(value[i]) && i > 0)
    i--;
  value[i+1] = '\0';

  status = TKreadMetadataChar(sGranuleHandle, *parameter, value);

  return (status);
}


/*****************************************************************************
*
*  FUNCTION STATEMENT:
*       tkwritemetadataint(IO_HANDLE *sGranuleHandle,  int *parameter,
*                          void *value)
*
*  DESCRIPTION:
*       This routine is used to call TKwriteMetadataInt in C toolkit programs.
*       This routine will only be called when compiling on the SUN and
*       SGI platforms.
*
*  INPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       sGranuleHandle         Structure containing information about the file
*                               which is to be closed.  sGranuleHandle is returned
*                               by TKopen().
*       parameter               Description of value to be read.
*       value                   Value to be written in metadata using parameter.
*
*  OUTPUT PARAMETERS:           None
*
*  CALLED BY:  			main program from Fortran 
*
*  RETURN VALUES:               TK_SUCCESS if TKwriteMetadataInt is successful.
*                               TK_FAIL if TKwriteMetadataInt is failed.
*
*  ROUTINES CALLED:             
*	TKwriteMetadataInt(), cpCoreMetadata(), cpPSMetadata()
*
******************************************************************************/
int tkwritemetadataint(IO_HANDLE *sGranuleHandle,  int *parameter, void *value)
{
  static int status;

  status = TKwriteMetadataInt(sGranuleHandle, *parameter, value);

  return (status);
}


/*****************************************************************************
*
*  FUNCTION STATEMENT:
*       tkwritemetadatafloat(IO_HANDLE *sGranuleHandle,  int *parameter,
*                             float *value)
*
*  DESCRIPTION:
*       This routine is used to call TKwriteMetadataFloat in C toolkit programs.
*       This routine will only be called when compiling on the SUN and
*       SGI platforms.
*
*  INPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       sGranuleHandle         Structure containing information about the file
*                               which is to be closed.  sGranuleHandle is returned
*                               by TKopen().
*       parameter               Description of value to be read.
*       value                   Value to be written in metadata using parameter.
*
*  OUTPUT PARAMETERS:           None
*
*  CALLED BY:			main program from Fortran
*
*  RETURN VALUES:               TK_SUCCESS if TKwriteMetadataFloat is successful.
*                               TK_FAIL if TKwriteMetadataFloat is failed.
*
*  ROUTINES CALLED:
*	TKwriteMetadataFloat(), cpCoreMetadata(), cpPSMetadata()
*
******************************************************************************/
int tkwritemetadatafloat(IO_HANDLE *sGranuleHandle,  int *parameter, float *value)
{
  static int status;

  status = TKwriteMetadataFloat(sGranuleHandle, *parameter, value);

  return (status);
}


/*****************************************************************************
*
*  FUNCTION STATEMENT:
*       tkwritemetadatachar(IO_HANDLE *sGranuleHandle,  int *parameter,
*                            char *value)
*
*  DESCRIPTION:
*       This routine is used to call TKwriteMetadataChar in C toolkit programs.
*       This routine will only be called when compiling on the SUN and
*       SGI platforms.
*
*  INPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       sGranuleHandle         Structure containing information about the file
*                               which is to be closed.  sGranuleHandle is returned
*                               by TKopen().
*       parameter               Description of value to be read.
*       value                   Value to be written in metadata using parameter.
*
*  OUTPUT PARAMETERS:           None
*
*  CALLED BY: 			main program from Fortran
*
*  RETURN VALUES:               TK_SUCCESS if TKwriteMetadataChar is successful.
*                               TK_FAIL if TKwriteMetadataChar is failed.
*
*  ROUTINES CALLED:             
*	TKwriteMetadataChar(), cpCoreMetadata(), cpPSMetadata()
*
******************************************************************************/
int tkwritemetadatachar(IO_HANDLE *sGranuleHandle,  int *parameter, 
			char *value, int n1)
{
  static int status;
  int i = 0;

  /* search from the end of the value string looking for first 
   * non-whitespace.  Terminate the string with a null
   */
  i = n1;
  while( isspace(value[i]) && i > 0)
    i--;
  value[i+1] = '\0';

  status = TKwriteMetadataChar(sGranuleHandle, *parameter, value);
  
  return (status);
}


/*****************************************************************************
*
*  FUNCTION STATEMENT:
*       tkreporterror(int *mnemonic)
*
*  DESCRIPTION:
*       This routine is used to call TKreportError in C toolkit programs.
*       This routine will only be called when compiling on the HP platforms.
*
*  INPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*	mnemonic		The mnemonic for error code which generated by
*				message compiler (smfcompile).
*
*  OUTPUT PARAMETERS:           None
*
*  CALLED BY:                   main program from Fortran
*
*  RETURN VALUES:               None
*
*  ROUTINES CALLED:             TKreportError()
*
******************************************************************************/
void tkreporterror(int *mnemonic)
{
  TKreportError(*mnemonic);
}


/*****************************************************************************
*
*  FUNCTION STATEMENT:
*       tkreportwarning(int *mnemonic)
*
*  DESCRIPTION:
*       This routine is used to call TKreportWarning in C toolkit programs.
*       This routine will only be called when compiling on the HP platforms.
*
*  INPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       mnemonic		The mnemonic for warning code which generated by
*				message compiler (smfcompile).
*
*  OUTPUT PARAMETERS:           None
*
*  CALLED BY:                   main program from Fortran
*
*  RETURN VALUES:               None
*
*  ROUTINES CALLED:             TKreportWarning()
*
******************************************************************************/
void tkreportwarning(int *mnemonic)
{
  TKreportWarning(*mnemonic);
}


/*****************************************************************************
*
*  FUNCTION STATEMENT:
*       tkwriteheader(IO_HANDLE *sGranuleHandle, void *sHeader)
*
*  DESCRIPTION:
*       This routine is used to call TKwriteHeader in C toolkit programs.
*       This routine will only be called when compiling on the HP platforms.
*
*  INPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       sGranuleHandle         A structure containing information about the file
*                               from which data can be obtained.
*       sHeader                 A structure containing the complete header info
*				for either L1B21, L1C21, or L2A25 which obtained 
*				from the input file.  This structure must be 
*				declared to correspond to the data file being read.  
*				The structure of sHeader is manipulated by 
*				TKreadHeader() and other toolkit routines.
*
*  OUTPUT PARAMETERS:           None
*
*  CALLED BY:                   main program from Fortran
*
*  RETURN VALUES:               TK_SUCCESS if TKrwriteHeader is successful.
*                               W_TK_BADPIDWH or W_TK_BADFILEMODEWH 
*				if TKwriteHeader is failed.
*
*  ROUTINES CALLED:             TKwriteHeader()
*
******************************************************************************/
int tkwriteheader(IO_HANDLE *sGranuleHandle, void *sHeader)
{
  static int status;

  status = TKwriteHeader(sGranuleHandle, sHeader);

  return (status);
}


/*****************************************************************************
*
*  FUNCTION STATEMENT:
*       tkreadheader(IO_HANDLE *sGranuleHandle, void *sHeader)
*
*  DESCRIPTION:
*       This routine is used to call TKreadHeader in C toolkit programs.
*       This routine will only be called when compiling on the HP platforms.
*
*  INPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       sGranuleHandle         A structure containing information about the file
*                               from which data can be obtained.
*
*  OUTPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       sHeader                 A structure containing the complete header info
*				for either L1B21, L1C21, or L2A25 which 
*				obtained from the input file.  This
*                               structure must be declared to correspond to the
*                               data file being read.  The structure of sHeader
*                               is manipulated by TKreadHeader() and other toolkit
*                               routines.
*
*  CALLED BY:                   main program from Fortran 
*
*  RETURN VALUES:               TK_SUCCESS if TKreadHeader is successful.
*                               W_TK_BADPIDRH or W_TK_BADFILEMODERH 
*				if TKreadHeader is failed.
*
*  ROUTINES CALLED:             TKreadHeader()
*
******************************************************************************/

int tkreadheader(IO_HANDLE *sGranuleHandle, void *sHeader)
{
  static int status;

  status = TKreadHeader(sGranuleHandle, sHeader);

  return (status);
}

/*****************************************************************************
*
*  FUNCTION STATEMENT:
*       tkwritenetheader_(IO_HANDLE *sGranuleHandle, int *nnet, void *sNetDesc)
*
*  DESCRIPTION:
*       This routine is used to call TKwriteNetHeader in C toolkit programs.
*       This routine will only be called when compiling on the HP platform.
*
*  INPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       sGranuleHandle          A structure containing information about the file
*                               from which data to be written. 
*       nnet                    The number of networks at a radar site.
*       sNetDesc                A structure containing the complete header data.
*                               This structure must be declared to correspond to
*                               the data file being written.
*
*  OUTPUT PARAMETERS:           None
*
*  RETURN VALUES:               TK_SUCCESS if TKwriteNetHeader is successful.
*
*  CALLED BY:                   Main program from Fortran.
*
*  ROUTINES CALLED:             TKwriteNetHeader()
*
******************************************************************************/

int tkwritenetheader(IO_HANDLE *sGranuleHandle, int *nnet, void *sNetDesc)
{
  static int status;

  status = TKwriteNetHeader(sGranuleHandle, *nnet, sNetDesc);

  return (status);
}

/*****************************************************************************
*
*  FUNCTION STATEMENT:
*       tkreadnetheader_(IO_HANDLE *sGranuleHandle, int *nnet, void *sNetDesc)
*
*  DESCRIPTION:
*       This routine is used to call TKreadNetHeader in C toolkit programs.
*       This routine will only be called when compiling on the HP platform.
*
*  INPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       sGranuleHandle          A structure containing information about the file
*                               from which data to be written. 
*       nnet                    The number of networks at a radar site.
*       sNetDesc                A structure containing the complete header data.
*                               This structure must be declared to correspond to
*                               the data file being read.
*
*  OUTPUT PARAMETERS:           None
*
*  RETURN VALUES:               TK_SUCCESS if TKreadNetHeader is successful.
*
*  CALLED BY:                   Main program from Fortran.
*
*  ROUTINES CALLED:             TKreadNetHeader()
*
******************************************************************************/

int tkreadnetheader(IO_HANDLE *sGranuleHandle, int *nnet, void *sNetDesc)
{
  static int status;

  status = TKreadNetHeader(sGranuleHandle, *nnet, sNetDesc);

  return (status);
}


/*****************************************************************************
*
*  FUNCTION STATEMENT:
*       tkwritegauge(IO_HANDLE *sGranuleHandle, void *sGauge_Disdrometer)
*
*  DESCRIPTION:
*       This routine is used to call TKwriteGauge in C toolkit programs.
*       This routine will only be called when compiling on the HP platform.
*
*  INPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       sGranuleHandle          A structure containing information about the file
*                               from which data to be written.
*       sGauge_Disdrometer      A structure containing the complete header data.
*                               This structure must be declared to correspond to
*                               the data file being written.
*
*  OUTPUT PARAMETERS:           None
*
*  RETURN VALUES:               TK_SUCCESS if TKwriteGauge is successful.
*
*  CALLED BY:                   Main program from Fortran.
*
*  ROUTINES CALLED:             TKwriteGauge()
*
******************************************************************************/
int tkwritegauge(IO_HANDLE *sGranuleHandle, void *sGauge_Disdrometer)
{
  static int status;

  status = TKwriteGauge(sGranuleHandle, sGauge_Disdrometer);

  return (status);
}

/*****************************************************************************
*
*  FUNCTION STATEMENT:
*       tkreadgauge(IO_HANDLE *sGranuleHandle, void *sGauge_Disdrometer)
*
*  DESCRIPTION:
*       This routine is used to call TKreadGauge in C toolkit programs.
*       This routine will only be called when compiling on the HP platform.
*
*  INPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       sGranuleHandle          A structure containing information about the file
*                               from which data to be written.
*       sGauge_Disdrometer      A structure containing the complete header data.
*                               This structure must be declared to correspond to
*                               the data file being read.
*
*  OUTPUT PARAMETERS:           None
*
*  RETURN VALUES:               TK_SUCCESS if TKreadGauge is successful.
*
*  CALLED BY:                   Main program from Fortran.
*
*  ROUTINES CALLED:             TKreadGauge()
*
******************************************************************************/
int tkreadgauge(IO_HANDLE *sGranuleHandle, void *sGauge_Disdrometer)
{
  static int status;

  status = TKreadGauge(sGranuleHandle, sGauge_Disdrometer);

  return (status);
}

/*****************************************************************************
*
*  FUNCTION STATEMENT:
*       tkwritedbraininfo(int *instrID, struct tm *sStart_time,
*                               struct tm *sEnd_time, int rain_percent)
*
*  DESCRIPTION:
*       This routine is used to call TKwriteDBRainInfo in C toolkit program.
*       This routine will only be called when compiling on the HP platform.
*
*  INPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       instrID                 GV site identifier.
*       sStart_time             Start time of VOS.
*       sEnd_time               End time of VOS.
*       rain_percent            Percent rain.
*
*  OUTPUT PARAMETERS:           None
*
*  RETURN VALUES:               TK_SUCCESS if TKwriteDBRainInfo is successful.
*
*  CALLED BY:                   Main program from Fortran.
*
*  ROUTINES CALLED:             TKwriteDBRainInfo()
*
******************************************************************************/

int tkwritedbraininfo(int instrID, struct tm *sStart_time, struct tm *sEnd_time,
                        int rain_percent)
{
  static int status;

  status = TKwriteDBRainInfo(instrID, sStart_time, sEnd_time, rain_percent);

  return(status);
}

/*****************************************************************************
*
*  FUNCTION STATEMENT:
*        int tkquerygvcoincidenceinfo(int *instrID, DATE_STR *sStartDate, 
*		       TIME_STR *sStartTime, DATE_STR *sEndDate, 
*		       TIME_STR *sEndTime, char *coinFile, char *CoinDate,
*		       char *CoinTime, float *DistOfClosApp )
*
*
*  DESCRIPTION:
*       This routine is used to call TKqueryGVCoincidenceInfo in C toolkit 
*       program.  This routine will only be called when compiling on the HP
*       platform.
*
*  INPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*	instrID			GV site identifier
*       sStartDate              Starting date
*	sStartTime		Starting time
*       sEndDate                Ending date
*	sEndTime		Ending time
*       coinFile                The name of the coincidence file (only used in TSU_ENV
*                               mode).
*
*  OUTPUT PARAMETERS:		
*       Parameter Name          Description
*       --------------          -----------
*       CoinDate                The date of coincidence
*       CoinTime                The time of coincidence
*       DistOfClosApp           The distance of closest approach
*
*  CALLED BY:                   main program
*
*  RETURN VALUES:               TK_SUCCESS, TK_FAIL, TK_NO_RECORD
*
*  ROUTINES CALLED:
*       Routine Called          Description
*       --------------          -----------
*       TKreportWarning()       This routine is used to report warning message to
*                               the console.
*       IMallocateRec()         This routine is used to allocate memory for the 
*                               data structure
*       IMopen                  Routine used to open the Database
*       IMfreeRec()             Routine to free the memory allocated earlier
*       IMclose                 Routine to close the database
*       IMquery                 Routine to query the database
*
******************************************************************************/

int tkquerygvcoincidenceinfo(int *instrID, DATE_STR *sStartDate, 
		       TIME_STR *sStartTime, DATE_STR *sEndDate, 
		       TIME_STR *sEndTime, char *coinFile, char *CoinDate,
		       char *CoinTime, float *DistOfClosApp )
{
  static int status;

  status = TKqueryGVCoincidenceInfo(instrID, sStartDate, sStartTime, 
				    sEndDate, sEndTime, coinFile,
				    CoinDate, CoinTime, DistOfClosApp );

  return(status);
}

/*
	==================================
	     HP wrapper functions for
		    TKutilGV.c
	==================================
*/

int tkreadl1gvparam( IO_HANDLE * handle , L1_GV_2BYTE *vos ,
        int *VosNum , char param_name[ ], VosSizeSTRUCT * VosSize )
{
	static int 	status;
	int		read_only_bottom_sweep = TK_FALSE ;

	status	= TKreadL1GV_2byte_in_FORTRAN( handle, vos,
	  * VosNum, param_name, read_only_bottom_sweep, VosSize ) ;

	return( status ) ;
}

int tkreadl1gv1byteparam( IO_HANDLE * handle , L1_GV_1BYTE *vos ,
        int *VosNum , char param_name[ ], VosSizeSTRUCT * VosSize )
{
	static int 	status;
	int		read_only_bottom_sweep = TK_FALSE ;

	status	= TKreadL1GV_1byte_in_FORTRAN( handle, vos,
	  * VosNum, param_name, read_only_bottom_sweep, VosSize ) ;

	return( status ) ;
}

int tkreadl1gvbasesweep( IO_HANDLE * handle , L1_GV_2BYTE *vos ,
        int *VosNum , char param_name[ ], VosSizeSTRUCT * VosSize )
{
	static int 	status;
	int		read_only_bottom_sweep = TK_FALSE ;

	status	= TKreadL1GV_2byte_in_FORTRAN( handle, vos,
	  * VosNum, param_name, read_only_bottom_sweep, VosSize ) ;

	return( status ) ;
}

int tkpickl1gvvosnum( IO_HANDLE * handle , DATE_TIME_STR * target_date,
        int *VosNum, int32 * diff_in_seconds ) 
{
	struct tm	target_date_in_C ;
	static int 	status;

	target_date_in_C.tm_year	= target_date->tkyear  -1900 ;
	target_date_in_C.tm_mon		= target_date->tkmonth -1 ;
	target_date_in_C.tm_mday	= target_date->tkday ;

	target_date_in_C.tm_hour	= target_date->tkhour ;
	target_date_in_C.tm_min		= target_date->tkminute ;
	target_date_in_C.tm_sec		= target_date->tksecond ;

	target_date_in_C.tm_isdst	= -1 ;

	status = TKpickL1GVvosNum( handle, target_date_in_C , VosNum, 
	  diff_in_seconds ) ;

	return( status ) ;
}

int tkreadl1gvdate( IO_HANDLE * handle , 
	DATE_TIME_ARRAY_STR * date_array , 
	int * num_date )
{
	static int status;

	status = TKreadL1GVdate_in_FORTRAN( handle, date_array, num_date ) ;

	return( status ) ;
}

int tkreadl1gvsummary( IO_HANDLE * handle ,
  int *VosNum, VosSummarySTRUCT *VosSummary )
{
	static int 	status ;

	status = TKreadL1GVsummary( handle, * VosNum , VosSummary ) ;

	return( status ) ;
}


int tkprintl1gvsummary( VosSummarySTRUCT *VosSummary )
{
	static int status = TK_SUCCESS ;

	/* it is necessary that the fortran "function" return
	something.  So here we have it return TK_SUCCESS all
	the time. The same thing is done with TKclose in FORTRAN. */

	TKprintL1GVsummary( VosSummary ) ;

	return( status ) ;
}


#endif
