/* DEVELOPMENT HISTORY */
/* Revision 1.185  2001/08/03 18:18:44  pkolbe
 * altitude increase change back again- gv needs to write product version
 *
 * Revision 1.184  2001/07/18 21:06:33  pkolbe
 * altitude increase changes
 *
 * Revision 1.183  1999/12/01 16:38:20  pkolbe
 * added empty granule gran input query fix
 *
 * Revision 1.182  1999/11/10 14:31:18  pkolbe
 * added case TK_SOFTWARE_VERSION to read/write metadata char (for GV)
 *
 * Revision 1.181  1999/10/26 17:49:01  pkolbe
 * added the file name to be reported when an error occurs in file status check
 *
 * Revision 1.180  1999/10/05 14:04:02  pkolbe
 * added empty string check in tk version compare function;
 * core dumps were happening for real time users on the SUN
 *
 * Revision 1.179  1999/09/13 18:12:43  pkolbe
 * finished backward compatability code changes
 *
 * Revision 1.178  1999/09/08 18:51:18  pkolbe
 * changed metadata element ssmiAdjust to tmiRolloverCoef
 *
 * Revision 1.177  1999/08/31 20:37:17  pkolbe
 * removed tk backward compatability/version checking code changes (for now
 * anyway)
 *
 * Revision 1.176  1999/08/27 19:24:14  pkolbe
 * added tk backward compatability/version checking code changes
 *
 * Revision 1.175  1999/07/14 17:31:49  pkolbe
 * Added a call to SDend to TKgetAlgorithmID. Memory leaks were happening.
 * SDstart was being called without an SDend.
 *
 * Revision 1.174  1998/09/17 17:17:54  pkolbe
 * changed the generation date format from YYYY/MM/DD to the EOSDIS
 * ascii code A format (which includes both date and time); this change
 * was made due to a request from EOSDIS to help prevent file duplication
 *
 * Revision 1.173  1998/07/08 21:46:51  pkolbe
 * changed sGranuleHandle->realTimeFlag to sGranuleHandle->subsetGranule
 *
 * Revision 1.172  1998/07/08 21:26:49  pkolbe
 * modified determineSubsetGranFlg to return TK_YES instead of TK_TRUE
 *
 * Revision 1.171  1998/07/07 21:26:57  pkolbe
 * added real time metadata code
 *
 * Revision 1.169  1998/04/27 19:09:23  pkolbe
 * added ssmi adjust coefficient metadata element code
 *
 * Revision 1.168  1998/02/11 19:32:29  slywczak
 * Modified routines TKreadMetadataChar and TKwriteMetadataChar.  Added the
 * ability to read and write the Solar Gains metadata element.  This element
 * is a list of values that are written as a character string.
 *
 * Revision 1.167  1998/01/14 14:25:09  slywczak
 * Added new routine TKgetAlgorithmID.
 *
 * Revision 1.166  1997/11/19 14:37:09  mack
 * Modified ifdef TSDIS_TK_ENV to ifndef TSU_ENV. This was needed
 * in order to add a third environment.  A TSDIS development one.
 *
 * Revision 1.165  1997/11/13 15:07:16  slywczak
 * Modified the return type of TKwriteGrid from int32 to int.
 *
 * Revision 1.164  1997/10/29 17:35:41  slywczak
 * Modified routine gIDparse.  Added limit checks to determine the number of
 * pieces in the filename before dissolving it.  This prevents overwrites in
 * memory.
 *
 * Revision 1.163  1997/09/29 22:16:01  slywczak
 * Modified routine TKopen.  Initialized the flag granFlag to 0.  When opening an
 * empty granule as the first file, the flag was not being reset and
 * subsequent opens were also returning empty granules.  Initializing this flag
 * to non-empty will make sure that the flag is explicitly set.
 *
 * Revision 1.162  1997/09/15 20:45:29  slywczak
 * Modified TKopen.  Assigned a success value to the status flag in TKopen.
 *
 * Revision 1.161  1997/09/08 20:34:22  slywczak
 * Modified functions TKopen and gIDparse.  Bubbled up the return code to TKopen
 * when an HDF file could not be opened.  Also, provided string length checking on
 * the lengths of the filename components.
 *
 * Revision 1.160  1997/08/27 19:20:52  slywczak
 * Modified routine TKclose.  During the append mode, corrected the code to
 * determine the file size and reformat the generation date.  These were added
 * after the TSS could not ingest the GV L1 data files.
 *
 * Revision 1.159  1997/08/01 12:50:54  slywczak
 * Modified routine TKwriteMetadataInt, TKreadMetadataInt, and initMetadata.
 * Removed the access for the following metadata elements:  Temperature Telemetry
 * Abnormal, Troubled SSPA Units, and Troubled LNA Units.  Changed the setting of
 * the boolean flag from an equivalence (==) to equals (=) for the Earth
 * Equatorial Radius and Flattening Ratio elements.
 *
 * Revision 1.158  1997/07/17 15:44:23  slywczak
 * Modified routine TKwriteMetadataFloat.  Changed to metadata routines to write
 * the last scan lat/long from the correct structure member.
 *
 * Revision 1.157  1997/07/09 20:40:23  slywczak
 * Modified routine TKclose.  Remove the freeing of the metadata structures so
 * that the output handle has access to the input metadata.
 *
 * Revision 1.156  1997/06/26 19:27:38  slywczak
 * Updated code based on the results of Purify.  Initialized structures.
 *
 * Revision 1.155  1997/06/25 11:11:53  slywczak
 * Modified function TKclose.  Changed the code to free the metadata list before
 * the file list.
 *
 * Revision 1.154  1997/06/23 21:47:01  slywczak
 * modified routine TKqueryGVCoincidenceInfo.  Set the isdst elements of the
 * struct tm structure to a negative value.  Then the C function mktime will not
 * apply the daylight saving time correction.
 *
 * Revision 1.153  1997/06/19 15:10:43  slywczak
 * Modified function TimesCompared.  Rewrote entire function to simplify the
 * code.
 *
 * Revision 1.152  1997/06/12 18:06:32  slywczak
 * Modified function gIDparse.  Previously, the type of product was determined
 * by the number of parts in the filename which didn't work for L3 satellite and
 * L3 GV.  Changed the function to lookup the correct product type and parse
 * the filename according to that scheme.
 *
 * Revision 1.151  1997/06/11 20:09:19  slywczak
 * Modified routine TKopen.  Changed the definition of the dirInfo pointer and
 * initialized it to NULL.  Initializing the pointer will keep garbage characters
 * from corrupting the buffer on string concatenation.
 *
 * Revision 1.150  1997/05/30 17:32:04  slywczak
 * Modified routine TKqueryGVCoincidenceInfo.  Added the pgs time routine to
 * convert from the double time (in sec) to an ASCII format (PGS_TD_TAItoUTC).
 * The return from this function now contains the milliseconds.
 *
 * Revision 1.149  1997/05/30 16:22:12  jt
 * *** empty log message ***
 *
 * Revision 1.148  1997/05/30 16:15:00  jt
 * Changed filemode condition for 2a56 and 2a57 in IO.c from "== TK_NEW_FILE" 
 * to "!= TK_APPEND" to allow for 2a56 and 2a57 read routines.
 *
 * Revision 1.147  1997/05/30 16:04:47  jt
 * Added routine  TKgetNumNetDesc for 2a56 and 2a57.                      
 *
 * Revision 1.146  1997/05/30 14:30:35  slywczak
 * Update routine gIDparse.  The code did not account for Level 3 filename (i.e.,
 * only contains 4 elements).  Fixed by making the if condition look for 4 or
 * 5 parts.
 *
 * Revision 1.145  1997/05/29 17:56:28  slywczak
 * Added the following new routines:  TimesCompared and TKqueryGVCoincidenceInfo.
 * Also, provided access to the new PR Level 1 Metadata elements.
 *
 * Revision 1.144  1997/05/16 18:25:45  slywczak
 * Modified the following functions:  TKopen, TKclose, TKwriteMetadataInt,
 * TKwriteMetadataFloat, and TKwriteMetadataChar.  The toolkit will now write
 * metadata to the HDF files during the TK_APPEND mode.
 *
 * Revision 1.143  1997/05/14 19:38:15  slywczak
 * Modified the following routines:  TKwriteMetadataInt, TKwriteMetadataChar,
 * TKreadMetadataInt, TKreadMetadataChar, and TKclose.  Added the following
 * metadata elements: ellipsoid name, temperature telemetry abnormal, number
 * of troubled SSPA units, number of troubled LNA units, data product version
 * number, toolkit version number, calibration coefficient version number,
 * and the min/max units.  Changed the radar spacing (X, Y, and Z) from ints
 * to floats.  Changed the first/last spacecraft seconds/subseconds (4 elements)
 * and the UTCF seconds/subseconds (2 elements) from long ints to unsigned
 * long ints. Modified TKclose to report when the data update for start and
 * stop times failed.
 *
 * Revision 1.142  1997/04/29 19:39:53  jt
 * Added routines TKreadGauge() and TKreadNetHeader().
 *
 * Revision 1.141  1997/04/23 14:10:36  slywczak
 * Modified routine TKseek.  Fixed a bug when TKseek was called with products
 * that have a ray header (1B21, 1C21, and 2A25).  The original routine started
 * to reset the Vdatas and SDSs at the main vgroup level (TKseek should not
 * seek through the ray header or the clutter flags).  TKseek now starts the seek
 * at the swath data.
 *
 * Revision 1.140  1997/04/22 15:13:56  slywczak
 * Modified function TKclose.  Add code to update the database with the start
 * and stop date/time for all Level 2 products.  TKclose will verify that
 * the output is a one of the valid Level 2 products, and will then call the
 * IM_GM_TIMES_UPDATE update function.  This IM routine will copy the start
 * and stop date/times from the Orbit_Metadata table to the Granule_Metadata
 * for that associated Granule_ID and Orbit_Number.
 *
 * Revision 1.139  1997/03/07 18:51:34  slywczak
 * Modified function TKremoveQuotes.  The function was replacing the first quote
 * with a blank instead of removing the quote.  Code was added to remove the
 * first quote and the function was optimized.
 *
 * Revision 1.138  1997/03/07 05:57:30  slywczak
 * Modified the function TKopen.  Added code to remove the configuration files
 * that are created for the GV L1 processing.
 *
 * Revision 1.137  1997/03/06 19:59:47  slywczak
 * Modified the TKseek routine.  Added the check for empty granules.  Previously
 * the code would have errored out, but now it will return a status code to the
 * calling application that the granule is empty.
 *
 * Revision 1.136  1997/03/06 03:41:36  slywczak
 * Removed function TKcopyScanHeader.  TKcopyScanHeader was rewritten and placed
 * in the file TKcopyHeadr.c.  The new version of the function is called for
 * each scan line of data processed.
 *
 * Revision 1.134  1997/03/04 21:21:49  jt
 * Renamed TK_ABS_ORBIT_OFF case statement in TKseek "TK_ABS_SCAN_OFF" and
 * removed old TK_ABS_SCAN_OFF case statement.
 *
 * Revision 1.132  1997/03/03 19:49:42  jt
 * Added function TKremoveQuotes.
 *
 * Revision 1.130  1997/02/27 20:58:49  slywczak
 * Update the following routines:  TKreadMetadataChar and TKwriteMetadataChar.
 * Changed the metadata parameter from TK_INPUT_ID to TK_INPUT_FILES.  In the
 * previous version of the toolkit, it was called TK_INPUT_FILES, and changed
 * to TK_INPUT_ID by mistake.  To maintain compatibility, it has been changed
 * back to the original name. (Refer to IO.h for more information).
 *
 * Revision 1.129  1997/02/19 18:46:26  piper
 * Fixed logic in TKcopy ScanHeader; check on TKseek status was outside
 * if statement containing the call to TKseek.
 *
 * Revision 1.128  1997/02/10 15:52:50  piper
 * Fixed TKseek; added type TK_ABS_ORBIT_OFF and eliminated TK_BOO/TK_BOF
 *
 * Revision 1.127  1997/02/04 16:43:36  amak
 * Increased parameter cfgFileName size from 10 to 20 in TKopen.
 *
 * Revision 1.126  1997/01/10 20:21:31  amak
 * Modified gIDparse().  Convert collectDate from string to integer type (cdate).
 *
 * Revision 1.125  1997/01/10 16:50:05  cdealy
 * Modified TKwriteDBRainInfo(). Free the insert record and close IM session
 * after failure to allocate memory for updating GV rain table
 *
 * Revision 1.124  1997/01/09 17:19:37  amak
 * Modified TKwriteDBRainInfo().  Free the insert record and close session of
 * IM after failure to allocate memory to update GV rain info.
 *
 * Revision 1.123  1997/01/07 22:43:41  amak
 * Modified gIDparse().
 *
 * Revision 1.122  1997/01/07 20:26:33  amak
 * Modified TKwriteDBRainInfo() to properly closing all IM calls.
 *
 * Revision 1.121  1997/01/03 22:38:31  amak
 * Modified gIDparse() to accomodate new add of entity datatype to GIDTOKENS.
 *
 * Revision 1.120  1996/12/24  14:29:32  amak
 * Incorporated walkthrough comments.
 * - Changed '<' and '>' to double quotes around the #include statements.
 * - Checked all return status of malloc.
 * - Added more information description to code logic.
 * - Took out TK_L1A_11 if statement in TKopen().  Toolkit does not handle
 *   binary file.
 * - Took out the code which has already been commented out in TKopen().
 * - Took out all un-informative comments in gIDparse().
 * - Replaced all hard-coded values into macros
 * - Removed all the #ifdef statement within case statement in TKwriteDBRainInfo.
 *
 * Revision 1.119  1996/12/16  20:17:13  amak
 * Added TSDIS_TK_ENV ifdef statements.  This use is embedded all the codes
 * (IM implementation) which can only use in TSDIS environment.
 *
 * Revision 1.118  1996/12/13  16:45:02  amak
 * Added description to metadata fields.
 * Added 5 PS metadata fields for GV.  TK_GV_DZCAL, TK_GV_L1C_SCALE and
 * TK_GV_ALPHA are floating point.  The implementation has been made to
 * TKreadMetadataFloat and TKwriteMetadataFloat.  TK_GV_RUNTIME_OPT and
 * TK_ANOMALY_FLAG are char.  The implementation has been made to
 * TKreadMetadataChar and TKwriteMetadataChar.
 *
 * Revision 1.117  1996/12/12  14:30:23  amak
 * Modified TKwriteMetadatInt, TKreadMetadataInt, TKwriteMetadataFloat,
 * TKreadMetadataFloat, TKwriteMetadataChar and TKreadMetadataChar.
 * The TK_SZ_ELEMENT macro has changed name into TK_SZ_ELEMENT_51.  Some
 * of the metadata fields (orbitModelName, qaParamName, browseName,
 * contact, granuleID, percentBadMissPix, maxValidChannel, minValidChannel,
 * inputID, dateGenInputFile, dataCenterSrc, sensorAlgn, scanPathModel, and
 * radarCity) have changed size (bytes).  The check of TK_SZ_ELEMENT_101 and
 * TK_SZ_ELEMENT_301 have been incorporated.
 * Took out invalid metadata entity qualityIndCmt, prRainThreshold,
 * valNetName, and numValSensors.  These fields have been taken out in
 * the file specification.
 *
 * Revision 1.116  1996/12/11  16:32:11  pshah
 * Added some more prologue to TKwriteDBRainInfo()
 *
 * Revision 1.115  1996/12/10  17:31:14  pshah
 * added Prologue
 *
 * Revision 1.114  1996/12/10  16:44:52  pshah
 * freed the memmory alloc when there is an error in inserting or opening the database
 *
 * Revision 1.113  1996/12/09  22:20:55  pshah
 * added some more code to the routine TKwriteDBRainInfo()
 *
 * Revision 1.112  1996/12/06  22:03:54  pshah
 * added a new routine TKwriteDBRainInfo() for IM interface
 *
 * Revision 1.111  1996/12/03  19:40:06  pshah
 * made modifications in gIDparse routine as per TRMM office
 *
 * Revision 1.110  1996/12/03  17:05:32  amak
 * Fixed redundant if-statement in IO.c as requested by TRMM Office.
 *
 * Revision 1.109  1996/11/18  16:40:58  dbazell
 * Changed gIDparse to check for ntok = 5, ntok = 6 or else zero the
 * token structure.  This fixed a problem with 3a46 that Dave Bolvin
 * reported.
 *
 * Revision 1.108  1996/11/07  14:08:22  dbazell
 * Added two new metadata elements:
 * - lonMaxLat (float)
 * - epochMillisec (int)
 *
 * Revision 1.107  1996/11/06  15:28:10  amak
 * Added detailed description to the routine.
 *
 * Revision 1.106  1996/11/05  15:19:19  dbazell
 * changed token to stoken in gIDparse routine
 *
 * Revision 1.105  1996/11/05  15:12:56  dbazell
 * added quotes around string characters in metadata char routines. moved
 * epoch date and epoch time to metadataint.
 *
 * Revision 1.104  1996/11/01  20:18:34  amak
 * Modified TKclose() - Call manageFiles with DELETE_ALL_LISTS to check
 * linked list file info.
 *
 * Modified TKcopyScanHeader() such that the input and output handle for
 * L1B11 and L2A12 will start from the beginning of the file rather than
 * the beginning of the orbit.
 *
 * Revision 1.103  1996/10/17  20:25:25  amak
 * Added new routines TKcopyScanHeader() and TKwriteDBRainInfo().
 *
 * Revision 1.102  1996/10/17  15:29:30  pshah
 * Made modification to TKopen() for TMI Instrument when there is
 * no Scan written  to the file and also when the # of scans is
 * less than 50 (number of perorbit scans)
 *
 * Revision 1.101  1996/09/19  16:39:10  pshah
 * Modified TKseek to handle all conditions for the file pointer
 *
 * Revision 1.100  1996/09/09  14:19:09  pshah
 * Modified code
 *
 * Revision 1.99  1996/09/09  13:41:02  pshah
 * Made modification to TKopen(), TKendOfFile(), TKseek(). All these routines will
 * now be able to handle the beginning or the end of the orbit time for TMI
 * instruments, i.e products with overlaps. Before the changes to these routines
 * the file pointer would always point to beginning or end of the file for the products
 * with or without overlaps, now for the products with overlaps the file pointer will
 * point to beginning of the orbit or the end of the orbit, while products without
 * overlaps the file pointer will point to beginning or the end of the file.
 *
 * Revision 1.98  1996/09/03  19:57:35  amak
 * Added new functions TKwriteNetHeader() and TKwriteGauge() to handle Rain
 * Gauge (2A56) and Disdrometer (2A57) products.
 *
 * Revision 1.97  1996/08/26  18:50:38  amak
 * Made modification to TKopen(), TKreadScan(), TKreadGrid(), TKreadL1GV(),
 * TKendOfFile(), TKreadHeader(), and TKclose().  All these routines are now
 * able to handle the empty granule or mistake in granule.  Before these
 * changes, the program used to bounce back a non-related warning/error
 * message.  The 'granuleFlag' which finds in all these routines is used
 * to check the granule.
 *
 * Revision 1.96  1996/07/23  19:12:11  dbazell
 * Changed strcpy(name, ptr) to strcpy(name, ptr+1) in gIDparse.c;
 * checked for ptr == NULL in first strtok(name, delim) in gIDparse.c
 *
 * Revision 1.95  1996/07/18  19:25:33  amak
 * Added prologue.
 *
 * Revision 1.94  1996/07/09  17:49:57  dbazell
 * Fixed array dimension problem in gIDparse.c.  Changed structure of
 * gIDparse routine.  Added initialization of genDate and fsize elements
 * of sGranuleHandle. Removed redundant TK_TEMP_RANGE_TYPE metadata
 * element.
 *
 * Revision 1.93  1996/06/13  20:46:07  amak
 * Added prologue.
 *
 * Revision 1.92  1996/06/13  15:16:53  dbazell
 * Made extensive changes to metadata code, added new metadata elements
 *
 * Revision 1.91  1996/06/10  14:36:13  amak
 * Added prologue.
 *
 * Revision 1.90  1996/06/07  19:43:28  amak
 * Modified the API of Metadata routines.
 *
 * Revision 1.89  1996/06/07  19:16:01  amak
 * Incorporated changes for release 2.5.2.
 *
 * Revision 1.88  1996/06/07  14:49:58  amak
 * Commented out processMetadata() and detachMetadata() from TKopen and TKclose
 * respectively.
 *
 * Revision 1.87  1996/06/03  17:24:09  amak
 * Edited prologue.
 *
 * Revision 1.83  1996/05/07  13:51:11  amak
 * Changed the prefix of the mnemonic in which the warning mnemonic must be
 * started with "W_".
 *
 * Revision 1.82  1996/04/19  15:40:45  amak
 * Made modifications to the preprocessor #include statement.  Replaced
 * TKerrorRou.h and TKwarnRou.h to TKerrHandle.h and TS_TK_15.h for new
 * error handling calls.
 *
 * Revision 1.81  1996/03/26  20:13:40  dbazell
 * Changed reportError calls to reportWarning
 *
 * Revision 1.80  1996/03/22 21:00:22  amak
 * Modified TKseek().  Completed the functionality for TK_ABS_SCAN_OFF.
 *
 * Revision 1.79  1996/03/21  21:56:04  amak
 * Added case statements for L3A46 on functions writeGrid() and readGrid().
 *
 * Revision 1.78  1996/03/04  19:14:37  amak
 * Modified TKreadMetadataInt(), TKreadMetadataFloat(), TKreadMetadataChar(),
 * TKwriteMetadataInt(), TKwriteMetadataFloat(), and TKwriteMetadataChar().
 * These modifications are based on the addition of the Product Specific
 * Metadata entities and changes on the data structure of metadata.
 *
 * Revision 1.77  1996/01/25  15:35:38  amak
 * Made Change TKwriteMetadataInt().  Formatted the printout of the time and
 * date.
 *
 * Revision 1.76  1996/01/22  20:19:51  yprasad
 * TKerrorRou.c
 *
 * Revision 1.74  1996/01/02  18:59:04  dbazell
 * Added comments explaining the internal structure of the granuleHandle
 * data structure.  Closes ARF260, from Item #20 of the Toolkit Review,
 * dated 7/14/95.
 *
 * Revision 1.73  1995/12/12 20:07:19  thyun
 * Modified type error in TKopen(), and put some comments in TKreadMetadata()
 * and TKwriteMetadata().
 *
 * Revision 1.72  1995/12/12  15:06:44  amak
 * Moved functions TKgetNvos(), TKgetNsensor(), TKgetNparm(), TKgetNcell(),
 * TKgetNray(), and TKgetNsweep() from L1_GV_ACCESS.c to IO.c
 *
 * Revision 1.71  1995/12/12  14:55:29  thyun
 * Modified TKendOfFile which compares the current number of scanlines to
 * decide if it is reached at the end of line.
 *
 * Revision 1.70  1995/12/11  16:00:54  amak
 * Took out function TKcopyHeader().  This function will not include in
 * toolkit's second release.
 *
 * Revision 1.69  1995/12/05  22:07:01  thyun
 * Modified TKreadMetadataInt.  There was semantic error reading date and
 * time correctly.
 *
 * Revision 1.68  1995/12/05  18:41:23  thyun
 * Modified comments in TKclose, TKopen, TKseek, and TKendOfFile.
 * Inserted prolog for TKreadL1GV, TKwriteL1GV, TKreadMetadataInt,
 * TKwriteMetadataFloat, and TKwriteMetadataChar.
 *
 * Revision 1.67  1995/12/04  19:50:08  amak
 * Took out TKgetCoincidence() routine because it is no longer part of the
 * requirement in Toolkit.
 *
 * Revision 1.66  1995/12/01  17:23:43  amak
 * Used TK_NUMBER_GV to determine the number of GV sites.
 *
 * Revision 1.65  1995/12/01  16:15:48  thyun
 * Mofied the prolog of TKwriteL1GV and TKreadL1GV.
 *
 * Revision 1.64  1995/12/01  15:41:06  thyun
 * Delete the initialization of currVgroup.  Also initialized nRecords with
 * -1.
 *
 * Revision 1.63  1995/11/30  21:10:18  amak
 * Added TKgetCoincidence() routine to detect the occurence of GV coincidence
 * event.
 *
 * Revision 1.62  1995/11/28  16:03:56  thyun
 * Implemented the routines, TKreadMetadataInt, TKreadMetadataFloat, TKreadMetadataChar,
 * TKwriteMetadataInt, TKwriteMetadataChar, and TKwriteMetadataFloat.
 * Also, modified TKopen and TKclose to process metadata.
 *
 * Revision 1.61  1995/11/22  20:03:18  thyun
 * Initialized sGranuleHandle->currVgroup to NULL.
 *
 * Revision 1.60  1995/11/15  23:35:30  thyun
 * Modifed TKopen an TKclose to adapt the changes in configuration structures  and
 * in Level 1B and 1C GV structures.k
 *
 * Revision 1.59  1995/10/18  20:52:20  amak
 * Made modifications after some files need to be renamed.
 *
 * Revision 1.58  1995/10/10  19:35:08  thyun
 * Created a new procedure called TKendOfFile.
 *
 * Revision 1.57  1995/10/10  15:33:03  thyun
 * Modified the program to hold the multiple and single defintions of GV radar.
 *
 * Revision 1.56  1995/09/28  18:04:15  amak
 * Showed return code value in comment blocks.
 *
 * Revision 1.55  1995/09/18  14:13:40  thyun
 * Modified TKcopyHeader after the code review.
 *
 * Revision 1.54  1995/09/14  20:18:03  thyun
 * Modified TKcopyHeader.
 *
 * Revision 1.53  1995/09/12  18:13:53  thyun
 * Modifed comments in TKcopyHeader.
 *
 * Revision 1.52  1995/09/12  18:07:55  thyun
 * Modified TKcopyHeader.
 *
 * Revision 1.51  1995/09/12  17:43:53  thyun
 * Modified the TKcopyHeader comment header block.
 *
 * Revision 1.50  1995/09/12  17:26:30  thyun
 * Inserted a function TKcopyHeader.
 *
 * Revision 1.49  1995/08/29  15:00:49  amak
 * Added more detailed descriptions in comment headers.
 *
 * Revision 1.48  1995/08/25  18:01:21  thyun
 * Assinged the some of data product's numberOfScanline with SD_UNLIMITED.
 *
 * Revision 1.47  1995/08/21  18:20:50  thyun
 * Deleted TK_READ_WRITE file mode and Assigned 1 to numberOfScanlines.
 *
 * Revision 1.46  1995/08/17  21:59:06  thyun
 * Changed pointer type sGranuleID to static type.
 *
 * Revision 1.45  1995/08/17  19:18:31  amak
 * Added IO_GV.h as header file.
 *
 * Revision 1.44  1995/08/16  19:33:23  amak
 * Changed API for routine TKopen.  Took out GRANULE_ID structure as input
 * parameter and replaced that with parameters granuleID, dataType, and
 * filemode.
 *
 * Revision 1.43  1995/08/15  20:46:44  thyun
 * Deleted a statement printCFG_STR from TKopen.  printCFG_STR was used t
 * during the testing.
 *
 * Revision 1.42  1995/08/14  13:57:07  amak
 * Simplified the logic in TKopen().
 *
 * Revision 1.41  1995/08/11  11:36:52  amak
 * Added comments for the TKreportWarning and TKreportError routines.
 *
 * Revision 1.40  1995/08/10  18:09:19  thyun
 * Modified TKopen to test how HDF responds to different types of access mode.
 * Inserted level 2 and 3 GV RADAR in TKreadGrid and TKwriteGrid.
 * Resolved semantic error in TKclose.
 *
 * Revision 1.39  1995/08/09  13:27:20  gsain
 * changed readScan_3A_25 and writeScan_3A_25 to Grid
 *
 * Revision 1.38  1995/08/03  17:45:36  amak
 * Re-modified the code because CVS couldn't do version control nicely.
 *
 * Revision 1.37  1995/08/02  18:58:15  gsain
 * added comments
 *
 * Revision 1.36  1995/08/02  18:51:01  gsain
 * added comments
 *
 * Revision 1.35  1995/08/02  18:41:02  gsain
 * removed return statements
 *
 * Revision 1.34  1995/08/02  18:34:59  amak
 * Deleted HEprint statements.
 *
 * Revision 1.33  1995/08/01  20:23:39  thyun
 * Made changes in TKopen and TKclose to update more genetic vgroup strucutres.
 *
 * Revision 1.29  1995/07/26  14:15:40  thyun
 * Defined GV vgroup strucure and corrected file mode.
 *
 * Revision 1.28  1995/07/25  15:18:31  thyun
 * Changed file mode in TKclose and TKopen.
 *
 * Revision 1.27  1995/07/21  18:30:37  thyun
 * Changed the condition checking from TK_READ_ONLY to TK_NEW_FILE in TKreadScan.
 *
 * Revision 1.26  1995/07/20  21:07:05  thyun
 * Changed the position of manageFiles in TKclose.
 *
 * Revision 1.25  1995/07/20  18:17:37  thyun
 * Changed file mode checking in TKreadScan, TKwriteScan, and TKwriteGrid.
 *
 * Revision 1.24  1995/07/20  14:16:32  amak
 * Added routines TKreadGrid() and TKwriteGrid() for Level 3 API.
 *
 * Revision 1.23  1995/07/18  20:19:07  thyun
 * Simplified the logics involved in file mode using case statements, changed the
 * parameters of TKreadScan and TKwriteScan, checked the file mode before performing
 * TKwriteScan and TKreadScan, took out level 3 stuff from TKreadScan and
 * TKwriteScan, and modified type mistakes in comments.
 *
 * Revision 1.21  1995/07/10  17:55:33  thyun
 * Modified the parameters of TKwriteScan and TKreadScan
 *
 * Revision 1.20  1995/07/10  15:14:03  thyun
 * Modified comments
 *
 * Revision 1.19  1995/07/10  15:06:15  gsain
 * Fixed syntax errors
 *
 * Revision 1.18  1995/07/10  14:44:16  gsain
 * error Routines
 *
 * Revision 1.17  1995/07/10  14:08:08  gsain
 * error Routines
 *
 * Revision 1.16  1995/07/07  20:30:50  amak
 * Added detailed comments
 *
 * Revision 1.15  1995/07/07  18:47:11  thyun
 * Modified occurances of 0 to NULL and -1 to TK_FAIL
 *
 * Revision 1.14  1995/07/07  14:08:10  thyun
 * Modified and added comments
 *
 * Revision 1.13  1995/07/05  18:55:21  amak
 * Corrected type error
 *
 * Revision 1.12  1995/06/30  19:04:44  amak
 * Added new definition.
 *
 * Revision 1.11  1995/06/30  18:28:49  thyun
 * Modified TKopen and TKclose
 *
 * Revision 1.6  1995/06/13  14:46:48  amak
 * Replacing return code 1 into TK_SUCCESS
 *
 * Revision 1.5  1995/06/13  14:28:46  amak
 * Adding more comments
 *
 * Revision 1.4  1995/06/08  18:31:58  amak
 * This is a test.
 *
 * Revision 1.3  1995/06/08  18:29:15  amak
 * added log message; added Tkseek routine
 * */

/**********************************************************************************
*
*  FILE NAME:           IO.c
*
*  DESCRIPTION:         This file contains routines that read and write data to 
*			and from HDF files.
*
*  ROUTINES CALLED:
*       Routine Name            Description
*       ------------            -----------
*       TKopen                 	This routine is used to open a data product file 
*				for reading and writing.
*       TKreportWarning         This routine records warnings in a file.
*       TKreadScan             	This routine reads a single scan from an open file
*				containing scan based satellite products.
*       TKwriteScan            	This routine writes a single scan to an open file
*				containing scan based satellite products.
*	TKreadGrid		This routine reads data for level 3 grid based
*				satellite data products, and level 2 and level 3
*				GV products.
*	TKwriteGrid		This routine writes data for level 3 grid based
*				satellite data products, and level 2 and level 3
*				GV products.
*       TKreadMetadataInt      	This routine is used to read individual integer
*                               metadata items from a file.
*       TKreadMetadataFloat    	This routine is used to read floating point
*                               metadata items from a file.
*       TKreadMetadataChar     	This routine is used to read individual character
*                               metadata items from a file.
*       TKwriteMetadataInt     	This routine is used to write individual integer
*                               metadata items to a file.
*       TKwriteMetadataFloat   	This routine is used to write individual floating
*                               point metadata items to a file.
*       TKwriteMetadataChar    	This routine is used to write individual character
*                               metadata items to a file.
*       TKseek 			This routine is used to seek the file pointer to
*                               an arbitrary scan in the file.
*       TKclose                	This routine is used to close a data product file.
*	TKreadL1GV		This routine is used to read Level 1 GV product
*				data from the HDF file and store them into sGV
*				which is Level 1 GV data structure.	
*	TKwriteL1GV		This routine is used to write Level 1 GV product
*				data into the HDF file.
*	TKendOfFile		This routine finds the number of records in the HDF
*				file the first time when it is called.  The number
*				of records is compared with the number of current 
*				scanlines.  If they are the same, it returns TK_EOF
*				which indicates that is the end of file; otherwise,
*				it returns TK_FAIL which indicates that is not the
*				end of file.
*	TKgetNvos		This routine returns the number of volume scans for
*				a given sGranuleHandle.
*       TKgetNumNetDesc         This routine returns the number of network descriptor
*                               headers for a given sGranuleHandle.
*	TKgetNsensor		This routine returns the number of sensors for each
*				volume scans.  Since there is only one sensor for
*				every volume scan, it always returns 1.
*	TKgetNparm		This routine returns the number of parameter for a 
*				given volume scan number.
*	TKgetNcell		This routine returns the number of cells for a given
*				volume scan number and a parameter number.
*	TKgetNray		This routine returns the number of rays for a given
*				volume scan number.
*	TKgetNsweep		This routine returns the number of sweeps for a given
*				volume scan number.
*	TKreadHeader		This routine is used to read product header data from 
*				a file and store them into the product data structure.
*	TKwriteHeader		This routine is used to write product header data to
*				a hdf file.
*	TKwriteNetHeader	This routine is used to write L2A56 or L2A57 Network
*				Descriptor header data to a hdf file.
*       TKreadNetHeader         This routine is used to read L2A56 or L2A57 Network
*                               Descriptor header data to a hdf file.
*	TKwriteGauge		This routine is used to write L2A56 or L2A57 data to
*				a hdf file.
*       TKreadGauge             This routine is used to read L2A56 or L2A57 data to
*                               a hdf file.
*	TKwriteDBRainInfo	This routine is used to write the input L2A52
*				information into TSDIS database.
*	TKcopyScanHeader	This routine is used to copy the scanStatus,
*				scanTime, Geolocation and Navigation fields from
*				Level 1 product to Level 2 product.
*
**********************************************************************************/

#ifndef LANGUAGE_FORTRAN
#include <string.h>
#include <math.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include "TKerrHandle.h"
#include "IO_VIRS.h"
#include "IO_TMI.h"
#include "IO_PR.h"
#include "IO_GV.h"
#include "IO_INTR_VIRS.h"
#include "IO_INTR_TMI.h"
#include "IO_INTR_PR.h"
#include "IO_INTR_GV.h"
#include "file_manager.h"
#include "hdf_routines.h"
#include "TS_TK_15.h"
#include <time.h>

#ifndef TSU_ENV
#include "IM.h"
#include "TS_IM_7.h"
#include "PGS_TD.h"
#endif

#endif



/**********************************************************************************
*
*  FUNCTION STATEMENT:
*       TKopen(char *granuleID, int dataType, 
*	       char filemode, IO_HANDLE *sGranuleHandle)
*
*  DESCRIPTION:                 This routine is used to open a data product file
*                               prior to reading or writing the product data or 
*                               metadata.
*
*  INPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*	granuleID		A character string containing the name of the file 
*				to be opened.  A maximum length of 256 characters is
*				allowed.
*	dataType		An unique identifier that specifies the type of data
*				file being read, e.g., TK_L1B_11 for the 1B-11
*				algorithm product.  A complete list of dataTypes can
*				be found in the Parameter Dictionary.
*	filemode		Access mode, READ_ONLY, WRITE_ONLY, NEW_FILE.
*				READ_ONLY opens the file in read only mode, without
*				changing the metadata; WRITE_ONLY opens the file in
*				write only mode; and NEW_FILE opens the file in write
*				only mode but initializes the metadata with default
*				values.  The metadata initialization is not currently
*				implemented.
*
*  OUTPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       sGranuleHandle          A structure passed to subsequent I/O routines.
*                               This structure is manipulated by TKopen() and
*                               other toolkit routines.
*                               Components:
*                                 *cfgSTR: structure storing HDF pointers
*                                 productID: the product ID of the file being
*                                            opened
*                                 currNumOfScanl: index to current scanline
*                                                 being accessed.
*                                 nRecords: Total number of records in the 
*                                           HDF file
*                                 mode: Access mode (e.g., read or write)
*                                 metadata: structure containing the metadat
*
*  CALLED BY:                   main program
*
*  RETURN VALUES:		W_TK_BADGIDOPEN, W_TK_FAILADGHEL, TK_SUCCESS
*				W_TK_NOGRANULEDATA when there is an empty granule
*
*  ROUTINES CALLED:
*       Routine Name            Description
*       ------------            -----------
*       parse()         	This routine parses the configuration file.
*	openHDF			This routines returns ID returned by Hopen.
*	startSD			This routines returns ID returned by SDstart.
*	getConfigFilenameAndScanline	This function finds the configuration file 
*				name using productID and returns the number of scanlines.
*	openInputVgroupL1GV	When vGroup is null, this routine searches the vgroup ids
*				and the sub-vgroup ids.  When vGroup is not null, it
*				initializes the vGroupID field in vGroups and sub-Vgroups 
*				with vgroup ids and sub-vgroup IDs.
*	manageL1GVtemplate	This routines performs a requested action.  The requestion
*				is described by opType.	
*	processObjects		This routine recursively creates HDF objects for either 
*				writing or reading from HDF file.
*	makeL1GVconfigFile	This routine is used to create a Level 1 GV configuration
*				file.
*	attachVgroup		This routine recursively attaches vgroup into the hdf file.
*	manageFiles		This procedure performs add and delete files from the
*                               list of files depending on the operation type.
*       TKreportWarning		This routine reports warning errors to the console and
*                               continues processing.
*	processHeader		This routine used to process L1B21, L1C21, and L2A25
*				header for either reading from or writing to hdf.
*	processNetworkHdr	This routines used to initialize L2A56 and L2A57 Network
*				Descriptor fields in link list form.
*	initMetadata		This routine fills the toolkit internal metadata
*                               structures for core and product specific metadata
*                               with default values.  If filemode = TK_NEW_FILE,
*                               then the metadata structures are initialized here;
*                               if filemode = TK_READ_ONLY, the information is
*                               obtained from the existing file metadata.
*
*******************************************************************************************/

int TKopen(char *granuleID, int dataType, char filemode, IO_HANDLE *sGranuleHandle)
{
  VGROUP_LINK	*lastVgroup;
  VDATA_LINK 	*vdata;
  SDS_LINK 	*sds;
  char 	cfgFileName[20];
  int32	hopenID;
  int32	sdstartID;
  int32	numOfScanlines;
  int32	status = TK_SUCCESS;
  int32	l1gvFlag;
  int32 tempRank[1];
  int32 tempNT[1];
  int32 tempNattr[1];
  int32 tempDimSize[MAX_RANK];
  char  tempSDSname[MAX_SIZE];
  int32 tempID;
  int32	currNumOfScanl = 0;
  int	j;
  char *dirInfo = NULL;
  char removeInfo[256];
  int granFlag = 0;
  char 	localTKversion[25];

  /*
  ** l1gvFlag is used in order to decide if the dataType is for level 1 GV
  ** processing.  If it is for level 1 GV processing, it returns 1, otherwise
  */
  l1gvFlag = ((dataType == TK_L1B_GV) || (dataType == TK_L1C_GV)) ? 1 : 0;

#ifdef TSU_ENV
  /*
  ** Let's help the TSU user know when his TSDISTK environment 
  ** variable is set wrong. 
  */
  checkTKenvironment( sGranuleHandle ); 
#endif

  /*
  ** Open HDF file for either reading or writing into the HDF file.
  */
  switch(filemode)
  {
    case TK_READ_ONLY:
       hopenID =   openHDF(granuleID, DFACC_RDONLY,0);
       sdstartID = startSD(granuleID, DFACC_RDONLY);
       break;

    case TK_NEW_FILE:
       hopenID =   openHDF(granuleID, DFACC_CREATE, 0);
       sdstartID = startSD(granuleID, DFACC_RDWR);
       break;

    case TK_APPEND:	/* Only for L1B_1C_GV */
	if (l1gvFlag)
        {
          hopenID =   openHDF(granuleID, DFACC_RDWR, 0);
          sdstartID = startSD(granuleID, DFACC_RDWR);
        }
        else  /* Not L1B_C_GV. */
        {
	  /* Unable to do file append with this product */
          TKreportWarning(W_TK_FAILFMGV);
	  return(W_TK_FAILFMGV);
        }
        break;

    default :
       /* Invalid filemode in TKopen. */
       TKreportWarning(W_TK_BADMODEOPEN);
       return(W_TK_BADMODEOPEN);
  }

  if ( ( hopenID == E_TK_FAILHDFOPEN ) || ( sdstartID == E_TK_FAILSDSTART ) )
    return TK_FAIL;
  /*
  ** Vstart initializes internal data structures for HDF files 
  ** containing Vgroup or Vdata.
  */
  Vstart(hopenID);

  /*
  ** Obtain the configuration file name and size of scanlies.
  */
  numOfScanlines = getConfigFilenameAndScanline(dataType, cfgFileName);

  /*
  ** If l1gvFlag is 1, do the following.
  ** 1. If it is for reading, then search the vgroup ids and the 
  **    sub-vgroup ids.  Those IDs are stored in openInputVgroupL1GV.
  ** 2. If it is for writing, then search level 1 GV template using
  **    granuleID from the internal level 1 GV template list and 
  **    reset the field inputFile with hopenID.
  */
  if (l1gvFlag)
  {
      switch(filemode)
      {
 	 case TK_READ_ONLY :
	   /* 
	    * Creates a 'L1_GV_TEMPLATE_NODE' for the VOS's in the file.
            * Obtains the vgroup and the sub-vgroup ids and stores them in static
            * variables inside openInputVgroupL1GV() 
	    */
	   status = openInputVgroupL1GV(hopenID, filemode, sdstartID, NULL, dataType);
	   break;
	    
         case TK_NEW_FILE :
	   /* 
	    * Tie the L1_GV_TEMPLATE_NODE, created by an earlier TKsetL1GVtemplate()
            * call, to the HDF file we've just opened. Do this by loading the field
            * L1_GV_TEMPLATE->inputFile with the hopenID. 
	    */
	   manageL1GVtemplate(SET_L1GV_INPUTFILE, hopenID, granuleID, NULL, -1, -1);
	   break;

	 case TK_APPEND :
           /* 
            * Creates a 'L1_GV_TEMPLATE_NODE' for the VOS's currently in the file.
            * Obtains the vgroup and the sub-vgroup ids and stores in static
            * variables in openInputVgroupL1GV() 
            */
           status = openInputVgroupL1GV(hopenID, filemode, sdstartID, NULL, dataType);

           /* 
	    * The dimensions for the new VOS to be appended into the file are read
            * from a L1_GV_TEMPLATE_NODE (which was created by an earlier
            * TKsetL1GVtemplate() call upon reading in the VOS),
            * and appended into the L1_GV_TEMPLATE_NODE for the file. 
	    */
           manageL1GVtemplate(UPDATE_L1GV_TEMPLATE, hopenID, granuleID, NULL, -1, -1);
           break;

       }

       makeL1GVconfigFile(hopenID, cfgFileName, dataType); 
  }

  /*
  ** Parse the configuration file and store the structure of the
  ** result of the parsing in sGranuleHandle->cfgSTR.
  */
  if (filemode == TK_NEW_FILE)
  {
      parse(cfgFileName, dataType, &sGranuleHandle->cfgSTR, TK_VERSION_NUMBER);
  }
  else
  {
      strcpy(localTKversion,TKgetTKversion(granuleID));
      parse(cfgFileName, dataType, &sGranuleHandle->cfgSTR, localTKversion);
  }

  /*
  ** Process L1B21, L1C21, or L2A25 PR header.
  */
  processHeader(sGranuleHandle->cfgSTR->vGroup, dataType);

  /*
  ** Process L2A56 or L2A57 Network Descriptor.
  */
  if (filemode != TK_APPEND)
    if ((dataType == TK_L2A_56) || (dataType == TK_L2A_57))
	processNetworkHdr(sGranuleHandle->cfgSTR->vGroup, dataType);


  /*
  ** If TKopen is for level 1 GV reading,then get the vgroup IDs and
  ** subVgroup IDs.
  */
  if (l1gvFlag)
  {
    if (filemode == TK_READ_ONLY)
    {
      /* 
       * Get the vgroup and sub-vgroup IDs of the vgroups in the file,
       * which were stored in static variables in the previous call to
       * openInputVgroupL1GV() , and load them into the vGroupID fields
       * in the vGroup tree structure. 
       */
      status = openInputVgroupL1GV(hopenID, filemode, sdstartID, 
				sGranuleHandle->cfgSTR->vGroup, dataType);
    }

    else if (filemode == TK_APPEND)
    {
      /* 
       * Get the vgroup and sub-vgroup IDs of the vgroups already in the file,
       * which were stored in static variables in the previous call to
       * openInputVgroupL1GV() , and load them into the vGroupID fields
       * in the vGroup tree structure. 
       */

      status = openInputVgroupL1GV(hopenID, filemode, sdstartID,
                         	sGranuleHandle->cfgSTR->vGroup, dataType);

      /* 
       * Chase across the vGroup tree structure til we get to the last VOS
       * in list. This is the new VOS which must be appended to the HDF file 
       */

      lastVgroup = sGranuleHandle->cfgSTR->vGroup->subVgroup;
      while (lastVgroup->next != NULL)
      {
        lastVgroup = lastVgroup->next;
        currNumOfScanl += 1;
      }

      /* 
       * Recursively attach the vGroup and its subVgroups for this
       * new VOS into the HDF file. This returns vGroupIDs, which are
       * loaded into the vGroup tree structure. Also assigns
       * vGroup names and classes. 
       */

      attachVgroup(hopenID, lastVgroup);
    }

    else if (filemode == TK_NEW_FILE)
    {
      /* Attach the vgroups and their sub-vgroups. */
      attachVgroup(hopenID, sGranuleHandle->cfgSTR->vGroup);

    }
  }  /* end if (l1gvFlag) */

  else  /* Not Level 1 GV */
  {
    /* 
     * If writing any non-L1GV product, then attach the vgroups and their
     * sub-vgroups. 
     */

    if (filemode == TK_NEW_FILE)
      attachVgroup(hopenID, sGranuleHandle->cfgSTR->vGroup);
  }

  /*
  ** Initialize sGranuleHandle.
  */
  sGranuleHandle->cfgSTR->hOpenID = hopenID;
  sGranuleHandle->cfgSTR->sdStartID = sdstartID;
  sGranuleHandle->productID = dataType;
  sGranuleHandle->mode = filemode;
  sGranuleHandle->nRecords = -1;
  /* sGranuleHandle->granuleFlag = TK_TRUE; */
  strcpy(sGranuleHandle->genDate, "\0");
  strcpy(sGranuleHandle->fsize, "\0");
  if (filemode == TK_NEW_FILE)
      strcpy(sGranuleHandle->TKversion,TK_VERSION_NUMBER);
  else
      strcpy(sGranuleHandle->TKversion,localTKversion);

  /* 
   * Note currNumOfScanl = (1st VOS) if not append, 
   *	  currNumOfScanl = (last VOS) if append. 
   */
  sGranuleHandle->currNumOfScanl = currNumOfScanl;

  strcpy(sGranuleHandle->dataFileName, granuleID);
  status = gIDparse(granuleID, sGranuleHandle->productID,
		    &sGranuleHandle->gIDtokens);

  /*
   * Determine if we are dealing with a real time granule.
   */
 
  sGranuleHandle->realTimeFlag = determineSubsetGranFlg(dataType); 
  
  /*
   * initMetadata fills the ps and core metadata structures with 
   * default values.  Then, if the filemode is TK_READ_ONLY, it reads
   * the metadata from the file.
   */

  initMetadata(sGranuleHandle, filemode);

  sGranuleHandle->granuleFlag = TK_TRUE;

  /*
  ** manageFiles with the parameter ADD_FILE allows to add the
  ** information of HDF file being opened into the internal list
  ** of HDF files.   This list keeps track of all the HDF files
  ** being opened.  In case of any critical error condition, all
  ** the HDF files being opened will be automatically closed.
  */    
  if (manageFiles(sGranuleHandle, 0, ADD_FILE) != TK_SUCCESS)
  {   
	/* Adding sGranuleHandle to error list failed */
	TKreportWarning(W_TK_FAILADGHEL);
	return(W_TK_FAILADGHEL);
  }

  /*
  ** Create HDF objects for either writing or reading from the HDF file.
  ** For read mode, if the file contains empty granule, returns W_TK_NOGRANULEDATA
  ** as status code, and set sGranuleHandle->granuleFlag equals to TK_FALSE.
  **/
  if ((l1gvFlag) && (filemode == TK_APPEND))
  {
        /*
        ** Access (write mode) only objects corresponding to the appending VOS.
        */
        processObjects(lastVgroup, filemode, hopenID, sdstartID,
                                numOfScanlines, &granFlag);
	if ( granFlag == W_TK_NOGRANULEDATA )
	  {
            sGranuleHandle->granuleFlag = TK_FALSE;
            return(TK_SUCCESS);
	  }
      }
  else
    {
      processObjects(sGranuleHandle->cfgSTR->vGroup, filemode, hopenID,
		     sdstartID, numOfScanlines, &granFlag);
      if ( granFlag == W_TK_NOGRANULEDATA )
        {
	  sGranuleHandle->granuleFlag = TK_FALSE;
	  return(TK_SUCCESS);
        }
    }

  if ( filemode == TK_NEW_FILE )
    if ( setSDSattributes ( sGranuleHandle ) != TK_SUCCESS )
      {
	TKreportWarning ( E_TK_SETCALINFO );
	return ( E_TK_SETCALINFO );
      }
  
  /* 
  ** The following code handles the preorbit overlap for TMI instrument.
  ** If the algorithm is 1A-11, 1B-11 or 2A-12, the file pointer will point
  ** to the beginning of the orbit instead of beginning of the file since
  ** these algorithms are products with Preorbit and Postorbit overlaps.
  */

  if ((sGranuleHandle->productID == TK_L1B_11)||
      (sGranuleHandle->productID == TK_L2A_12))
  {
    if (filemode == TK_READ_ONLY)
    {
	tempID = sGranuleHandle->cfgSTR->vGroup->subVgroup->vdata->vdataID;
	VSQuerycount(tempID, &sGranuleHandle->nRecords);
        if (sGranuleHandle->nRecords >= 100)
	{
    	   TKseek(sGranuleHandle,0,TK_ABS_SCAN_OFF); 
	   tempID = sGranuleHandle->cfgSTR->vGroup->subVgroup->vdata->vdataID;
	   VSQuerycount(tempID, &sGranuleHandle->nRecords);
 	}
	else
	{
           if (sGranuleHandle->nRecords <= 0)
             return(TK_SUCCESS);
           else
           {
	     TKreportWarning(W_TK_SCANWARNING);
	     return(W_TK_SCANWARNING);
           }
	}
    }
  }

#ifndef TSU_ENV
  if ( l1gvFlag )
    {
      strcpy ( removeInfo, "./" );
      strcat ( removeInfo, cfgFileName );
      remove ( removeInfo );
    }
#else
  if ( l1gvFlag )
    {
      dirInfo = getenv ( "TSDISTK" );
      strcpy ( removeInfo, dirInfo );
      strcat ( removeInfo, "/config/" );
      strcat ( removeInfo, cfgFileName );
      remove ( removeInfo );
    }
#endif
  /* 
  ** Return TK_SUCCESS if no error condition occured so far.
  */
  return(TK_SUCCESS);
} 



/*****************************************************************
*
* FUNCTION STATEMENT:
*       gIDparse( char *granuleID, int prodId, GIDTOKENS *stoken)
*
* DESCRIPTION:
* Parse the granuleID string, which is a set of tokens delimited
* by periods (.).  Place each token into the appropriate place
* in the token structure.
*
* INPUT PARAMETERS:
*	Parameter Name           Description
*	--------------           -----------
*	granuleID                Character string containing the name of the file
*                                and its path.
*       prodId                   The product type of the input/output product.
*
* OUTPUT PARAMETERS:
*	Parameter Name		Description
*	--------------		-----------
*	stoken                  A structure that contains the various tokens in 
*                               the granuleID: 
*
* CALLED BY:                    TKopen()
*
* RETURN VALUES:                Number of tokens parsed.
*
* ROUTINES CALLED:              None
*
***********************************************************************************/
int gIDparse(char *granuleID, int prodId, GIDTOKENS *stoken)
{
  int    ntokens;
  int    ntok = 0;
  char   *ptr, *name, parts[8][256];
  char   *delim = ".";
  char   *storeFirstPos;
  int setNull;

  /* Chop off the path:  look for the last occurance of '/', increment
   * pointer to point just after last '/' 
   *
   * If strrchr returns NULL, then there is no /, so point to beginning
   * of granuleID
   */

  for ( setNull = 0; setNull < 7; setNull++ )
    strcpy ( parts[setNull], "\0" );
  
  name = (char *) malloc(strlen(granuleID)*sizeof(char)+1);
  if (name == NULL)
	/* Memory allocation failed in gIDparse(). */
	TKreportError(E_TK_MEMFAILGIDPARSE);

  if ( (ptr = strrchr(granuleID, '/')) == NULL )
    strcpy(name, granuleID);
  else
    strcpy(name, ptr+1);

  if ( strlen ( name ) <= 46 )
    {
      sprintf(stoken->granule_ID, name);
      sprintf(stoken->granuleName, "%c%s%c", '\"', name, '\"');
    }
  else
    {
      stoken->granule_ID[0] = '\0';
      stoken->granuleName[0] = '\0';
    }
  /*
  ** Store the first position where the *name setted.  This position will
  ** lose when strtok() is called.
  */
  storeFirstPos = name; 

  /* Parse the tokens until NULL is returned */
  if ( ( (ptr = strtok(name, delim)) != NULL ) && ntok < 7 )
    strcpy(parts[ntok++],ptr);

  while ( ( (ptr = strtok(NULL, delim)) != NULL ) && ntok < 7 )
    strcpy(parts[ntok++], ptr);

  /*  
   * Initialize the datatype and collection data parts of
   * the structure.
   */

  /*
   *  The datatype and algID is determined by the toolkit;  therefore,
   *  we shouldn't have to check the lengths, since they are
   *  predetermined.
   */
  strcpy ( stoken->datatype, findAlgorithmDataType ( prodId ) ); 
  sprintf(stoken->algID, "%c%s%c", '\"', stoken->datatype, '\"');
 
  if ( strlen ( parts[1] ) <= 8 )
    {
      sprintf(stoken->collectDate, "%c%s%c", '\"', &parts[1][0], '\"');
      stoken->cdate = atoi(&parts[1][0]);
    }
  else
    {
      stoken->collectDate[0] = '\0';
      stoken->cdate = 0;
    }
  
  /* 
   *  Determine if the instrument is satellite.
   */
  if ( ( instType ( prodId ) == TK_TMI ) ||
      ( instType ( prodId ) == TK_VIRS ) ||
      ( instType ( prodId ) == TK_PR ) ||
      ( instType ( prodId ) == TK_VARIOUS ) )
    {
      if ( prodType ( prodId ) == TK_L3 )
	{
	  stoken->orbitNumber[0] = '\0';
	  if ( strlen ( parts[2] ) <= 6 )
	    sprintf(stoken->algVersion, "%c%s%c", '\"', &parts[2][0], '\"');
	  else
	    stoken->algVersion[0] = '\0';
	}
      else
	{
	  if ( strlen ( parts[2] ) <= 7 )
	    sprintf(stoken->orbitNumber, "%c%s%c", '\"', &parts[2][0], '\"');
	  else
	    stoken->orbitNumber[0] = '\0';

	  if ( strlen ( parts[3] ) <= 6 )
	    sprintf(stoken->algVersion, "%c%s%c", '\"', &parts[3][0], '\"');
	  else
	    stoken->algVersion[0] = '\0';
	}
      stoken->radar[0] = '\0';
    }
  else if ( instType ( prodId ) == TK_GV )
    {
      if ( ( prodType ( prodId ) == TK_L1 ) ||
	( ( prodType ( prodId ) == TK_L2 ) && 
	( ( prodId != TK_L2A_56 ) && ( prodId != TK_L2A_57 ) ) ) )
	{
	  if ( strlen ( parts[2] ) <= 7 )
	    sprintf(stoken->orbitNumber, "%c%s%c", '\"', &parts[2][0], '\"');
	  else
	    stoken->orbitNumber[0] = '\0';
	  
	  if ( strlen ( parts[3] ) <= 6 ) 
	    sprintf(stoken->radar, "%c%s%c", '\"', &parts[3][0], '\"');
	  else
	    stoken->radar[0] = '\0';

	  if ( strlen ( parts[4] ) )
	    sprintf(stoken->algVersion, "%c%s%c", '\"', &parts[4][0], '\"');
	  else
	    stoken->algVersion[0] = '\0';
	}
      else
	{
	  stoken->orbitNumber[0] = '\0';

	  if ( strlen ( parts[2] ) <= 6 ) 
	    sprintf(stoken->radar, "%c%s%c", '\"', &parts[2][0], '\"');
	  else
	    stoken->radar[0] = '\0';

	  if ( strlen ( parts[3] ) <= 6 )
	    sprintf(stoken->algVersion, "%c%s%c", '\"', &parts[3][0], '\"');
	  else
	    stoken->algVersion[0] = '\0';
	}
    }
  else
    {
      stoken->datatype[0] = '\0';
      stoken->algID[0] = '\0';
      stoken->collectDate[0] = '\0';
      stoken->cdate = 0;
      stoken->orbitNumber[0] = '\0';
      stoken->algVersion[0] = '\0';
      stoken->radar[0] = '\0';
    }

  free(storeFirstPos);
  return ntok;
}



/***********************************************************************************
*
*  FUNCTION STATEMENT:
*       TKreadScan(IO_HANDLE *sGranuleHandle, void *sSwathData)
*
*  DESCRIPTION:
*       This routine is used to read product data from a file and store them into
*       the product data structure.
*
*  INPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       sGranuleHandle          A structure containing information about the file
*                               from which data can be obtained.  sGranuleHandle 
*                               is returned by TKopen().
*
*  OUTPUT PARAMETERS:           
*       Parameter Name          Description
*       --------------          -----------
*       sSwathData              A structure containing the complete scanline data
*                               which is obtained from the input file.  This
*                               structure must be declared to correspond to the
*                               data file being read.  The structure of sSwathData 
*				is manipulated by TKreadScan() and other toolkit 
*				routines.
*
*  CALLED BY:                   main program
*
*  RETURN VALUES:               W_TK_BADPIDRS, W_TK_BADREADFMODE, TK_SUCCESS,
*				W_TK_NOGRANULEDATA
*
*  ROUTINES CALLED:
*       readScan_1B_01(), readScan_1B_11(), readScan_1B_21(), readScan_2A_12(),
*       readScan_2A_21(), readScan_2A_23(), readScan_2A_25(), readScan_2A_31(),
*       TKreportWarning()
*
***********************************************************************************/

int TKreadScan(IO_HANDLE *sGranuleHandle, void *sSwathData)
{
  sGranuleHandle->currNumOfScanl++;
  
  if (sGranuleHandle->mode == TK_READ_ONLY)
    {
      /**
       ** Check for empty granule status.  If granuleFlag equals TK_TRUE, file 
       ** contains scan info.  If TK_FALSE, that is an empty granule file.
       **/
      if (sGranuleHandle->granuleFlag == TK_TRUE)
	{
	  switch (sGranuleHandle->productID) 
	    {
	    case TK_L1B_01:  
	      return(readScan_1B_01(sGranuleHandle, sSwathData));
	    case TK_L1B_11: 
	      return(readScan_1B_11(sGranuleHandle, sSwathData));
	    case TK_L1B_21: 
	    case TK_L1C_21: 
	      return(readScan_1B_21(sGranuleHandle, sSwathData));
	    case TK_L2A_12: 
	      return(readScan_2A_12(sGranuleHandle, sSwathData));
	    case TK_L2A_21: 
	      return(readScan_2A_21(sGranuleHandle, sSwathData));
	    case TK_L2A_23: 
	      return(readScan_2A_23(sGranuleHandle, sSwathData));
	    case TK_L2A_25: 
	      return(readScan_2A_25(sGranuleHandle, sSwathData));
	    case TK_L2N_25: 
	      return(readScan_2N_25(sGranuleHandle, sSwathData));
	    case TK_L2B_31: 
	      return(readScan_2B_31(sGranuleHandle, sSwathData));
	    case TK_L1B_11_R1:
	      return ( readScan_1B_11_R1 ( sGranuleHandle, sSwathData ) );
	    case TK_L2A_12_R1:
	      return ( readScan_2A_12_R1 ( sGranuleHandle, sSwathData ) );
	    case TK_L2A_23_R1:
	      return ( readScan_2A_23_R1 ( sGranuleHandle, sSwathData ) );
	    case TK_L2A_25_R1:
	      return ( readScan_2A_25_R1 ( sGranuleHandle, sSwathData ) );
	    case TK_L2A_25_R2:
	      return ( readScan_2A_25_R2 ( sGranuleHandle, sSwathData ) );
	    default :
	      /* Invalid ProductID in TKreadScan */
	      TKreportWarning(W_TK_BADPIDRS);
	      return(W_TK_BADPIDRS);
	    }
	}
      else
	return(W_TK_NOGRANULEDATA);
    }
  else
    {
      /* Invalid file mode in TKreadScan */
      TKreportWarning(W_TK_BADREADFMODE);
      return(W_TK_BADREADFMODE);
    }
  return(TK_SUCCESS);
}


/***********************************************************************************
*
*  FUNCTION STATEMENT:
*       TKwriteScan(IO_HANDLE *sGranuleHandle, void *sSwathData)
*
*  DESCRIPTION:
*       This routine is used to write product data to a file.
*
*  INPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       sGranuleHandle          A structure containing information about the file
*                               from which data being written.  sGranuleHandle 
*                               is returned by TKopen().
*
*       sSwathData              A structure containing the complete scanline data
*                               which can be written to the output file.  This
*                               structure must be declared to correspond to the
*                               data file being written.  The structure of sScanData 
*				is manipulated by TKwriteScan() and other toolkit 
*				routines.
*
*  OUTPUT PARAMETERS:		None
*
*  CALLED BY:                   main program
*
*  RETURN VALUES:               W_TK_BADPIDWS, W_TK_BADWRITEFMODE, TK_SUCCESS
*
*  ROUTINES CALLED:
*       writeScan_1B_01(), writeScan_1B_11(), writeScan_1B_21(), writeScan_2A_12(),
*       writeScan_2A_21(), writeScan_2A_23(), writeScan_2A_25(), writeScan_2A_31(),
*       TKreportWarning()
*
***********************************************************************************/

int TKwriteScan(IO_HANDLE *sGranuleHandle, void *sSwathData)
{
  sGranuleHandle->currNumOfScanl++;
  
  if (sGranuleHandle->mode == TK_NEW_FILE)
    {
      switch (sGranuleHandle->productID) 
	{
	case TK_L1B_01:  
	  return(writeScan_1B_01(sGranuleHandle, sSwathData));
	case TK_L1B_11: 
	  return(writeScan_1B_11(sGranuleHandle, sSwathData));
	case TK_L1B_21: 
	case TK_L1C_21: 
	  return(writeScan_1B_21(sGranuleHandle, sSwathData));
	case TK_L2A_12: 
	  return(writeScan_2A_12(sGranuleHandle, sSwathData));
	case TK_L2A_21: 
	  return(writeScan_2A_21(sGranuleHandle, sSwathData));
	case TK_L2A_23: 
	  return(writeScan_2A_23(sGranuleHandle, sSwathData));
	case TK_L2A_25: 
	  return(writeScan_2A_25(sGranuleHandle, sSwathData));
	case TK_L2N_25: 
	  return(writeScan_2N_25(sGranuleHandle, sSwathData));
	case TK_L2B_31: 
	  return(writeScan_2B_31(sGranuleHandle, sSwathData));
	case TK_L1B_11_R1:
	  return ( writeScan_1B_11_R1 ( sGranuleHandle, sSwathData ) );
	case TK_L2A_12_R1:
	  return ( writeScan_2A_12_R1 ( sGranuleHandle, sSwathData ) );
	case TK_L2A_23_R1:
	  return ( writeScan_2A_23_R1 ( sGranuleHandle, sSwathData ) );
	case TK_L2A_25_R1:
	  return ( writeScan_2A_25_R1 ( sGranuleHandle, sSwathData ) );
	case TK_L2A_25_R2:
	  return ( writeScan_2A_25_R2 ( sGranuleHandle, sSwathData ) );
	default :
	  /* Invalid ProductID in TKwriteScan */
	  TKreportWarning(W_TK_BADPIDWS);
	  return(W_TK_BADPIDWS);
	}
    }
  else
    {
      /* Invalid file mode in TKwriteScan */
      TKreportWarning(W_TK_BADWRITEFMODE);
      return(W_TK_BADWRITEFMODE);
    }
  
  return(TK_SUCCESS);
}


/***********************************************************************************
*
*  FUNCTION STATEMENT:
*       TKreadGrid(IO_HANDLE *sGranuleHandle, void *sGrid)
*
*  DESCRIPTION:
*       This routine is used to read product data from a file and store them into
*       the product data structure.
*
*  INPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       sGranuleHandle          A structure containing information about the file
*                               from which data can be written.  sGranuleHandle 
*                               is returned by TKopen().
*
*  OUTPUT PARAMETERS:           
*       Parameter Name          Description
*       --------------          -----------
*       sGrid             	A structure containing the complete scanline data
*                               which is obtained from the input file.  This
*                               structure must be declared to correspond to the
*                               data file being read.  The structure of sGrid 
*				is manipulated by TKreadGrid() and other toolkit 
*				routines.
*
*  CALLED BY:                   main program
*
*  RETURN VALUES:               W_TK_BADPIDRG, W_TK_READGRIDMODE, TK_SUCCESS,
*				W_TK_NOGRANULEDATA
*
*  ROUTINES CALLED:
*       readGrid_3A_11(), readGrid_3A_25(), readGrid_3A_26(), readGrid_3B_31(),
*       readGrid_3B_42(), readGrid_3B_43(), readGrid_3A_46(),
*	readGVGrid_2A_53_single(), readGVGrid_2A_53_mult(),
*	readGVGrid_2A_54_single(), readGVGrid_2A_54_mult(),
*	readGVGrid_2A_55_single(), readGVGrid_2A_55_mult(),
*       readGVGrid_3A_53_single(), readGVGrid_3A_53_mult(),     
*       readGVGrid_3A_54_single(), readGVGrid_3A_54_mult(),	
*	readGVGrid_3A_46()
*
***********************************************************************************/

int TKreadGrid(IO_HANDLE *sGranuleHandle, void *sGrid)
{
  sGranuleHandle->currNumOfScanl++;

  if (sGranuleHandle->mode == TK_READ_ONLY)
  {
    /**
     ** Check for empty granule status.  If granuleFlag equals TK_TRUE, file 
     ** contains scan info.  If TK_FALSE, that is an empty granule file.
     **/
    if (sGranuleHandle->granuleFlag == TK_TRUE)
    {
      switch (sGranuleHandle->productID)
      {
              case TK_L2A_53S:
                   return(readGVGrid_2A_53_single(sGranuleHandle, sGrid));
              case TK_L2A_53TX:
                   return(readGVGrid_2A_53_TX_mult(sGranuleHandle, sGrid));
              case TK_L2A_53FL:
                   return(readGVGrid_2A_53_FL_mult(sGranuleHandle, sGrid));
              case TK_L2A_54S:
                   return(readGVGrid_2A_54_single(sGranuleHandle, sGrid));
              case TK_L2A_54TX:
                   return(readGVGrid_2A_54_TX_mult(sGranuleHandle, sGrid));
              case TK_L2A_54FL:
                   return(readGVGrid_2A_54_FL_mult(sGranuleHandle, sGrid));
              case TK_L2A_55S:
                   return(readGVGrid_2A_55_single(sGranuleHandle, sGrid));
              case TK_L2A_55TX:
                   return(readGVGrid_2A_55_TX_mult(sGranuleHandle, sGrid));
              case TK_L2A_55FL:
                   return(readGVGrid_2A_55_FL_mult(sGranuleHandle, sGrid));
              case TK_L3A_11:
                   return(readGrid_3A_11(sGranuleHandle, sGrid));
              case TK_L3A_12:
                   return(readGrid_3A_12(sGranuleHandle, sGrid));
              case TK_L3A_25:
                   return(readGrid_3A_25(sGranuleHandle, sGrid));
              case TK_L3A_26:
                   return(readGrid_3A_26(sGranuleHandle, sGrid));
              case TK_L3A_27:
                   return(readGrid_3A_27(sGranuleHandle, sGrid));
              case TK_L3B_31:
                   return(readGrid_3B_31(sGranuleHandle, sGrid));
              case TK_L3B_42:
                   return(readGrid_3B_42(sGranuleHandle, sGrid));
              case TK_L3B_43:
                   return(readGrid_3B_43(sGranuleHandle, sGrid));
              case TK_L3A_53S:
                   return(readGVGrid_3A_53_single(sGranuleHandle, sGrid));
              case TK_L3A_53TX:
                   return(readGVGrid_3A_53_TX_mult(sGranuleHandle, sGrid));
              case TK_L3A_53FL:
                   return(readGVGrid_3A_53_FL_mult(sGranuleHandle, sGrid));
              case TK_L3A_54S:
                   return(readGVGrid_3A_54_single(sGranuleHandle, sGrid));
              case TK_L3A_54TX:
                   return(readGVGrid_3A_54_TX_mult(sGranuleHandle, sGrid));
              case TK_L3A_54FL:
                   return(readGVGrid_3A_54_FL_mult(sGranuleHandle, sGrid));
              case TK_L3A_55:
                   return(readGVGrid_3A_55(sGranuleHandle, sGrid));
              case TK_L3A_46:
                   return(readGVGrid_3A_46(sGranuleHandle, sGrid));
              default :
		   /* Invalid ProductID in TKreadGrid */
                   TKreportWarning(W_TK_BADPIDRG);
		   return(W_TK_BADPIDRG);
      }
    }
    else
	return(W_TK_NOGRANULEDATA);
  }
  else
  {
      /* Invalid file mode in TKreadGrid */
      TKreportWarning(W_TK_READGRIDMODE);
      return(W_TK_READGRIDMODE);
  }
  return(TK_SUCCESS);
}


/***********************************************************************************
*
*  FUNCTION STATEMENT:
*       TKwriteGrid(IO_HANDLE *sGranuleHandle, void *sGrid)
*
*  DESCRIPTION:
*       This routine is used to write product data to a file.
*
*  INPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       sGranuleHandle          A structure containing information about the file
*                               from which data can be written.  sGranuleHandle 
*                               is returned by TKopen().
*
*       sGrid              	A structure containing the complete scanline data
*                               which can be written to the output file.  This
*                               structure must be declared to correspond to the
*                               data file being written.  The structure of sScanData 
*				is manipulated by TKwriteGrid() and other toolkit 
*				routines.
*
*  OUTPUT PARAMETERS:		None
*
*  CALLED BY:                   main program
*
*  RETURN VALUES:               W_TK_BADPIDWS, W_TK_WRITEGRIDMODE, TK_SUCCESS
*
*  ROUTINES CALLED:
*       writeGrid_3A_11(), writeGrid_3A_25(), writeGrid_3A_26(), writeGrid_3B_31(),
*       writeGrid_3B_42(), writeGrid_3B_43(), writeGrid_3A_46(), TKreportWarning(),
*	writeGVGrid_2A_53_single(), readGVGrid_2A_53_mult(),
*	writeGVGrid_2A_54_single(), readGVGrid_2A_54_mult(),
*	writeGVGrid_2A_55_single(), readGVGrid_2A_55_mult(),
*       writeGVGrid_3A_53_single(), readGVGrid_3A_53_mult(),
*       writeGVGrid_3A_54_single(), readGVGrid_3A_54_mult(),
*       writeGVGrid_3A_55()
*
***********************************************************************************/

int TKwriteGrid(IO_HANDLE *sGranuleHandle, void *sGrid)
{
  sGranuleHandle->currNumOfScanl++;

  if (sGranuleHandle->mode != TK_READ_ONLY)
  {
      switch (sGranuleHandle->productID)
      {
               case TK_L2A_53S:
                   return(writeGVGrid_2A_53_single(sGranuleHandle, sGrid));
               case TK_L2A_53TX:
                   return(writeGVGrid_2A_53_TX_mult(sGranuleHandle, sGrid));
               case TK_L2A_53FL:
                   return(writeGVGrid_2A_53_FL_mult(sGranuleHandle, sGrid));
               case TK_L2A_54S:
                   return(writeGVGrid_2A_54_single(sGranuleHandle, sGrid));
               case TK_L2A_54TX:
                   return(writeGVGrid_2A_54_TX_mult(sGranuleHandle, sGrid));
               case TK_L2A_54FL:
                   return(writeGVGrid_2A_54_FL_mult(sGranuleHandle, sGrid));
               case TK_L2A_55S:
                   return(writeGVGrid_2A_55_single(sGranuleHandle, sGrid));
               case TK_L2A_55TX:
                   return(writeGVGrid_2A_55_TX_mult(sGranuleHandle, sGrid));
               case TK_L2A_55FL:
                   return(writeGVGrid_2A_55_FL_mult(sGranuleHandle, sGrid));
               case TK_L3A_11:
                    return(writeGrid_3A_11(sGranuleHandle, sGrid));
               case TK_L3A_12:
                    return(writeGrid_3A_12(sGranuleHandle, sGrid));
               case TK_L3A_25:
                    return(writeGrid_3A_25(sGranuleHandle, sGrid));
               case TK_L3A_26:
                    return(writeGrid_3A_26(sGranuleHandle, sGrid));
               case TK_L3A_27:
                    return(writeGrid_3A_27(sGranuleHandle, sGrid));
               case TK_L3A_53S:
                   return(writeGVGrid_3A_53_single(sGranuleHandle, sGrid));
               case TK_L3A_53TX:
                   return(writeGVGrid_3A_53_TX_mult(sGranuleHandle, sGrid));
               case TK_L3A_53FL:
                   return(writeGVGrid_3A_53_FL_mult(sGranuleHandle, sGrid));
               case TK_L3A_54S:
                   return(writeGVGrid_3A_54_single(sGranuleHandle, sGrid));
               case TK_L3A_54TX:
                   return(writeGVGrid_3A_54_TX_mult(sGranuleHandle, sGrid));
               case TK_L3A_54FL:
                   return(writeGVGrid_3A_54_FL_mult(sGranuleHandle, sGrid));
               case TK_L3A_55:
                   return(writeGVGrid_3A_55(sGranuleHandle, sGrid));
               case TK_L3B_31:
                    return(writeGrid_3B_31(sGranuleHandle, sGrid));
               case TK_L3B_42:
                    return(writeGrid_3B_42(sGranuleHandle, sGrid));
               case TK_L3B_43:
                    return(writeGrid_3B_43(sGranuleHandle, sGrid));
               case TK_L3A_46:
                    return(writeGVGrid_3A_46(sGranuleHandle, sGrid));
               default :
		    /* Invalid ProductID in TKwriteGrid */
                    TKreportWarning(W_TK_BADPIDWS);
		    return(W_TK_BADPIDWS);
      }
  }
  else
  {
      /* Invalid file mode in TKwriteGrid */
      TKreportWarning(W_TK_WRITEGRIDMODE);
      return(W_TK_WRITEGRIDMODE);
  }
  
  return(TK_SUCCESS);
}



/***********************************************************************************
*
*  FUNCTION STATEMENT:
*	TKreadL1GV(IO_HANDLE *sGranuleHandle, void *sGV)	       
*
*  DESCRIPTION:	
*	This routine is used to read Level 1 GV product data from the HDF file and
*	store them into sGV which is Level 1 GV data structure.
*
*  INPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       sGranuleHandle          A structure containing information about the file
*                               from which data to be read.  sGranuleHandle
*                               is returned by TKopen().
*
*  OUTPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*	sGV			A structure containing one volume scan data which
*				is obtained from the input file.  This structure
*				must be declared to correspond to the data file
*				being read.  The structure of sGV is manipulated
*				by TKreadL1GV and other toolkit routines.
*
*  CALLED BY:                   main program
*
*  RETURN VALUES:               W_TK_BADPIDRGV, W_TK_BADFMODERG, TK_SUCCESS,
*				W_TK_NOGRANULEDATA
*
*  ROUTINES CALLED:
*	readGV_L1B_1C(), TKreportWarning()
*
***********************************************************************************/

int TKreadL1GV(IO_HANDLE *sGranuleHandle, void *sGV)
{
  sGranuleHandle->currNumOfScanl++;

  if (sGranuleHandle->mode == TK_READ_ONLY)
  {
    /**
     ** Check for empty granule status.  If granuleFlag equals TK_TRUE, file 
     ** contains scan info.  If TK_FALSE, that is an empty granule file.
     **/
    if (sGranuleHandle->granuleFlag == TK_TRUE)
    {
      switch (sGranuleHandle->productID)
      {
      	      case TK_L1B_GV :
		   return (readGV_L1B_1C(sGranuleHandle, sGV, sGranuleHandle->productID));
      	      case TK_L1C_GV :
		   return (readGV_L1B_1C(sGranuleHandle, sGV, sGranuleHandle->productID));
		   break;
              default :
		   /* Invalid product ID in TKreadL1GV. */
		   TKreportWarning(W_TK_BADPIDRGV);
		   return(W_TK_BADPIDRGV);
      }
    }
    else
	return(W_TK_NOGRANULEDATA);
  }
  else
  {
      /* Invalid file mode in TKreadL1GV.*/
      TKreportWarning(W_TK_BADFMODERGV);
      return(W_TK_BADFMODERGV);
  }
  return(TK_SUCCESS);
}




/***********************************************************************************
*
*  FUNCTION STATEMENT:
*       TKwriteL1GV(IO_HANDLE *sGranuleHandle, void *sGV)        
*
*  DESCRIPTION:
*	This routine is used to write Level 1 GV product data into the HDF file.
*
*  INPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       sGranuleHandle          A structure containing information about the file
*                               from which data can be written.  sGranuleHandle
*                               is returned by TKopen().
*	sGV			A structure containing one volume scan data which
*				can be written to the HDF file.  This structure
*				must be declared to correspond to the data file
*				being written.  The structure of sGV is manipulated
*				by TKwriteL1GV and other toolkit routines.
*
*  OUTPUT PARAMETERS:		None.
*
*  CALLED BY:                   main program
*
*  RETURN VALUES:               W_TK_BADPIDWGV, W_TK_BADFMODEWGV, TK_SUCCESS
*
*  ROUTINES CALLED:
*	writeGV_L1B_1C(), TKreportWarning()
*
***********************************************************************************/

int TKwriteL1GV(IO_HANDLE *sGranuleHandle, void *sGV)
{
  sGranuleHandle->currNumOfScanl++;

  if (sGranuleHandle->mode != TK_READ_ONLY)
  {
      switch (sGranuleHandle->productID) 
      {
      	      case TK_L1B_GV :
		   return (writeGV_L1B_1C(sGranuleHandle, sGV, sGranuleHandle->productID));
      	      case TK_L1C_GV :
		   return (writeGV_L1B_1C(sGranuleHandle, sGV, sGranuleHandle->productID));
		   break;
	      default :
		   /* Invalid product ID in TKwriteL1GV. */
		   TKreportWarning(W_TK_BADPIDWGV);
		   return(W_TK_BADPIDWGV);
      }
  }
  else
  {
      /* Invalid file mode in TKwriteL1GV.*/
      TKreportWarning(W_TK_BADFMODEWGV);
      return(W_TK_BADFMODEWGV);
  }
  return(TK_SUCCESS);
}



/***********************************************************************************
*
*  FUNCTION STATEMENT:
*       TKreadMetadataInt(IO_HANDLE *sGranuleHandle, 
*                           int parameter, 
*                           int *value) 
*
*  DESCRIPTION:
*       This routine is used to read individual integer metadata items from a
*       file.
*
*  INPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       sGranuleHandle          A structure containing information about the file
*                               from which data to be read.  sGranuleHandle 
*                               is returned by TKopen().
*       parameter               A string containing the name of the metadata
*                               element to be read from the file.
*
*  OUTPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       value                   The integer value corresponding to the
*                               metadata element specified by "parameter".
*
*  CALLED BY:                   main program
*
*  RETURN VALUES:               W_TK_BADPARMRI, W_TK_BADFILEMODERI, TK_SUCCESS
*
*  ROUTINES CALLED:
*	TKreportWarning(), TKreportWarning()
*
***********************************************************************************/
int TKreadMetadataInt(IO_HANDLE *sGranuleHandle, int parameter, void *value)
{
  char *ptr;
  char tempString[5];
  short sizeOfDorT;
  long int *intValue = (long int *) value;
  unsigned long int *uintValue = ( unsigned long int * ) value;
  DATE_STR *dateValue = (DATE_STR *) value;
  TIME_STR *timeValue = (TIME_STR *) value; 

  if (sGranuleHandle->mode == TK_READ_ONLY)
  {
      switch (parameter)
      {
	case TK_ORBIT_NUMBER : /* Orbit number. */
	  *intValue = atoi(sGranuleHandle->metadata.coreMetadata.orbitNumber.value);
	  break;

	case TK_MISSING_DATA : /* Missing Data. */
	  *intValue = atoi(sGranuleHandle->metadata.psMetadata.missingData.value);
	  break;

	case TK_ORBIT_SIZE : /* Orbit Size. */
	  *intValue = atoi(sGranuleHandle->metadata.psMetadata.orbitSize.value);
	  break;

	case TK_FIRST_SCAN_UTC_MILLISEC : /* Orbit First Scan UTC Milliseconds */ 
         *intValue = atoi(sGranuleHandle->metadata.psMetadata.firstScanUTCmsec.value);
          break;

	case TK_FIRST_SCAN_SC_SECS : /* Orbit First Scantime - Spacecraft clock - seconds */
          *uintValue = strtoul (sGranuleHandle->metadata.psMetadata.firstScanSCsec.value,
				(char **) NULL, 0);
          break;

	case TK_FIRST_SCAN_SC_SUBSECS : /* Orbit First Scantime-Spacecraft clock-subseconds */
          *uintValue = strtoul(sGranuleHandle->metadata.psMetadata.firstScanSCsubsec.value,
			       (char **) NULL, 0);
          break;

	case TK_LAST_SCAN_UTC_MILLISEC : /* Orbit Last Scan UTC Milliseconds */
          *intValue = atoi(sGranuleHandle->metadata.psMetadata.lastScanUTCmsec.value);
          break;

	case TK_LAST_SCAN_SC_SECS : /* Orbit Last Scantime - Spacecraft clock - seconds */
          *uintValue = strtoul(sGranuleHandle->metadata.psMetadata.lastScanSCsec.value,
			       (char **) NULL, 0);
          break;

	case TK_LAST_SCAN_SC_SUBSECS : /* Orbit Last Scantime - Spacecraft clock - subseconds */
          *uintValue = strtoul (sGranuleHandle->metadata.psMetadata.lastScanSCsubsec.value,
				(char **) NULL, 0);
          break;

	case TK_UTCF_SECONDS : /* UTCF seconds */
          *uintValue = strtoul (sGranuleHandle->metadata.psMetadata.utcfSec.value, 
				(char **) NULL, 0);
          break;

	case TK_UTCF_SUBSECONDS : /* UTCF Subseconds */
          *uintValue = strtoul (sGranuleHandle->metadata.psMetadata.utcfSubsec.value,
				(char **) NULL, 0);
          break;

	case TK_LEAP_SECS_FLAG : /* Leap Seconds Flag*/
          *intValue = atoi(sGranuleHandle->metadata.psMetadata.leapSecsFlag.value);
          break;

	case TK_NUM_VOS : /* Number of VOS */
          *intValue = atoi(sGranuleHandle->metadata.psMetadata.numVOS.value);
          break;

        case TK_RADAR_GRID_SIZE_X : /* Radar Grid Size X */
          *intValue = atoi(sGranuleHandle->metadata.psMetadata.radarGridSizeX.value);
          break;

        case TK_RADAR_GRID_SIZE_Y : /* Radar Grid Size Y */
          *intValue = atoi(sGranuleHandle->metadata.psMetadata.radarGridSizeY.value);
          break;
        
        case TK_RADAR_GRID_SIZE_Z : /* Radar Grid Size Z */
          *intValue = atoi(sGranuleHandle->metadata.psMetadata.radarGridSizeZ.value);
          break;

        case TK_UTCF_FLAG : /* UTCF Flag */
          *intValue = atoi(sGranuleHandle->metadata.psMetadata.utcfFlag.value);
          break;

	case TK_ORBIT_ADJUST : /* Orbit Adjust Flag */
          *intValue = atoi(sGranuleHandle->metadata.coreMetadata.orbitAdjFlag.value);
          break;

	case TK_ATTITUDE_MODE : /* Attitude Mode Flag */
          *intValue = atoi(sGranuleHandle->metadata.coreMetadata.attitudeMode.value);
          break;

	case TK_KEP_EPOCH_MILLISEC : /* Epoch Milliseconds */
          *intValue = atoi(sGranuleHandle->metadata.coreMetadata.kepEpochMillisec.value);
          break;

/* altitude increase change */
	case TK_PRODUCT_VERSION:
/* TK 5.7.2 add instType || condition */
	  if ((versionCompare("5.7",sGranuleHandle->TKversion) >= 0)
                    || (instType(sGranuleHandle->productID) == TK_GV ))
          {
	      *intValue = atoi ( sGranuleHandle->metadata.psMetadata.productVersion.value );
          }
          else
	      /* Invalid parameter in TKreadMetadataInt. */
          {
	      TKreportWarning(W_TK_BADPARMRI);
      	      return(W_TK_BADPARMRI);
          }
	  break;

	case TK_CAL_COEFF_VERSION:
	  *intValue = atoi ( sGranuleHandle->metadata.psMetadata.calCoeffVersion.value );
	  break;

	case TK_SOFTWARE_VERSION:
	  *intValue = atoi ( sGranuleHandle->metadata.psMetadata.softwareVersion.value );
	  break;

	case TK_DATABASE_VERSION:
	  *intValue = atoi ( sGranuleHandle->metadata.psMetadata.databaseVersion.value );
	  break;

	case TK_UTC_MILLISEC_ON_EQUATOR:
	  *intValue = atoi ( sGranuleHandle->metadata.psMetadata.millisecOnEquator.value );
	  break;

	case TK_CENTER_SCAN_UTC_MILLISEC:
	  *intValue = atoi ( sGranuleHandle->metadata.psMetadata.centerScanUTCMillisec.value );
	  break;

	case TK_NUM_OF_RAIN_SCANS:
	  *intValue = atoi ( sGranuleHandle->metadata.psMetadata.numOfRainScans.value );
	  break;

	default  :
	  switch(parameter)
 	  {
	    case TK_BEGIN_DATE : /* Begin Date. */
	      ptr = sGranuleHandle->metadata.coreMetadata.beginDate.value;
	      sizeOfDorT = 4;
	      break;

	    case TK_BEGIN_TIME : /* Begin Time. */
	      ptr = sGranuleHandle->metadata.coreMetadata.beginTime.value;
	      sizeOfDorT = 2;
	      break;

	    case TK_END_DATE : /* End Date. */
	      ptr = sGranuleHandle->metadata.coreMetadata.endDate.value;
	      sizeOfDorT = 4;
	      break;

	    case TK_END_TIME : /* End Time. */
	      ptr = sGranuleHandle->metadata.coreMetadata.endTime.value;
	      sizeOfDorT = 2;
	      break;

	    case TK_GEN_DATE : /* Generation Date */
	      ptr = sGranuleHandle->metadata.psMetadata.generationDate.value;
	      sizeOfDorT = 4;
	      break;

            case TK_FIRST_SCAN_UTC_DATE : /* Orbit First Scan UTC Date */
              ptr = sGranuleHandle->metadata.psMetadata.firstScanUTCdate.value;
              sizeOfDorT = 4;
              break;

            case TK_FIRST_SCAN_UTC_TIME : /* Orbit First Scan UTC Time */
              ptr = sGranuleHandle->metadata.psMetadata.firstScanUTCtime.value;
              sizeOfDorT = 2;
              break;

            case TK_LAST_SCAN_UTC_DATE : /* Orbit Last Scan UTC Date */
              ptr = sGranuleHandle->metadata.psMetadata.lastScanUTCdate.value;
              sizeOfDorT = 4;
              break;

            case TK_LAST_SCAN_UTC_TIME : /* Orbit Last Scan UTC Time */
              ptr = sGranuleHandle->metadata.psMetadata.lastScanUTCtime.value;
              sizeOfDorT = 2;
              break;

            case TK_KEP_EPOCH_DATE : /* Epoch Date */
              ptr = sGranuleHandle->metadata.coreMetadata.kepEpochDate.value;
              sizeOfDorT = 4;
              break;

            case TK_KEP_EPOCH_TIME : /* Epoch Time */
              ptr = sGranuleHandle->metadata.coreMetadata.kepEpochTime.value;
              sizeOfDorT = 2;
              break;

            case TK_UTC_DATE_ON_EQUATOR :
              ptr = sGranuleHandle->metadata.psMetadata.UTCDateOnEquator.value;
              sizeOfDorT = 4;
	      break;

            case TK_UTC_TIME_ON_EQUATOR :
              ptr = sGranuleHandle->metadata.psMetadata.UTCTimeOnEquator.value;
              sizeOfDorT = 2;
              break;

            case TK_CENTER_SCAN_UTC_DATE :
              ptr = sGranuleHandle->metadata.psMetadata.centerScanUTCDate.value;
              sizeOfDorT = 4;
	      break;

            case TK_CENTER_SCAN_UTC_TIME :
              ptr = sGranuleHandle->metadata.psMetadata.centerScanUTCTime.value;
              sizeOfDorT = 2;
              break;

	    default  :
	      /* Invalid parameter in TKreadMetadataInt. */
	      TKreportWarning(W_TK_BADPARMRI);
      	      return(W_TK_BADPARMRI);
	
	  }

	  /*
	  ** When sizeOfDorT is 4, that means it is date.
	  */
	  if (sizeOfDorT == 4)
          {
	      memset(tempString, '\0', sizeof(tempString));
	      tempString[0] = '\0';
	      strncpy(tempString, ptr, sizeOfDorT);
	      ptr += sizeOfDorT + 1;
	      dateValue->tkyear = atoi(tempString);

	      memset(tempString, '\0', sizeof(tempString));
	      tempString[0] = '\0';
	      strncpy(tempString, ptr, 2);
	      ptr += 3;
	      dateValue->tkmonth = atoi(tempString);

	      memset(tempString, '\0', sizeof(tempString));
	      tempString[0] = '\0';
	      strncpy(tempString, ptr, 2);
	      dateValue->tkday = atoi(tempString);
	  }
	  
	  /*
          ** When sizeOfDorT is 2, that means it is time.
          */
	  if (sizeOfDorT == 2)
  	  {
	      memset(tempString, '\0', sizeof(tempString));
	      tempString[0] = '\0';
	      strncpy(tempString, ptr, sizeOfDorT);
	      ptr += sizeOfDorT + 1;
	      timeValue->tkhour = atoi(tempString);

	      memset(tempString, '\0', sizeof(tempString));
	      tempString[0] = '\0';
	      strncpy(tempString, ptr, 2);
	      ptr += 3;
	      timeValue->tkminute = atoi(tempString);

	      memset(tempString, '\0', sizeof(tempString));
	      tempString[0] = '\0';
	      strncpy(tempString, ptr, 2);
	      timeValue->tksecond = atoi(tempString);
	  }
	  break;
      }
      return(TK_SUCCESS);
  }
  else
  {
      /* Invalid filemode in TKreadMetadataInt. */
      TKreportWarning(W_TK_BADFILEMODERI);
      return(W_TK_BADFILEMODERI);
  }
  return(TK_SUCCESS);
}
/***********************************************************************************
*
*  FUNCTION STATEMENT:
*       TKreadMetadataFloat(IO_HANDLE *sGranuleHandle, 
*                            int parameter, 
*                            float *value) 
*
*  DESCRIPTION:
*       This routine is used to read floating point metadata items from a
*       file.
*
*  INPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       sGranuleHandle          A structure containing information about the file
*                               from which metadata can be read.  sGranuleHandle 
*                               is returned by TKopen().
*       parameter               A string containing the name of the metadata
*                               element to be read from the file.
*
*  OUTPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       value                   The float value corresponding to the
*                               metadata element specified by "parameter".
*
*  CALLED BY:                   main program
*
*  RETURN VALUES:               W_TK_BADPARMRF, W_TK_BADFILEMODERF, TK_SUCCESS
*
*  ROUTINES CALLED:        
*	TKreportWarning()
*
***********************************************************************************/
int TKreadMetadataFloat(IO_HANDLE *sGranuleHandle, int parameter, float *value)
{
  char tempValue[TK_SZ_ELEMENT_51];
  if (sGranuleHandle->mode == TK_READ_ONLY)
  {
      switch (parameter)
      {
	case TK_NUM_DATA_GAP :  /* The number of data gaps in the data in the  */
				/* orbit (satellite data) or granule (GV data) */
	  strcpy(tempValue, sGranuleHandle->metadata.psMetadata.numDataGap.value);
	  break;

	case TK_RADAR_WAVELENGTH : /* Radar wave length. */
	  strcpy(tempValue, sGranuleHandle->metadata.psMetadata.radarWavelength.value);
	  break;

	case TK_MIN_REF_THRESHOLD : /* Min Ref Threshold. */
	  strcpy(tempValue, sGranuleHandle->metadata.psMetadata.minRefThreshold.value);
	  break;

	case TK_DATA_GAP : /* Data Gap */
          strcpy(tempValue, sGranuleHandle->metadata.psMetadata.dataGap.value);
          break;

	case TK_DAY_NIGHT : /* Percentage scans during the orbit in daytime mode */
          strcpy(tempValue, sGranuleHandle->metadata.psMetadata.dayNight.value);
          break;

	case TK_NUM_ORBITS : /* Mean Motion */
          strcpy(tempValue, sGranuleHandle->metadata.coreMetadata.meanMotion.value);
          break;

	case TK_BEGIN_SOLAR_BETA : /* Solar Beta Angle at Beginning of Granule */
          strcpy(tempValue, sGranuleHandle->metadata.coreMetadata.beginSolarBeta.value);
          break;

	case TK_END_SOLAR_BETA : /* Solar Beta Angle at End of Granule */
          strcpy(tempValue, sGranuleHandle->metadata.coreMetadata.endSolarBeta.value);
          break;

	case TK_EQ_RADIUS : /* Equatorial radius of the earth ellipsoid */
	  strcpy(tempValue, sGranuleHandle->metadata.coreMetadata.earthEqRad.value);
	  break;

	case TK_FLATTENING_RATIO : /* Denominator of Flattening Ratio */
	  strcpy(tempValue, sGranuleHandle->metadata.coreMetadata.flatteningRatio.value);
	  break;

	case TK_KEP_SEMI_MAJOR_AXIS : /* Half of the long axis of the orbit ellipse */
          strcpy(tempValue, sGranuleHandle->metadata.coreMetadata.kepSemiMajorAxis.value);
          break;

	case TK_KEP_MEAN_ANOMALY : /* Angle around the orbit at the Epoch Time about */
				   /* the Ellipse center from the ascending node     */
          strcpy(tempValue, sGranuleHandle->metadata.coreMetadata.kepMeanAnomaly.value);
          break;

	case TK_KEP_RIGHT_ASCEN_NODE : /* Right Ascension in Geocentric Inertial */
				       /* Coordinates of the north bound equator */
				       /* crossing				 */
          strcpy(tempValue, sGranuleHandle->metadata.coreMetadata.kepRightAscenNode.value);
          break;

	case TK_KEP_ARG_OF_PERIGEE : /* Angle from the ascending node to perigee */
          strcpy(tempValue, sGranuleHandle->metadata.coreMetadata.kepArgOfPerigee.value);
          break;

	case TK_KEP_ECCENTRICITY : /* Eccentricity of ellipse */
          strcpy(tempValue, sGranuleHandle->metadata.coreMetadata.kepEccentricity.value);
          break;

	case TK_KEP_INCLINATION : /* Angle between Orbit plane and Earth Equatorial */
				  /* plane					    */
          strcpy(tempValue, sGranuleHandle->metadata.coreMetadata.kepInclination.value);
          break;

	case TK_WEST_BOUND_COORD : /* The degree value for the west longitude of */
				   /* boundary					 */
          strcpy(tempValue, sGranuleHandle->metadata.coreMetadata.westBoundCoord.value);
          break;

	case TK_EAST_BOUND_COORD : /* The degree value for the east longitude of */
				   /* boundary					 */
          strcpy(tempValue, sGranuleHandle->metadata.coreMetadata.eastBoundCoord.value);
          break;

	case TK_NORTH_BOUND_COORD : /* The degree value for the north latitude of */
				    /* boundary					  */
          strcpy(tempValue, sGranuleHandle->metadata.coreMetadata.northBoundCoord.value);
          break;

	case TK_SOUTH_BOUND_COORD : /* The degree value for the south latitude of */
				    /* boundary					  */
          strcpy(tempValue, sGranuleHandle->metadata.coreMetadata.southBoundCoord.value);
          break;

	case TK_CENTER_POINT_LAT : /* Latitude of center point of product */
          strcpy(tempValue, sGranuleHandle->metadata.coreMetadata.centerPointLat.value);
          break;

	case TK_CENTER_POINT_LON : /* Longitude of center point of product */
          strcpy(tempValue, sGranuleHandle->metadata.coreMetadata.centerPointLon.value);
          break;

	case TK_RADIUS : /* Distance in km from point */
          strcpy(tempValue, sGranuleHandle->metadata.coreMetadata.radius.value);
          break;

	case TK_LATITUDE_RES : /* The minimum difference between two adjacent latitude */
			       /* values expressed in Geographic Coordinate units of   */
			       /* measure.					       */
          strcpy(tempValue, sGranuleHandle->metadata.coreMetadata.latitudeRes.value);
          break;

	case TK_LONGITUDE_RES : /* The minimum difference between two adjacent longitude */
				/* values expressed in Geographic Coordinate units of    */
				/* measure						 */
          strcpy(tempValue, sGranuleHandle->metadata.coreMetadata.longitudeRes.value);
          break;

        case TK_FILE_SIZE : /* */
          strcpy(tempValue, sGranuleHandle->metadata.coreMetadata.fileSize.value);
          break;

        case TK_LON_OF_MAX_LAT : /* Longitude of Maximum Latitude */
          strcpy(tempValue, sGranuleHandle->metadata.coreMetadata.lonMaxLat.value);
          break;

        case TK_RADAR_ORIGIN_LAT : /* Radar Grid Origin Latitude */
          strcpy (tempValue, sGranuleHandle->metadata.psMetadata.radarOriginLat.value);
          break;

        case TK_RADAR_ORIGIN_LON : /* Radar Grid Origin Longitude */
          strcpy (tempValue, sGranuleHandle->metadata.psMetadata.radarOriginLon.value);
          break;

        case TK_RADAR_ORIGIN_ALT : /* Radar Grid Origin Altitude */
          strcpy (tempValue, sGranuleHandle->metadata.psMetadata.radarOriginAlt.value);
          break;

        case TK_GV_DZCAL: /* Radar calibration offset */
          strcpy(tempValue, sGranuleHandle->metadata.psMetadata.dzcal.value);
          break;

        case TK_GV_L1C_SCALE: /* Scaling factor for 1C-51 mask */
          strcpy(tempValue, sGranuleHandle->metadata.psMetadata.gvL1Cscale.value);
          break;

        case TK_GV_ALPHA: /* Correction for gaseous two-way attenuation */
          strcpy(tempValue, sGranuleHandle->metadata.psMetadata.alpha.value);
          break;
	  
        case TK_RADAR_SPACING_X : /* Radar Grid Spacing X */
          strcpy (tempValue, sGranuleHandle->metadata.psMetadata.radarSpacingX.value);
          break;
	  
        case TK_RADAR_SPACING_Y : /* Radar Grid Spacing Y */
          strcpy ( tempValue, sGranuleHandle->metadata.psMetadata.radarSpacingY.value);
          break;
	  
        case TK_RADAR_SPACING_Z : /* Radar Grid Spacing Z */
          strcpy ( tempValue, sGranuleHandle->metadata.psMetadata.radarSpacingZ.value);
          break;

	case TK_LON_ON_EQUATOR:
	  strcpy ( tempValue, sGranuleHandle->metadata.psMetadata.lonOnEquator.value );
	  break;

	case TK_FIRST_SCAN_LAT:
	  strcpy ( tempValue, sGranuleHandle->metadata.psMetadata.firstScanLat.value );
	  break;

	case TK_FIRST_SCAN_LON:
	  strcpy ( tempValue, sGranuleHandle->metadata.psMetadata.firstScanLon.value );
	  break;

	case TK_LAST_SCAN_LAT:
	  strcpy ( tempValue, sGranuleHandle->metadata.psMetadata.lastScanLat.value );
	  break;

	case TK_LAST_SCAN_LON:
	  strcpy ( tempValue, sGranuleHandle->metadata.psMetadata.lastScanLon.value );
	  break;

	default  :
	  /* Invalid parameter in TKreadMetadataFloat. */ 
	  TKreportWarning(W_TK_BADPARMRF);
      	  return(W_TK_BADPARMRF);
      }

      *value = atof(tempValue);
  }
  else
  {
      /* Invalid filemode in TKreadMetadataFloat. */
      TKreportWarning(W_TK_BADFILEMODERF);
      return(W_TK_BADFILEMODERF);
  }
  return(TK_SUCCESS);
}





/***********************************************************************************
*
*  FUNCTION STATEMENT:
*       TKreadMetadataChar(IO_HANDLE *sGranuleHandle, 
*                           int parameter, 
*                           char *value) 
*
*  DESCRIPTION:
*       This routine is used to read individual character metadata items from a
*       file.
*
*  INPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       sGranuleHandle          A structure containing information about the file
*                               from which data can be obtained.  sGranuleHandle 
*                               is returned by TKopen().
*       parameter               A string containing the name of the metadata
*                               element to be read from the file.
*
*  OUTPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       value                   The character value corresponding to the
*                               metadata element specified by "parameter".
*
*  CALLED BY:                   main program
*
*  RETURN VALUES:               W_TK_BADPARMRC, W_TK_BADFILEMODERC, TK_SUCCESS
*
*  ROUTINES CALLED:          
*	TKreportWarning()
*       TKremoveQuotes(char *value)
*
***********************************************************************************/
int TKreadMetadataChar(IO_HANDLE *sGranuleHandle, int parameter,  char *value)
{

  if (sGranuleHandle->mode == TK_READ_ONLY)
  {
      switch (parameter)
      {
/* altitude increase change */
	case TK_PRODUCT_VERSION : /* Version of the product */
	  strcpy(value, sGranuleHandle->metadata.psMetadata.productVersion.value);
	  break;

	case TK_ALGORITHM_VERSION : /* Version of the algorithm */
	  strcpy(value, sGranuleHandle->metadata.psMetadata.algorithmVersion.value);
	  break;
	
	case TK_ALGORITHM_ID : /* Algorithm ID. */
	  strcpy(value, sGranuleHandle->metadata.psMetadata.algorithmID.value);
	  break;

	case TK_INPUT_FILES: /* Input ID */
	  strcpy(value, sGranuleHandle->metadata.psMetadata.inputID.value);
	  break;

	case TK_GEN_DATE_INPUT_FILES : /* Date of Generation of Input Files */
	  strcpy(value, sGranuleHandle->metadata.psMetadata.dateGenInputFile.value);
	  break;

	case TK_DATA_CENTER_SRC : /* Data Center Source of Input Files */
	  strcpy(value, sGranuleHandle->metadata.psMetadata.dataCenterSrc.value);
	  break;
  
	case TK_EPHEM_FILENAME : /* Ephemeris File ID */
	  strcpy(value, sGranuleHandle->metadata.coreMetadata.ephemFilename.value);
	  break;

	case TK_RADAR_NAME : /* Radar Site Name */
	  strcpy(value, sGranuleHandle->metadata.psMetadata.radarName.value);
	  break;

	case TK_RADAR_CITY : /* Radar City */
	  strcpy(value, sGranuleHandle->metadata.psMetadata.radarCity.value);
	  break;

	case TK_RADAR_STATE : /* Radar State */
	  strcpy(value, sGranuleHandle->metadata.psMetadata.radarState.value);
	  break;

	case TK_RADAR_COUNTRY : /* Radar Country */
	  strcpy(value, sGranuleHandle->metadata.psMetadata.radarCountry.value);
	  break;

	case TK_PERCENT_BAD_MISS_PIXEL : /* Percent of Bad or Missing Pixels */
	  strcpy(value, sGranuleHandle->metadata.psMetadata.percentBadMissPix.value);
	  break;

	case TK_DATA_ACCURACY : /* Data Accuracy */
	  strcpy(value,sGranuleHandle->metadata.psMetadata.dataAccuracy.value);
          break;

	case TK_MAX_VALID_CHANNEL : /* Maximum valid Value of Channel */
	  strcpy(value,sGranuleHandle->metadata.psMetadata.maxValidChannel.value);
          break;

	case TK_MIN_VALID_CHANNEL : /* Minimum Valid Value of Channel */
	  strcpy(value, sGranuleHandle->metadata.psMetadata.minValidChannel.value);
          break;

	case TK_SENSOR_ALGN : /* Sensor alignment */
          strcpy(value, sGranuleHandle->metadata.coreMetadata.sensorAlgn.value);
          break;

	case TK_SENSOR_ALGN_CHAN_OFFSET : /* Sensor alignment channel offset */
          strcpy(value, sGranuleHandle->metadata.coreMetadata.sensorAlgnChanOff.value);
          break;

	case TK_SCAN_PATH_MODEL : /* Parameters describing the scan path as used */
				  /* for pixel geolocation			 */
          strcpy(value, sGranuleHandle->metadata.coreMetadata.scanPathModel.value);
          break;

	case TK_SCAN_PATH_PARAM : /* Scan Path parameters per channel */
          strcpy(value, sGranuleHandle->metadata.coreMetadata.scanPathParam.value);
          break;

	case TK_GRANULE_ID : /* TSDIS granule ID */
	  strcpy(value, sGranuleHandle->metadata.coreMetadata.granuleID.value);
	  break;

	case TK_DATA_ID : /* ID of ECS Data Object */
	  strcpy(value, sGranuleHandle->metadata.coreMetadata.dataID.value);
	  break;

	case TK_SPAT_COV_TYPE : /* Spatial Coverage Type */
	  strcpy(value, sGranuleHandle->metadata.coreMetadata.spatCovType.value);
	  break;

	case TK_ORBIT_MODEL_NAME : /* The reference name to the orbital model to be  */
				   /* used to calculate the geolocation of this data */
				   /* to determine global spatial extent	     */
	  strcpy(value, sGranuleHandle->metadata.coreMetadata.orbitModelName.value);
	  break;

	case TK_GEO_COORD_UNITS : /* Units of measure used for the latitude and */
				  /* longitude resolution values		*/
	  strcpy(value, sGranuleHandle->metadata.coreMetadata.geoCoordUnits.value);
	  break;

	case TK_TEMPOR_RNG_TYPE : /* Temporal Range Type */
	  strcpy(value, sGranuleHandle->metadata.coreMetadata.temporRngType.value);
	  break;

	case TK_QA_PARAM_NAME : /* QA Parameter name */
	  strcpy(value, sGranuleHandle->metadata.coreMetadata.qaParamName.value);
	  break;

	case TK_QA_PARAM_VALUE : /* QA Parameter Value */
	  strcpy(value, sGranuleHandle->metadata.coreMetadata.qaParamValue.value);
	  break;

	case TK_REPRO_STAT : /* Reprocessing Status */
	  strcpy(value, sGranuleHandle->metadata.coreMetadata.reproStat.value);
	  break;

	case TK_BROWSE_NAME : /* Browse Package Reference */
	  strcpy(value, sGranuleHandle->metadata.coreMetadata.browseName.value);
	  break;

	case TK_CONTACT : /* Name of algorithm developer related to this granule */
	  strcpy(value, sGranuleHandle->metadata.coreMetadata.contact.value);
	  break;

	case TK_GV_RUNTIME_OPT:	/* Runtime options for algorithm including */
				/* QC parameters used.			   */
	  strcpy(value, sGranuleHandle->metadata.psMetadata.runtimeOption.value);
          break;

	case TK_ANOMALY_FLAG:	/* Indication of the reason of the empty granule */
	  strcpy(value, sGranuleHandle->metadata.psMetadata.anomalyFlag.value);
          break;

	case TK_TOOLKIT_VERSION:
	  strcpy ( value, sGranuleHandle->metadata.psMetadata.toolkitVersion.value );
	  break;
	  
	case TK_MIN_MAX_UNITS:
	  strcpy ( value, sGranuleHandle->metadata.psMetadata.minMaxUnits.value );
	  break;

	case TK_ELLIPSOID_NAME:
	  strcpy ( value, sGranuleHandle->metadata.coreMetadata.ellipsoidName.value );
	  break;

	case TK_TOTAL_QUALITY_CODE:
	  strcpy ( value, sGranuleHandle->metadata.psMetadata.totalQualityCode.value );
	  break;

	case TK_SOLAR_GAINS:
	  strcpy ( value, sGranuleHandle->metadata.psMetadata.solarGains.value );
	  break;

        case TK_TMI_ROLLOVER_COEF:
          strcpy ( value, sGranuleHandle->metadata.psMetadata.tmiRolloverCoef.value );
          break;

        case TK_SOFTWARE_VERSION:
          strcpy( value, sGranuleHandle->metadata.psMetadata.softwareVersion.value );
          break;

        case TK_LATITUDE_RES : /* latitude resolution */
          strcpy( value, sGranuleHandle->metadata.coreMetadata.latitudeRes.value );
          break;

        case TK_LONGITUDE_RES : /* longitude resolution */
          strcpy( value, sGranuleHandle->metadata.coreMetadata.longitudeRes.value );
          break;

	default  :
	  /* Invalid parameter in TKreadMetadataChar. */
	  TKreportWarning(W_TK_BADPARMRC);
          return(W_TK_BADPARMRC);
      }
  }
  else
  {
      /* Invalid filemode in TKreadMetadataChar. */
      TKreportWarning(W_TK_BADFILEMODERC);
      return(W_TK_BADFILEMODERC);
  }

  TKremoveQuotes(value);
                  
  return(TK_SUCCESS);
}


/***********************************************************************************
*
*  FUNCTION STATEMENT:
*       TKwriteMetadataInt(IO_HANDLE *sGranuleHandle, 
*                           int parameter, 
*                           int *value) 
*
*  DESCRIPTION:
*       This routine is used to write individual integer metadata items from a
*       file.
*
*  INPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       sGranuleHandle          A structure containing information about the file
*                               from which metadata can be written.  sGranuleHandle 
*                               is returned by TKopen().
*       parameter               A string containing the name of the metadata
*                               element to be read from the file.
*
*  OUTPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       value                   The integer value corresponding to the
*                               metadata element specified by "parameter".
*
*  CALLED BY:                   main program
*
*  RETURN VALUES:              W_TK_BADVALUESIZEWI, W_TK_BADVALUESIZEW,
*                              W_TK_BADPARMWI, TK_SUCCESS
*  ROUTINES CALLED:             
*	TKreportWarning()
*
***********************************************************************************/
int TKwriteMetadataInt(IO_HANDLE *sGranuleHandle, int parameter, void *value)
{
  char tempValue[TK_SZ_ELEMENT_51];
  long int *intValue = (long int *) value;
  unsigned long int *uintValue = (unsigned long int *) value;
  DATE_STR *dateValue = (DATE_STR *) value;
  TIME_STR *timeValue = (TIME_STR *) value;

  if ( (sGranuleHandle->mode == TK_NEW_FILE) || (sGranuleHandle->mode == TK_APPEND ) )
  {
      switch(parameter)
      {
	case TK_BEGIN_DATE : /* Begin Date. */
	case TK_END_DATE : /* End Date. */
	case TK_GEN_DATE : /* Generation Date */
	case TK_FIRST_SCAN_UTC_DATE : /* Orbit First Scan UTC Date */
	case TK_LAST_SCAN_UTC_DATE : /* Orbit Last Scan UTC Date */
	case TK_KEP_EPOCH_DATE: /* Epoch Date */
	case TK_UTC_DATE_ON_EQUATOR:
	case TK_CENTER_SCAN_UTC_DATE:
	  sprintf(tempValue, "%4d/%02d/%02d", dateValue->tkyear, 
					 dateValue->tkmonth,
					 dateValue->tkday);
	  break;
	case TK_BEGIN_TIME : /* Begin Time. */
	case TK_END_TIME : /* End Time. */
	case TK_FIRST_SCAN_UTC_TIME : /* Orbit First Scan UTC Time */
	case TK_LAST_SCAN_UTC_TIME : /* Orbit Last Scan UTC Time */
	case TK_KEP_EPOCH_TIME: /* Epoch Time */
	case TK_UTC_TIME_ON_EQUATOR:
	case TK_CENTER_SCAN_UTC_TIME:
	  sprintf(tempValue, "%02d:%02d:%02d", timeValue->tkhour,
					 timeValue->tkminute,
					 timeValue->tksecond);
	  break;

	case TK_FIRST_SCAN_SC_SECS:
	case TK_FIRST_SCAN_SC_SUBSECS:
	case TK_LAST_SCAN_SC_SECS:
	case TK_LAST_SCAN_SC_SUBSECS:
	case TK_UTCF_SECONDS:
	case TK_UTCF_SUBSECONDS:
	  sprintf ( tempValue, "%u", *uintValue );
	  break;

	default  :
          sprintf(tempValue, "%d", *intValue);
	  break;
      }

      switch (parameter)
      {
	case TK_ORBIT_NUMBER : /* Orbit Number. */
	  if (strlen(tempValue) < TK_SZ_ELEMENT_51 )
	  {
	    strcpy(sGranuleHandle->metadata.coreMetadata.orbitNumber.value, tempValue);
	    sGranuleHandle->metadata.coreMetadata.orbitNumber.booleanFlag = TK_TRUE;
	  }
	  else {
	    /* Size of value out of range in TKwriteMetadataInt.*/
	    TKreportWarning(W_TK_BADVALUESIZEWI);
	    return (W_TK_BADVALUESIZEWI);
	  }
	  break;

	case TK_BEGIN_DATE : /* Begin Date. */
	  if (strlen(tempValue) < TK_SZ_ELEMENT_51 )
	  {
	    strcpy(sGranuleHandle->metadata.coreMetadata.beginDate.value, tempValue);
	    sGranuleHandle->metadata.coreMetadata.beginDate.booleanFlag = TK_TRUE;
	  }
	  else {
	    /* Size of value out of range in TKwriteMetadataInt.*/
	    TKreportWarning(W_TK_BADVALUESIZEWI);
	    return (W_TK_BADVALUESIZEWI);
	  }
	  break;

	case TK_BEGIN_TIME :/* Begin Time. */
	  if (strlen(tempValue) < TK_SZ_ELEMENT_51 )
	  {
	    strcpy(sGranuleHandle->metadata.coreMetadata.beginTime.value, tempValue);
	    sGranuleHandle->metadata.coreMetadata.beginTime.booleanFlag = TK_TRUE;
	  }
	  else
	  {
	     /* Size of value out of range in TKwriteMetadataInt.*/
	     TKreportWarning(W_TK_BADVALUESIZEWI);
	     return (W_TK_BADVALUESIZEWI);
	  }
	  break;

	case TK_END_DATE : /* End Date. */
	  if (strlen(tempValue) < TK_SZ_ELEMENT_51 )
	  {
	    strcpy(sGranuleHandle->metadata.coreMetadata.endDate.value, tempValue);
	    sGranuleHandle->metadata.coreMetadata.endDate.booleanFlag = TK_TRUE;
	  }
	  else
	  {
	     /* Size of value out of range in TKwriteMetadataInt.*/
	     TKreportWarning(W_TK_BADVALUESIZEWI);
	     return (W_TK_BADVALUESIZEWI);
	  }
	  break;

	case TK_END_TIME : /* End Time. */
	  if (strlen(tempValue) < TK_SZ_ELEMENT_51 )
	  {
	    strcpy(sGranuleHandle->metadata.coreMetadata.endTime.value, tempValue);
	    sGranuleHandle->metadata.coreMetadata.endTime.booleanFlag = TK_TRUE;
	  }
	  else
	  {
	     /* Size of value out of range in TKwriteMetadataInt.*/
	     TKreportWarning(W_TK_BADVALUESIZEWI);
	     return (W_TK_BADVALUESIZEWI);
	  }
	  break;

	case TK_MISSING_DATA : /* Missing Data. */
	  if (strlen(tempValue) < TK_SZ_ELEMENT_51 )
	  {
	    strcpy(sGranuleHandle->metadata.psMetadata.missingData.value, tempValue);
	    sGranuleHandle->metadata.psMetadata.missingData.booleanFlag = TK_TRUE;
	  }
	  else
	  {
	     /* Size of value out of range in TKwriteMetadataInt.*/
	     TKreportWarning(W_TK_BADVALUESIZEWI);
	     return (W_TK_BADVALUESIZEWI);
	  }
	  break;

	case TK_ORBIT_SIZE : /* Orbit Size. */
	  if (strlen(tempValue) < TK_SZ_ELEMENT_51 )
	  {
	    strcpy(sGranuleHandle->metadata.psMetadata.orbitSize.value, tempValue);
	    sGranuleHandle->metadata.psMetadata.orbitSize.booleanFlag = TK_TRUE;
	  }
	  else
	  {
	     /* Size of value out of range in TKwriteMetadataInt.*/
	     TKreportWarning(W_TK_BADVALUESIZEWI);
	     return (W_TK_BADVALUESIZEWI);
	  }
	  break;

        case TK_GEN_DATE : /* Generation Date */
          if (strlen(tempValue) < TK_SZ_ELEMENT_51 )
	  {
	    strcpy(sGranuleHandle->metadata.psMetadata.generationDate.value, tempValue);
	    sGranuleHandle->metadata.psMetadata.generationDate.booleanFlag = TK_TRUE;
	  }
          else
          {
             /* Size of value out of range in TKwriteMetadataInt.*/
             TKreportWarning(W_TK_BADVALUESIZEWI);
             return (W_TK_BADVALUESIZEWI);
          }
          break;

        case TK_ORBIT_ADJUST : /* Orbit Adjust Flag */
          if (strlen(tempValue) < TK_SZ_ELEMENT_51 )
	  {
            strcpy(sGranuleHandle->metadata.coreMetadata.orbitAdjFlag.value, tempValue);
	    sGranuleHandle->metadata.coreMetadata.orbitAdjFlag.booleanFlag = TK_TRUE;
	  }
          else
          {
             /* Size of value out of range in TKwriteMetadataInt.*/
             TKreportWarning(W_TK_BADVALUESIZEWI);
             return (W_TK_BADVALUESIZEWI);
          }
          break;

        case TK_ATTITUDE_MODE : /* Attitude Mode Flag */
          if (strlen(tempValue) < TK_SZ_ELEMENT_51 )
	  {
            strcpy(sGranuleHandle->metadata.coreMetadata.attitudeMode.value, tempValue);
	    sGranuleHandle->metadata.coreMetadata.attitudeMode.booleanFlag = TK_TRUE;
	  }
          else
          {
             /* Size of value out of range in TKwriteMetadataInt.*/
             TKreportWarning(W_TK_BADVALUESIZEWI);
             return (W_TK_BADVALUESIZEWI);
          }
          break;

        case TK_FIRST_SCAN_UTC_DATE : /* Orbit First Scan UTC Date */
          if (strlen(tempValue) < TK_SZ_ELEMENT_51 )
	  {
	    strcpy(sGranuleHandle->metadata.psMetadata.firstScanUTCdate.value, tempValue);
	    sGranuleHandle->metadata.psMetadata.firstScanUTCdate.booleanFlag = TK_TRUE;
	  }
          else
          {
             /* Size of value out of range in TKwriteMetadataInt.*/
             TKreportWarning(W_TK_BADVALUESIZEWI);
             return W_TK_BADVALUESIZEWI;
          }
          break;

        case TK_FIRST_SCAN_UTC_TIME : /* Orbit FirstScan UTC Time */
          if (strlen(tempValue) < TK_SZ_ELEMENT_51 )
	  {
            strcpy(sGranuleHandle->metadata.psMetadata.firstScanUTCtime.value, tempValue);
	    sGranuleHandle->metadata.psMetadata.firstScanUTCtime.booleanFlag = TK_TRUE;
	  }
          else
          {
             /* Size of value out of range in TKwriteMetadataInt.*/
             TKreportWarning(W_TK_BADVALUESIZEWI);
             return (W_TK_BADVALUESIZEWI);
          }
          break;

        case TK_FIRST_SCAN_UTC_MILLISEC : /* Orbit First Scan UTC Milliseconds */
          if (strlen(tempValue) < TK_SZ_ELEMENT_51 )
	  {
	    strcpy(sGranuleHandle->metadata.psMetadata.firstScanUTCmsec.value, tempValue);
	    sGranuleHandle->metadata.psMetadata.firstScanUTCmsec.booleanFlag = TK_TRUE;
	  }
          else
          {
             /* Size of value out of range in TKwriteMetadataInt.*/
             TKreportWarning(W_TK_BADVALUESIZEWI);
             return (W_TK_BADVALUESIZEWI);
          }
          break;

        case TK_FIRST_SCAN_SC_SECS : 
		/* Orbit First Scantime - Spacecraft clock - seconds */
          if (strlen(tempValue) < TK_SZ_ELEMENT_51 )
	  {
	    strcpy(sGranuleHandle->metadata.psMetadata.firstScanSCsec.value, tempValue);
	    sGranuleHandle->metadata.psMetadata.firstScanSCsec.booleanFlag = TK_TRUE;
	  }
          else
          {
             /* Size of value out of range in TKwriteMetadataInt.*/
             TKreportWarning(W_TK_BADVALUESIZEWI);
             return (W_TK_BADVALUESIZEWI);
          }
          break;

        case TK_FIRST_SCAN_SC_SUBSECS : 
		/* Orbit First Scantime - Spacecraft Clock - Subseconds */
          if (strlen(tempValue) < TK_SZ_ELEMENT_51 )
	  {
	    strcpy(sGranuleHandle->metadata.psMetadata.firstScanSCsubsec.value, tempValue);
	    sGranuleHandle->metadata.psMetadata.firstScanSCsubsec.booleanFlag = TK_TRUE;
	  }
          else
          {
             /* Size of value out of range in TKwriteMetadataInt.*/
             TKreportWarning(W_TK_BADVALUESIZEWI);
             return (W_TK_BADVALUESIZEWI);
          }
          break;

        case TK_LAST_SCAN_UTC_DATE : /* Orbit Last Scan UTC Date */
          if (strlen(tempValue) < TK_SZ_ELEMENT_51 )
	  {
	    strcpy(sGranuleHandle->metadata.psMetadata.lastScanUTCdate.value, tempValue);
	    sGranuleHandle->metadata.psMetadata.lastScanUTCdate.booleanFlag = TK_TRUE;
	  }
          else
          {
             /* Size of value out of range in TKwriteMetadataInt.*/
             TKreportWarning(W_TK_BADVALUESIZEWI);
             return (W_TK_BADVALUESIZEWI);
          }
          break;

	case TK_KEP_EPOCH_DATE: /* Epoch Date */
          if (strlen(tempValue) < TK_SZ_ELEMENT_51 )
	    strcpy(sGranuleHandle->metadata.coreMetadata.kepEpochDate.value, tempValue);
          else
          {
             /* Size of value out of range in TKwriteMetadataInt.*/
             TKreportWarning(W_TK_BADVALUESIZEWI);
             return (W_TK_BADVALUESIZEWI);
          }
          break;

	case TK_KEP_EPOCH_TIME: /* Epoch TIME */
          if (strlen(tempValue) < TK_SZ_ELEMENT_51 )
	    strcpy(sGranuleHandle->metadata.coreMetadata.kepEpochTime.value, tempValue);
          else
          {
             /* Size of value out of range in TKwriteMetadataInt.*/
             TKreportWarning(W_TK_BADVALUESIZEWI);
             return (W_TK_BADVALUESIZEWI);
          }
          break;

	case TK_KEP_EPOCH_MILLISEC: /* Epoch millisec */
          if (strlen(tempValue) < TK_SZ_ELEMENT_51 )
	    strcpy(sGranuleHandle->metadata.coreMetadata.kepEpochMillisec.value, tempValue);
          else
          {
             /* Size of value out of range in TKwriteMetadataInt.*/
             TKreportWarning(W_TK_BADVALUESIZEWI);
             return (W_TK_BADVALUESIZEWI);
          }
          break;


        case TK_LAST_SCAN_UTC_TIME : /* Orbit Last Scan UTC Time */
          if (strlen(tempValue) < TK_SZ_ELEMENT_51 )
	  {
	    strcpy(sGranuleHandle->metadata.psMetadata.lastScanUTCtime.value, tempValue);
	    sGranuleHandle->metadata.psMetadata.lastScanUTCtime.booleanFlag = TK_TRUE;
	  }
          else
          {
             /* Size of value out of range in TKwriteMetadataInt.*/
             TKreportWarning(W_TK_BADVALUESIZEWI);
             return (W_TK_BADVALUESIZEWI);
          }
          break;

        case TK_LAST_SCAN_UTC_MILLISEC : /* Orbit Last Scan UTC Milliseconds */
          if (strlen(tempValue) < TK_SZ_ELEMENT_51 )
	  {
	    strcpy(sGranuleHandle->metadata.psMetadata.lastScanUTCmsec.value, tempValue);
	    sGranuleHandle->metadata.psMetadata.lastScanUTCmsec.booleanFlag = TK_TRUE;
	  }
          else
          {
             /* Size of value out of range in TKwriteMetadataInt.*/
             TKreportWarning(W_TK_BADVALUESIZEWI);
             return (W_TK_BADVALUESIZEWI);
          }
          break;

        case TK_LAST_SCAN_SC_SECS : 
		/* Orbit Last Scantime - Spacecraft Clock - Seconds */
          if (strlen(tempValue) < TK_SZ_ELEMENT_51 )
	  {
	    strcpy(sGranuleHandle->metadata.psMetadata.lastScanSCsec.value, tempValue);
	    sGranuleHandle->metadata.psMetadata.lastScanSCsec.booleanFlag = TK_TRUE;
	  }
          else
          {
             /* Size of value out of range in TKwriteMetadataInt.*/
             TKreportWarning(W_TK_BADVALUESIZEWI);
             return (W_TK_BADVALUESIZEWI);
          }
          break;

        case TK_LAST_SCAN_SC_SUBSECS : 
		/* Orbit Last Scantime - Spacecraft Clock - Subseconds */
          if (strlen(tempValue) < TK_SZ_ELEMENT_51 )
	  {
	    strcpy(sGranuleHandle->metadata.psMetadata.lastScanSCsubsec.value, tempValue);
	    sGranuleHandle->metadata.psMetadata.lastScanSCsubsec.booleanFlag = TK_TRUE;
	  }
          else
          {
             /* Size of value out of range in TKwriteMetadataInt.*/
             TKreportWarning(W_TK_BADVALUESIZEWI);
             return (W_TK_BADVALUESIZEWI);
          }
          break;

        case TK_UTCF_SECONDS : /* UTCF Seconds */
          if (strlen(tempValue) < TK_SZ_ELEMENT_51 )
	  {
	    strcpy(sGranuleHandle->metadata.psMetadata.utcfSec.value, tempValue);
	    sGranuleHandle->metadata.psMetadata.utcfSec.booleanFlag = TK_TRUE;
	  }
	  else
          {
             /* Size of value out of range in TKwriteMetadataInt.*/
             TKreportWarning(W_TK_BADVALUESIZEWI);
             return (W_TK_BADVALUESIZEWI);
          }
          break;

        case TK_UTCF_SUBSECONDS : /* UTCF Subseconds */
          if (strlen(tempValue) < TK_SZ_ELEMENT_51 )
	  {
	    strcpy(sGranuleHandle->metadata.psMetadata.utcfSubsec.value, tempValue);
	    sGranuleHandle->metadata.psMetadata.utcfSubsec.booleanFlag = TK_TRUE;
	  }
          else
          {
             /* Size of value out of range in TKwriteMetadataInt.*/
             TKreportWarning(W_TK_BADVALUESIZEWI);
             return (W_TK_BADVALUESIZEWI);
          }
          break;

        case TK_LEAP_SECS_FLAG : /* Leap Seconds Flag */
          if (strlen(tempValue) < TK_SZ_ELEMENT_51 )
	  {
	    strcpy(sGranuleHandle->metadata.psMetadata.leapSecsFlag.value, tempValue);
	    sGranuleHandle->metadata.psMetadata.leapSecsFlag.booleanFlag = TK_TRUE;
	  }
          else
          {
             /* Size of value out of range in TKwriteMetadataInt.*/
             TKreportWarning(W_TK_BADVALUESIZEWI);
             return (W_TK_BADVALUESIZEWI);
          }
          break;

        case TK_NUM_VOS : /* Number of VOS */
          if (strlen(tempValue) < TK_SZ_ELEMENT_51 )
	  {
	    strcpy(sGranuleHandle->metadata.psMetadata.numVOS.value, tempValue);
	    sGranuleHandle->metadata.psMetadata.numVOS.booleanFlag = TK_TRUE;
	  }
          else
          {
             /* Size of value out of range in TKwriteMetadataInt.*/
             TKreportWarning(W_TK_BADVALUESIZEWI);
             return (W_TK_BADVALUESIZEWI);
          }
          break;

        case TK_RADAR_GRID_SIZE_X : /* Radar Grid Size X */
          if (strlen(tempValue) < TK_SZ_ELEMENT_51 )
	  {
	    strcpy(sGranuleHandle->metadata.psMetadata.radarGridSizeX.value, tempValue);
	    sGranuleHandle->metadata.psMetadata.radarGridSizeX.booleanFlag = TK_TRUE;
	  }
          else
          {
             /* Size of value out of range in TKwriteMetadataInt.*/
             TKreportWarning(W_TK_BADVALUESIZEWI);
             return (W_TK_BADVALUESIZEWI);
          }
          break;

        case TK_RADAR_GRID_SIZE_Y : /* Radar Grid Size Y */
          if (strlen(tempValue) < TK_SZ_ELEMENT_51 )
	  {
	    strcpy(sGranuleHandle->metadata.psMetadata.radarGridSizeY.value, tempValue);
	    sGranuleHandle->metadata.psMetadata.radarGridSizeY.booleanFlag = TK_TRUE;
	  }
          else
          {
             /* Size of value out of range in TKwriteMetadataInt.*/
             TKreportWarning(W_TK_BADVALUESIZEWI);
             return (W_TK_BADVALUESIZEWI);
          }
          break;

        case TK_RADAR_GRID_SIZE_Z : /* Radar Grid Size Z */
          if (strlen(tempValue) < TK_SZ_ELEMENT_51 )
	  {
	    strcpy(sGranuleHandle->metadata.psMetadata.radarGridSizeZ.value, tempValue);
	    sGranuleHandle->metadata.psMetadata.radarGridSizeZ.booleanFlag = TK_TRUE;
	  }
          else
          {
             /* Size of value out of range in TKwriteMetadataInt.*/
             TKreportWarning(W_TK_BADVALUESIZEWI);
             return (W_TK_BADVALUESIZEWI);
          }
          break;

        case TK_UTCF_FLAG : /* UTCF Flag */
          if (strlen(tempValue) < TK_SZ_ELEMENT_51 )
	  {
	    strcpy(sGranuleHandle->metadata.psMetadata.utcfFlag.value, tempValue);
	    sGranuleHandle->metadata.psMetadata.utcfFlag.booleanFlag = TK_TRUE;
	  }
          else
          {
             /* Size of value out of range in TKwriteMetadataInt.*/
             TKreportWarning(W_TK_BADVALUESIZEWI);
             return (W_TK_BADVALUESIZEWI);
          }
          break;

/* altitude increase change */
/*
change back due to GV
*/
	case TK_PRODUCT_VERSION:
	  if ( strlen ( tempValue ) < TK_SZ_ELEMENT_51 )
	    {
	      strcpy ( sGranuleHandle->metadata.psMetadata.productVersion.value, tempValue );
	      sGranuleHandle->metadata.psMetadata.productVersion.booleanFlag = TK_TRUE;
	    }
	  else
	    {
/*
change back due to GV
*/
	      /* Size of value out of range in TKwriteMetadataInt.  */
/*
change back due to GV
*/
	      TKreportWarning ( W_TK_BADVALUESIZEWI );
	      return ( W_TK_BADVALUESIZEWI );
	    }
	  break;
/*
change back due to GV
*/

	case TK_CAL_COEFF_VERSION:
	  if ( strlen ( tempValue ) < TK_SZ_ELEMENT_51 )
	    {
	      strcpy ( sGranuleHandle->metadata.psMetadata.calCoeffVersion.value, tempValue );
	      sGranuleHandle->metadata.psMetadata.calCoeffVersion.booleanFlag = TK_TRUE;
	    }
	  else
	    {
	      /* Size of value out of range in TKwriteMetadataInt.  */
	      TKreportWarning ( W_TK_BADVALUESIZEWI );
	      return ( W_TK_BADVALUESIZEWI );
	    }
	  break;

	case TK_SOFTWARE_VERSION:
	  if ( strlen ( tempValue ) < TK_SZ_ELEMENT_51 )
	    {
	      strcpy ( sGranuleHandle->metadata.psMetadata.softwareVersion.value, tempValue );
	      sGranuleHandle->metadata.psMetadata.softwareVersion.booleanFlag = TK_TRUE;
	    }
	  else
	    {
	      /* Size of value out of range in TKwriteMetadataInt.  */
	      TKreportWarning ( W_TK_BADVALUESIZEWI );
	      return ( W_TK_BADVALUESIZEWI );
	    }
	  break;

	case TK_DATABASE_VERSION:
	  if ( strlen ( tempValue ) < TK_SZ_ELEMENT_51 )
	    {
	      strcpy ( sGranuleHandle->metadata.psMetadata.databaseVersion.value, tempValue );
	      sGranuleHandle->metadata.psMetadata.databaseVersion.booleanFlag = TK_TRUE;
	    }
	  else
	    {
	      /* Size of value out of range in TKwriteMetadataInt.  */
	      TKreportWarning ( W_TK_BADVALUESIZEWI );
	      return ( W_TK_BADVALUESIZEWI );
	    }
	  break;

	case TK_UTC_DATE_ON_EQUATOR:
	  if ( strlen ( tempValue ) < TK_SZ_ELEMENT_51 )
	    {
	      strcpy ( sGranuleHandle->metadata.psMetadata.UTCDateOnEquator.value, tempValue );
	      sGranuleHandle->metadata.psMetadata.UTCDateOnEquator.booleanFlag = TK_TRUE;
	    }
	  else
	    {
	      /* Size of value out of range in TKwriteMetadataInt.  */
	      TKreportWarning ( W_TK_BADVALUESIZEWI );
	      return ( W_TK_BADVALUESIZEWI );
	    }
	  break;

	case TK_UTC_TIME_ON_EQUATOR:
	  if ( strlen ( tempValue ) < TK_SZ_ELEMENT_51 )
	    {
	      strcpy ( sGranuleHandle->metadata.psMetadata.UTCTimeOnEquator.value, tempValue );
	      sGranuleHandle->metadata.psMetadata.UTCTimeOnEquator.booleanFlag = TK_TRUE;
	    }
	  else
	    {
	      /* Size of value out of range in TKwriteMetadataInt.  */
	      TKreportWarning ( W_TK_BADVALUESIZEWI );
	      return ( W_TK_BADVALUESIZEWI );
	    }
	  break;

	case TK_UTC_MILLISEC_ON_EQUATOR:
	  if ( strlen ( tempValue ) < TK_SZ_ELEMENT_51 )
	    {
	      strcpy ( sGranuleHandle->metadata.psMetadata.millisecOnEquator.value, tempValue );
	      sGranuleHandle->metadata.psMetadata.millisecOnEquator.booleanFlag = TK_TRUE;
	    }
	  else
	    {
	      /* Size of value out of range in TKwriteMetadataInt.  */
	      TKreportWarning ( W_TK_BADVALUESIZEWI );
	      return ( W_TK_BADVALUESIZEWI );
	    }
	  break;

	case TK_CENTER_SCAN_UTC_DATE:
	  if ( strlen ( tempValue ) < TK_SZ_ELEMENT_51 )
	    {
	      strcpy ( sGranuleHandle->metadata.psMetadata.centerScanUTCDate.value, tempValue );
	      sGranuleHandle->metadata.psMetadata.centerScanUTCDate.booleanFlag = TK_TRUE;
	    }
	  else
	    {
	      /* Size of value out of range in TKwriteMetadataInt.  */
	      TKreportWarning ( W_TK_BADVALUESIZEWI );
	      return ( W_TK_BADVALUESIZEWI );
	    }
	  break;

	case TK_CENTER_SCAN_UTC_TIME:
	  if ( strlen ( tempValue ) < TK_SZ_ELEMENT_51 )
	    {
	      strcpy ( sGranuleHandle->metadata.psMetadata.centerScanUTCTime.value, tempValue );
	      sGranuleHandle->metadata.psMetadata.centerScanUTCTime.booleanFlag = TK_TRUE;
	    }
	  else
	    {
	      /* Size of value out of range in TKwriteMetadataInt.  */
	      TKreportWarning ( W_TK_BADVALUESIZEWI );
	      return ( W_TK_BADVALUESIZEWI );
	    }
	  break;

	case TK_CENTER_SCAN_UTC_MILLISEC:
	  if ( strlen ( tempValue ) < TK_SZ_ELEMENT_51 )
	    {
	      strcpy ( sGranuleHandle->metadata.psMetadata.centerScanUTCMillisec.value, tempValue );
	      sGranuleHandle->metadata.psMetadata.centerScanUTCMillisec.booleanFlag = TK_TRUE;
	    }
	  else
	    {
	      /* Size of value out of range in TKwriteMetadataInt.  */
	      TKreportWarning ( W_TK_BADVALUESIZEWI );
	      return ( W_TK_BADVALUESIZEWI );
	    }
	  break;

	case TK_NUM_OF_RAIN_SCANS:
	  if ( strlen ( tempValue ) < TK_SZ_ELEMENT_51 )
	    {
	      strcpy ( sGranuleHandle->metadata.psMetadata.numOfRainScans.value, tempValue );
	      sGranuleHandle->metadata.psMetadata.numOfRainScans.booleanFlag = TK_TRUE;
	    }
	  else
	    {
	      /* Size of value out of range in TKwriteMetadataInt.  */
	      TKreportWarning ( W_TK_BADVALUESIZEWI );
	      return ( W_TK_BADVALUESIZEWI );
	    }
	  break;

	default :
	  /* Invalid parameter in TKwriteMetadataInt. */
	  TKreportWarning(W_TK_BADPARMWI);
	  return(W_TK_BADPARMWI);
      }
  }
  else
  {
      /* Invalid filemode in TKwriteMetadataInt. */
      TKreportWarning(W_TK_BADFILEMODEWI);
      return(W_TK_BADFILEMODEWI);
  }
  return(TK_SUCCESS);
}

/***********************************************************************************
*
*  FUNCTION STATEMENT:
*       TKwriteMetadataFloat(IO_HANDLE *sGranuleHandle, 
*                             int parameter, 
*                             float *value) 
*
*  DESCRIPTION:
*       This routine is used to write individual floating point metadata items 
*       from a file.
*
*  INPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       sGranuleHandle          A structure containing information about the file
*                               from which metadata can be written.  
*                               sGranuleHandle is returned by TKopen().
*       parameter               A string containing the name of the metadata
*                               element to be read from the file.
*
*  OUTPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       value                   The float value corresponding to the
*                               metadata element specified by "parameter".
*
*  CALLED BY:                   main program
*
*  RETURN VALUES:               W_TK_BADVALUESIZEWF,W_TK_BADPARMWF
*                               W_TK_BADFILEMODEWF, TK_SUCCESS 
*
*  ROUTINES CALLED:            
*	TKreportWarning()
*
***********************************************************************************/
int TKwriteMetadataFloat(IO_HANDLE *sGranuleHandle, int parameter, float *value)
{
  char tempValue[TK_SZ_ELEMENT_51];

  if ( (sGranuleHandle->mode == TK_NEW_FILE) || (sGranuleHandle->mode == TK_APPEND) ) {
    sprintf(tempValue, "%f", *value);
    if (strlen(tempValue) >= TK_SZ_ELEMENT_51) {
      /* Size of value out of range in TKwriteMetadataFloat.*/
      TKreportWarning(W_TK_BADVALUESIZEWF);
      return (W_TK_BADVALUESIZEWF);
    }
    switch (parameter)
      {
      case TK_NUM_DATA_GAP : /* Number of data gaps in the data in the orbit or granule */
	strcpy(sGranuleHandle->metadata.psMetadata.numDataGap.value, tempValue);
	sGranuleHandle->metadata.psMetadata.numDataGap.booleanFlag = TK_TRUE;
	break;
	
      case TK_RADAR_WAVELENGTH : /* Radar Wave Length. */
	strcpy(sGranuleHandle->metadata.psMetadata.radarWavelength.value, tempValue);
	sGranuleHandle->metadata.psMetadata.radarWavelength.booleanFlag = TK_TRUE;
	break;
		
      case TK_MIN_REF_THRESHOLD : /* Min Ref Threshold. */
	strcpy(sGranuleHandle->metadata.psMetadata.minRefThreshold.value, tempValue);
	sGranuleHandle->metadata.psMetadata.minRefThreshold.booleanFlag = TK_TRUE;
	break;
	
      case TK_DATA_GAP : /* Data Gap */
	strcpy(sGranuleHandle->metadata.psMetadata.dataGap.value, tempValue);
	sGranuleHandle->metadata.psMetadata.dataGap.booleanFlag = TK_TRUE;
	break;
	
      case TK_DAY_NIGHT : /* Day/Night */
	strcpy(sGranuleHandle->metadata.psMetadata.dayNight.value, tempValue);
	sGranuleHandle->metadata.psMetadata.dayNight.booleanFlag = TK_TRUE;
	break;
	
      case TK_NUM_ORBITS : /* Mean Motion */
	strcpy(sGranuleHandle->metadata.coreMetadata.meanMotion.value, tempValue);
	sGranuleHandle->metadata.coreMetadata.meanMotion.booleanFlag = TK_TRUE;
	break;
	
      case TK_BEGIN_SOLAR_BETA : /* Solar Beta Angle at Beginning of Granule */
	strcpy(sGranuleHandle->metadata.coreMetadata.beginSolarBeta.value, tempValue);
	sGranuleHandle->metadata.coreMetadata.beginSolarBeta.booleanFlag = TK_TRUE;
	break;
	
      case TK_END_SOLAR_BETA : /* Solar Beta Angle at End of Granule */
	strcpy(sGranuleHandle->metadata.coreMetadata.endSolarBeta.value, tempValue);
	sGranuleHandle->metadata.coreMetadata.endSolarBeta.booleanFlag = TK_TRUE;
	break;
	
      case TK_EQ_RADIUS : /* Equatorial Radius of the earth ellipsoid */
	strcpy(sGranuleHandle->metadata.coreMetadata.earthEqRad.value, tempValue);
	sGranuleHandle->metadata.coreMetadata.earthEqRad.booleanFlag = TK_TRUE;
	break;
	
      case TK_FLATTENING_RATIO : /* Denominator of Flattening Ratio */
	strcpy(sGranuleHandle->metadata.coreMetadata.flatteningRatio.value, tempValue);
	sGranuleHandle->metadata.coreMetadata.flatteningRatio.booleanFlag = TK_TRUE;
	break;
	
      case TK_KEP_SEMI_MAJOR_AXIS : /* Half of the long exis of the orbit ellipse */
	strcpy(sGranuleHandle->metadata.coreMetadata.kepSemiMajorAxis.value, tempValue);
	sGranuleHandle->metadata.coreMetadata.kepSemiMajorAxis.booleanFlag = TK_TRUE;
	break;
	
      case TK_KEP_MEAN_ANOMALY : /* Angle around the orbit at the Epoch Time about */
				 /* the ellipse center from the ascending node	   */
	strcpy(sGranuleHandle->metadata.coreMetadata.kepMeanAnomaly.value, tempValue);
	sGranuleHandle->metadata.coreMetadata.kepMeanAnomaly.booleanFlag = TK_TRUE;
	break;
	
      case TK_KEP_RIGHT_ASCEN_NODE : /* Right ascension of ascending node */
	strcpy(sGranuleHandle->metadata.coreMetadata.kepRightAscenNode.value, tempValue);
	sGranuleHandle->metadata.coreMetadata.kepRightAscenNode.booleanFlag = TK_TRUE;
	break;
	
      case TK_KEP_ARG_OF_PERIGEE : /* Angle from the ascending node to perigee */
	strcpy(sGranuleHandle->metadata.coreMetadata.kepArgOfPerigee.value, tempValue);
	sGranuleHandle->metadata.coreMetadata.kepArgOfPerigee.booleanFlag = TK_TRUE;
	break;
	
      case TK_KEP_ECCENTRICITY : /* Eccentricity of ellipse */
	strcpy(sGranuleHandle->metadata.coreMetadata.kepEccentricity.value, tempValue);
	sGranuleHandle->metadata.coreMetadata.kepEccentricity.booleanFlag = TK_TRUE;
	break;
	
      case TK_KEP_INCLINATION : /* Angle between orbit plane and earth equatorial plane */
	strcpy(sGranuleHandle->metadata.coreMetadata.kepInclination.value, tempValue);
	sGranuleHandle->metadata.coreMetadata.kepInclination.booleanFlag = TK_TRUE;
	break;

      case TK_WEST_BOUND_COORD : /* the degree value for the west longitude of boundary */
	strcpy(sGranuleHandle->metadata.coreMetadata.westBoundCoord.value, tempValue);
	sGranuleHandle->metadata.coreMetadata.westBoundCoord.booleanFlag = TK_TRUE;
	break;
	
      case TK_EAST_BOUND_COORD : /* the degree value for the east longitude of boundary */
        strcpy(sGranuleHandle->metadata.coreMetadata.eastBoundCoord.value, tempValue);
	sGranuleHandle->metadata.coreMetadata.eastBoundCoord.booleanFlag = TK_TRUE;
	break;
	
      case TK_NORTH_BOUND_COORD : /* the degree value for the north latitude of boundary */
	strcpy(sGranuleHandle->metadata.coreMetadata.northBoundCoord.value, tempValue);
	sGranuleHandle->metadata.coreMetadata.northBoundCoord.booleanFlag = TK_TRUE;
	break;
	
      case TK_SOUTH_BOUND_COORD : /* the degree value for the south latitude of boundary */
        strcpy(sGranuleHandle->metadata.coreMetadata.southBoundCoord.value, tempValue);
	sGranuleHandle->metadata.coreMetadata.southBoundCoord.booleanFlag = TK_TRUE;
	break;
	
      case TK_CENTER_POINT_LAT : /* latitude of center point of product */
	strcpy(sGranuleHandle->metadata.coreMetadata.centerPointLat.value, tempValue);
	sGranuleHandle->metadata.coreMetadata.centerPointLat.booleanFlag = TK_TRUE;
	break;
	
      case TK_CENTER_POINT_LON : /* longitude of center point of product */
	strcpy(sGranuleHandle->metadata.coreMetadata.centerPointLon.value, tempValue);
	sGranuleHandle->metadata.coreMetadata.centerPointLon.booleanFlag = TK_TRUE;
	break;
	
      case TK_RADIUS : /* distance in km from point */
	strcpy(sGranuleHandle->metadata.coreMetadata.radius.value, tempValue);
	sGranuleHandle->metadata.coreMetadata.radius.booleanFlag = TK_TRUE;
	break;
	
      case TK_LATITUDE_RES : /* latitude resolution */
	strcpy(sGranuleHandle->metadata.coreMetadata.latitudeRes.value, tempValue);
	sGranuleHandle->metadata.coreMetadata.latitudeRes.booleanFlag = TK_TRUE;
        break;
	
      case TK_LONGITUDE_RES : /* longitude resolution */
	strcpy(sGranuleHandle->metadata.coreMetadata.longitudeRes.value, tempValue);
	sGranuleHandle->metadata.coreMetadata.longitudeRes.booleanFlag = TK_TRUE;
	break;

      case TK_FILE_SIZE : /**/
	strcpy(sGranuleHandle->metadata.coreMetadata.fileSize.value, tempValue);
	sGranuleHandle->metadata.coreMetadata.fileSize.booleanFlag = TK_TRUE;
	break;
	
      case TK_LON_OF_MAX_LAT : /* Longitude of Maximum Latitude*/
	strcpy(sGranuleHandle->metadata.coreMetadata.lonMaxLat.value, tempValue);
	sGranuleHandle->metadata.coreMetadata.lonMaxLat.booleanFlag = TK_TRUE;
	break;


      case TK_RADAR_ORIGIN_LAT : /* Radar Grid Origin Latitude */
	strcpy(sGranuleHandle->metadata.psMetadata.radarOriginLat.value, tempValue);
	sGranuleHandle->metadata.psMetadata.radarOriginLat.booleanFlag = TK_TRUE;
	break;

      case TK_RADAR_ORIGIN_LON : /* Radar Grid Origin Longitude */
	strcpy(sGranuleHandle->metadata.psMetadata.radarOriginLon.value, tempValue);
	sGranuleHandle->metadata.psMetadata.radarOriginLon.booleanFlag = TK_TRUE;
	break;

      case TK_RADAR_ORIGIN_ALT : /* Radar Grid Origin Altitude */
	strcpy(sGranuleHandle->metadata.psMetadata.radarOriginAlt.value, tempValue);
	sGranuleHandle->metadata.psMetadata.radarOriginAlt.booleanFlag = TK_TRUE;
	break;

      case TK_GV_DZCAL: /* Radar calibration offset */
        strcpy(sGranuleHandle->metadata.psMetadata.dzcal.value, tempValue);
        sGranuleHandle->metadata.psMetadata.dzcal.booleanFlag = TK_TRUE;
        break;

      case TK_GV_L1C_SCALE: /* Scaling factor for 1C-51 mask */
        strcpy(sGranuleHandle->metadata.psMetadata.gvL1Cscale.value, tempValue);
        sGranuleHandle->metadata.psMetadata.gvL1Cscale.booleanFlag = TK_TRUE;
        break;

      case TK_GV_ALPHA : /* Correction for gaseous two-way attenuation */
        strcpy(sGranuleHandle->metadata.psMetadata.alpha.value, tempValue);
        sGranuleHandle->metadata.psMetadata.alpha.booleanFlag = TK_TRUE;
        break;
	
      case TK_RADAR_SPACING_X : /* Radar Grid Spacing X */
	strcpy(sGranuleHandle->metadata.psMetadata.radarSpacingX.value, tempValue);
	sGranuleHandle->metadata.psMetadata.radarSpacingX.booleanFlag = TK_TRUE;
	break;
	
      case TK_RADAR_SPACING_Y : /* Radar Grid Spacing Y */
	strcpy(sGranuleHandle->metadata.psMetadata.radarSpacingY.value, tempValue);
	sGranuleHandle->metadata.psMetadata.radarSpacingY.booleanFlag = TK_TRUE;
	break;

      case TK_RADAR_SPACING_Z : /* Radar Grid Spacing Z */
	strcpy(sGranuleHandle->metadata.psMetadata.radarSpacingZ.value, tempValue);
	sGranuleHandle->metadata.psMetadata.radarSpacingZ.booleanFlag = TK_TRUE;
	break;

      case TK_LON_ON_EQUATOR : 
	strcpy(sGranuleHandle->metadata.psMetadata.lonOnEquator.value, tempValue);
	sGranuleHandle->metadata.psMetadata.lonOnEquator.booleanFlag = TK_TRUE;
	break;

      case TK_FIRST_SCAN_LAT : 
	strcpy(sGranuleHandle->metadata.psMetadata.firstScanLat.value, tempValue);
	sGranuleHandle->metadata.psMetadata.firstScanLat.booleanFlag = TK_TRUE;
	break;

      case TK_FIRST_SCAN_LON : 
	strcpy(sGranuleHandle->metadata.psMetadata.firstScanLon.value, tempValue);
	sGranuleHandle->metadata.psMetadata.firstScanLon.booleanFlag = TK_TRUE;
	break;

      case TK_LAST_SCAN_LAT : 
	strcpy(sGranuleHandle->metadata.psMetadata.lastScanLat.value, tempValue);
	sGranuleHandle->metadata.psMetadata.lastScanLat.booleanFlag = TK_TRUE;
	break;

      case TK_LAST_SCAN_LON : 
	strcpy(sGranuleHandle->metadata.psMetadata.lastScanLon.value, tempValue);
	sGranuleHandle->metadata.psMetadata.lastScanLon.booleanFlag = TK_TRUE;
	break;

      default  :
	/* Invalid parameter in TKwriteMetadataFloat. */
 	TKreportWarning(W_TK_BADPARMWF);
	return(W_TK_BADPARMWF);
    }
  }
  else {
    /* Invalid filemode in TKwriteMetadataFloat. */
    TKreportWarning(W_TK_BADFILEMODEWF);
    return(W_TK_BADFILEMODEWF);
  }
  return(TK_SUCCESS);
}

/***********************************************************************************
*
*  FUNCTION STATEMENT:
*       TKwriteMetadataChar(IO_HANDLE *sGranuleHandle, 
*                           int parameter, 
*                           char *value) 
*
*  DESCRIPTION:
*       This routine is used to write individual character metadata items from a
*       file.
*
*  INPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       sGranuleHandle          A structure containing information about the file
*                               from which metadata can be written.  sGranuleHandle 
*                               is returned by TKopen().
*       parameter               A string containing the name of the metadata
*                               element to be read from the file.
*
*  OUTPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       value                   The character value corresponding to the
*                               metadata element specified by "parameter".
*
*  CALLED BY:                   main program
*
*  RETURN VALUES:               W_TK_BADVALUESIZEWC, W_TK_BADPARMWC, 
*                               W_TK_BADFILEMODEWC, TK_SUCCESS
*
*  ROUTINES CALLED:             
*	TKreportWarning()
*
***********************************************************************************/
int TKwriteMetadataChar(IO_HANDLE *sGranuleHandle, int parameter, char *value)
{
  if ( (sGranuleHandle->mode == TK_NEW_FILE) || (sGranuleHandle->mode == TK_APPEND) )
  {
      switch (parameter) {



/* altitude increase change */
	case TK_PRODUCT_VERSION : /* Product Version. */
	  if (strlen(value) < TK_SZ_ELEMENT_51 ) {
	    sprintf(sGranuleHandle->metadata.psMetadata.productVersion.value,
		    "%c%s%c", '\"', value, '\"');
	    sGranuleHandle->metadata.psMetadata.productVersion.booleanFlag = TK_TRUE;
	  }
          else
          {
	      /* Size of value out of range in TKwriteMetadataChar.*/
	      TKreportWarning(W_TK_BADVALUESIZEWC);
	      return (W_TK_BADVALUESIZEWC);
	  }
	  break;

	case TK_ALGORITHM_VERSION : /* Algorithm Version. */
	  if (strlen(value) < TK_SZ_ELEMENT_51 ) {
	    sprintf(sGranuleHandle->metadata.psMetadata.algorithmVersion.value,
		    "%c%s%c", '\"', value, '\"');
	    sGranuleHandle->metadata.psMetadata.algorithmVersion.booleanFlag = TK_TRUE;
	  }
          else
          {
	      /* Size of value out of range in TKwriteMetadataChar.*/
	      TKreportWarning(W_TK_BADVALUESIZEWC);
	      return (W_TK_BADVALUESIZEWC);
	  }
	  break;

	case TK_ALGORITHM_ID : /* Algorithm ID. */
	  if (strlen(value) < TK_SZ_ELEMENT_51)
	    {
	    sprintf(sGranuleHandle->metadata.psMetadata.algorithmID.value,
		    "%c%s%c", '\"', value, '\"');
	    sGranuleHandle->metadata.psMetadata.algorithmID.booleanFlag = TK_TRUE;
	  }
          else
          {
	      /* Size of value out of range in TKwriteMetadataChar.*/
	      TKreportWarning(W_TK_BADVALUESIZEWC);
	      return (W_TK_BADVALUESIZEWC);
	  }
	  break;

	case TK_INPUT_FILES: /* Input ID */
          if (strlen(value) < TK_SZ_ELEMENT_301)
          {
	    sprintf(sGranuleHandle->metadata.psMetadata.inputID.value,
			"%c%s%c", '\"', value, '\"');
	    sGranuleHandle->metadata.psMetadata.inputID.booleanFlag = TK_TRUE;
          }
          else
          {
              /* Size of value out of range in TKwriteMetadataChar.*/
              TKreportWarning(W_TK_BADVALUESIZEWC);
              return (W_TK_BADVALUESIZEWC);
          }
          break;

	case TK_GEN_DATE_INPUT_FILES : /* Date of Generation of Input Files */
          if (strlen(value) < TK_SZ_ELEMENT_101)
          {
	    sprintf(sGranuleHandle->metadata.psMetadata.dateGenInputFile.value,
		    "%c%s%c", '\"', value, '\"');
	    sGranuleHandle->metadata.psMetadata.dateGenInputFile.booleanFlag = TK_TRUE;
          }
          else
          {
              /* Size of value out of range in TKwriteMetadataChar.*/
              TKreportWarning(W_TK_BADVALUESIZEWC);
              return (W_TK_BADVALUESIZEWC);
          }
          break;


	case TK_DATA_CENTER_SRC : /* Data Center Source of Input Files */
	  if (strlen(value) < TK_SZ_ELEMENT_101)
	    {
	      sprintf(sGranuleHandle->metadata.psMetadata.dataCenterSrc.value,
		      "%c%s%c", '\"', value, '\"');
	      sGranuleHandle->metadata.psMetadata.dataCenterSrc.booleanFlag = TK_TRUE;
	    }
          else
	    {
              /* Size of value out of range in TKwriteMetadataChar.*/
              TKreportWarning(W_TK_BADVALUESIZEWC);
              return (W_TK_BADVALUESIZEWC);
	    }
          break;

        case TK_DATA_ACCURACY : /* Data Accurcy */
          if (strlen(value) < TK_SZ_ELEMENT_51 )
	    {
	    sprintf(sGranuleHandle->metadata.psMetadata.dataAccuracy.value,
		    "%c%s%c", '\"', value, '\"');
	    sGranuleHandle->metadata.psMetadata.dataAccuracy.booleanFlag = TK_TRUE;
	  }
          else
          {
             /* Size of value out of range in TKwriteMetadataChar.*/
             TKreportWarning(W_TK_BADVALUESIZEWC);
             return (W_TK_BADVALUESIZEWC);
          }
          break;

        case TK_MIN_VALID_CHANNEL : /* Minimum Valid Value of Channel */
          if (strlen(value) < TK_SZ_ELEMENT_101)
	  {
	      sprintf(sGranuleHandle->metadata.psMetadata.minValidChannel.value,
		      "%c%s%c", '\"', value, '\"');
	    sGranuleHandle->metadata.psMetadata.minValidChannel.booleanFlag = TK_TRUE;
	  }
          else
          {
	    /* Size of value out of range in TKwriteMetadataChar.*/
	    TKreportWarning(W_TK_BADVALUESIZEWC);
	    return (W_TK_BADVALUESIZEWC);
          }
          break;

	case TK_EPHEM_FILENAME : /* Ephemeris File ID */
          if (strlen(value) < TK_SZ_ELEMENT_51)
          {
	    sprintf(sGranuleHandle->metadata.coreMetadata.ephemFilename.value,
		    "%c%s%c", '\"', value, '\"');
	    sGranuleHandle->metadata.coreMetadata.ephemFilename.booleanFlag = TK_TRUE;
          }
          else
          {
              /* Size of value out of range in TKwriteMetadataChar.*/
              TKreportWarning(W_TK_BADVALUESIZEWC);
              return (W_TK_BADVALUESIZEWC);
          }
          break;

	case TK_RADAR_NAME : /* Radar Site Name */
          if (strlen(value) < TK_SZ_ELEMENT_51)
          {
	    sprintf(sGranuleHandle->metadata.psMetadata.radarName.value,
		    "%c%s%c", '\"', value, '\"');
	    sGranuleHandle->metadata.psMetadata.radarName.booleanFlag = TK_TRUE;
          }
          else
          {
              /* Size of value out of range in TKwriteMetadataChar.*/
              TKreportWarning(W_TK_BADVALUESIZEWC);
              return (W_TK_BADVALUESIZEWC);
          }
          break;

	case TK_RADAR_CITY : /* Radar City */
          if (strlen(value) < TK_SZ_ELEMENT_101)
          {
	    sprintf(sGranuleHandle->metadata.psMetadata.radarCity.value,
		    "%c%s%c", '\"', value, '\"');
	    sGranuleHandle->metadata.psMetadata.radarCity.booleanFlag = TK_TRUE;
          }
          else
          {
              /* Size of value out of range in TKwriteMetadataChar.*/
              TKreportWarning(W_TK_BADVALUESIZEWC);
              return (W_TK_BADVALUESIZEWC);
          }
          break;

	case TK_RADAR_STATE : /* Radar State */
          if (strlen(value) < TK_SZ_ELEMENT_51)
          {
	    sprintf(sGranuleHandle->metadata.psMetadata.radarState.value,
		    "%c%s%c", '\"', value, '\"');
	    sGranuleHandle->metadata.psMetadata.radarState.booleanFlag = TK_TRUE;
          }
          else
          {
              /* Size of value out of range in TKwriteMetadataChar.*/
              TKreportWarning(W_TK_BADVALUESIZEWC);
              return (W_TK_BADVALUESIZEWC);
          }
          break;

	case TK_RADAR_COUNTRY : /* Radar Country */
          if (strlen(value) < TK_SZ_ELEMENT_51)
          {
	    sprintf(sGranuleHandle->metadata.psMetadata.radarCountry.value,
		    "%c%s%c", '\"', value, '\"');
	    sGranuleHandle->metadata.psMetadata.radarCountry.booleanFlag = TK_TRUE;
          }
          else
          {
              /* Size of value out of range in TKwriteMetadataChar.*/
              TKreportWarning(W_TK_BADVALUESIZEWC);
              return (W_TK_BADVALUESIZEWC);
          }
          break;

        case TK_PERCENT_BAD_MISS_PIXEL : /* Percent of Bad or Missing Pixels */
          if (strlen(value) < TK_SZ_ELEMENT_101)
	  {
	    sprintf(sGranuleHandle->metadata.psMetadata.percentBadMissPix.value,
		    "%c%s%c", '\"', value, '\"');
	    sGranuleHandle->metadata.psMetadata.percentBadMissPix.booleanFlag = TK_TRUE;
	  }
          else
	  {
	    /* Size of value out of range in TKwriteMetadataChar.*/
	    TKreportWarning(W_TK_BADVALUESIZEWC);
	    return (W_TK_BADVALUESIZEWC);
          }
          break;

        case TK_MAX_VALID_CHANNEL : /* Maximum Valid Value of Channel */
          if (strlen(value) < TK_SZ_ELEMENT_101 )
	  {
	    sprintf(sGranuleHandle->metadata.psMetadata.maxValidChannel.value,
		    "%c%s%c", '\"', value, '\"');
	    sGranuleHandle->metadata.psMetadata.maxValidChannel.booleanFlag = TK_TRUE;
	  }
          else
          {
             /* Size of value out of range in TKwriteMetadataChar.*/
             TKreportWarning(W_TK_BADVALUESIZEWC);
             return (W_TK_BADVALUESIZEWC);
          }
          break;

	case TK_SENSOR_ALGN : /* Sensor alignment */
	  if (strlen(value) < TK_SZ_ELEMENT_101 )
	  {
	    sprintf(sGranuleHandle->metadata.coreMetadata.sensorAlgn.value,
		    "%c%s%c", '\"', value, '\"');
	    sGranuleHandle->metadata.coreMetadata.sensorAlgn.booleanFlag = TK_TRUE;
	  }
          else
          {
             /* Size of value out of range in TKwriteMetadataChar.*/
             TKreportWarning(W_TK_BADVALUESIZEWC);
             return (W_TK_BADVALUESIZEWC);
          }
	  break;

	case TK_SENSOR_ALGN_CHAN_OFFSET : /* */
	  if (strlen(value) < TK_SZ_ELEMENT_51 )
	  {
	    sprintf(sGranuleHandle->metadata.coreMetadata.sensorAlgnChanOff.value,
		    "%c%s%c", '\"', value, '\"');
	    sGranuleHandle->metadata.coreMetadata.sensorAlgnChanOff.booleanFlag = TK_TRUE;
	  }
          else
          {
             /* Size of value out of range in TKwriteMetadataChar.*/
             TKreportWarning(W_TK_BADVALUESIZEWC);
             return (W_TK_BADVALUESIZEWC);
	  }
	  break;

	case TK_SCAN_PATH_MODEL : /* Scan Path Model */
	  if (strlen(value) < TK_SZ_ELEMENT_101 )
	  {
	    sprintf(sGranuleHandle->metadata.coreMetadata.scanPathModel.value,
		    "%c%s%c", '\"', value, '\"');
	    sGranuleHandle->metadata.coreMetadata.scanPathModel.booleanFlag = TK_TRUE;
	  }
          else
          {
             /* Size of value out of range in TKwriteMetadataChar.*/
             TKreportWarning(W_TK_BADVALUESIZEWC);
             return (W_TK_BADVALUESIZEWC);
          }
	break;

	case TK_SCAN_PATH_PARAM : /* Scan Path parameters per channel */
	  if (strlen(value) < TK_SZ_ELEMENT_51 )
	  {
	    sprintf(sGranuleHandle->metadata.coreMetadata.scanPathParam.value,
		    "%c%s%c", '\"', value, '\"');
	    sGranuleHandle->metadata.coreMetadata.scanPathParam.booleanFlag = TK_TRUE;
	  }
          else
          {
             /* Size of value out of range in TKwriteMetadataChar.*/
             TKreportWarning(W_TK_BADVALUESIZEWC);
             return (W_TK_BADVALUESIZEWC);
          }
	break;

	case TK_GRANULE_ID : /* TSDIS granule ID */
	  if (strlen(value) < TK_SZ_ELEMENT_101)
	  {
	    sprintf(sGranuleHandle->metadata.coreMetadata.granuleID.value,
		    "%c%s%c", '\"', value, '\"');
	    sGranuleHandle->metadata.coreMetadata.granuleID.booleanFlag = TK_TRUE;
	  }
          else
          {
	      /* Size of value out of range in TKwriteMetadataChar.*/
	      TKreportWarning(W_TK_BADVALUESIZEWC);
	      return (W_TK_BADVALUESIZEWC);
	  }
	  break;

	case TK_DATA_ID : /* ID of ECS data object */
	  if (strlen(value) < TK_SZ_ELEMENT_101)
	  {
	    sprintf(sGranuleHandle->metadata.coreMetadata.dataID.value,
		    "%c%s%c", '\"', value, '\"');
	    sGranuleHandle->metadata.coreMetadata.dataID.booleanFlag = TK_TRUE;
	  }
          else
          {
	      /* Size of value out of range in TKwriteMetadataChar.*/
	      TKreportWarning(W_TK_BADVALUESIZEWC);
	      return (W_TK_BADVALUESIZEWC);
	  }
	  break;

	case TK_SPAT_COV_TYPE : /* spatial coverage type */
	  if (strlen(value) < TK_SZ_ELEMENT_51)
	  {
	    sprintf(sGranuleHandle->metadata.coreMetadata.spatCovType.value,
		    "%c%s%c", '\"', value, '\"');
	    sGranuleHandle->metadata.coreMetadata.spatCovType.booleanFlag = TK_TRUE;
	  }
          else
          {
	      /* Size of value out of range in TKwriteMetadataChar.*/
	      TKreportWarning(W_TK_BADVALUESIZEWC);
	      return (W_TK_BADVALUESIZEWC);
	  }
	  break;

	case TK_ORBIT_MODEL_NAME : /* reference name to the orbital model to be used */
				   /* to calculate the geolocation of this data to   */
				   /* determine global spatial extent		     */
	  if (strlen(value) < TK_SZ_ELEMENT_101)
	  {
	    sprintf(sGranuleHandle->metadata.coreMetadata.orbitModelName.value,
		    "%c%s%c", '\"', value, '\"');
	    sGranuleHandle->metadata.coreMetadata.orbitModelName.booleanFlag = TK_TRUE;
	  }
          else
          {
	      /* Size of value out of range in TKwriteMetadataChar.*/
	      TKreportWarning(W_TK_BADVALUESIZEWC);
	      return (W_TK_BADVALUESIZEWC);
	  }
	  break;

	case TK_GEO_COORD_UNITS : /* Geographic coord units */
	  if (strlen(value) < TK_SZ_ELEMENT_51)
	  {
	    sprintf(sGranuleHandle->metadata.coreMetadata.geoCoordUnits.value,
		    "%c%s%c", '\"', value, '\"');
	    sGranuleHandle->metadata.coreMetadata.geoCoordUnits.booleanFlag = TK_TRUE;
	  }
          else
          {
	      /* Size of value out of range in TKwriteMetadataChar.*/
	      TKreportWarning(W_TK_BADVALUESIZEWC);
	      return (W_TK_BADVALUESIZEWC);
	  }
	  break;

	case TK_TEMPOR_RNG_TYPE : /* temporal range type */
	  if (strlen(value) < TK_SZ_ELEMENT_51)
	  {
	    sprintf(sGranuleHandle->metadata.coreMetadata.temporRngType.value,
		    "%c%s%c", '\"', value, '\"');
	    sGranuleHandle->metadata.coreMetadata.temporRngType.booleanFlag = TK_TRUE;
	  }
          else
          {
	      /* Size of value out of range in TKwriteMetadataChar.*/
	      TKreportWarning(W_TK_BADVALUESIZEWC);
	      return (W_TK_BADVALUESIZEWC);
	  }
	  break;

	case TK_QA_PARAM_NAME : /* QA parameter name */
	  if (strlen(value) < TK_SZ_ELEMENT_101)
	  {
	    sprintf(sGranuleHandle->metadata.coreMetadata.qaParamName.value,
		    "%c%s%c", '\"', value, '\"');
	    sGranuleHandle->metadata.coreMetadata.qaParamName.booleanFlag = TK_TRUE;
	  }
         else
          {
	      /* Size of value out of range in TKwriteMetadataChar.*/
	      TKreportWarning(W_TK_BADVALUESIZEWC);
	      return (W_TK_BADVALUESIZEWC);
	  }
	  break;

	case TK_QA_PARAM_VALUE : /* QA parameter value */
	  if (strlen(value) < TK_SZ_ELEMENT_51)
	  {
	    sprintf(sGranuleHandle->metadata.coreMetadata.qaParamValue.value,
		    "%c%s%c", '\"', value, '\"');
	    sGranuleHandle->metadata.coreMetadata.qaParamValue.booleanFlag = TK_TRUE;
	  }
          else
          {
	      /* Size of value out of range in TKwriteMetadataChar.*/
	      TKreportWarning(W_TK_BADVALUESIZEWC);
	      return (W_TK_BADVALUESIZEWC);
	  }
	  break;

	case TK_REPRO_STAT : /* reprocessing status */
	  if (strlen(value) < TK_SZ_ELEMENT_51)
	  {
	    sprintf(sGranuleHandle->metadata.coreMetadata.reproStat.value,
		    "%c%s%c", '\"', value, '\"');
	    sGranuleHandle->metadata.coreMetadata.reproStat.booleanFlag = TK_TRUE;
	  }
          else
          {
	      /* Size of value out of range in TKwriteMetadataChar.*/
	      TKreportWarning(W_TK_BADVALUESIZEWC);
	      return (W_TK_BADVALUESIZEWC);
	  }
	  break;

	case TK_BROWSE_NAME : /* browse package reference */
	  if (strlen(value) < TK_SZ_ELEMENT_101)
	  {
	    sprintf(sGranuleHandle->metadata.coreMetadata.browseName.value,
		    "%c%s%c", '\"', value, '\"');
	    sGranuleHandle->metadata.coreMetadata.browseName.booleanFlag = TK_TRUE;
	  }
          else
          {
	      /* Size of value out of range in TKwriteMetadataChar.*/
	      TKreportWarning(W_TK_BADVALUESIZEWC);
	      return (W_TK_BADVALUESIZEWC);
	  }
	  break;

	case TK_CONTACT : /* name of the algorithm developer related to this granule */
	  if (strlen(value) < TK_SZ_ELEMENT_101)
	  {
	    sprintf(sGranuleHandle->metadata.coreMetadata.contact.value,
		    "%c%s%c", '\"', value, '\"');
	    sGranuleHandle->metadata.coreMetadata.contact.booleanFlag = TK_TRUE;
	  }
          else
          {
	      /* Size of value out of range in TKwriteMetadataChar.*/
	      TKreportWarning(W_TK_BADVALUESIZEWC);
	      return (W_TK_BADVALUESIZEWC);
	  }
	  break;

        case TK_GV_RUNTIME_OPT: /* Runtime option for algorithm including */
				/* QC parameters used.			  */
          if (strlen(value) < TK_SZ_ELEMENT_1001)
          {
            sprintf(sGranuleHandle->metadata.psMetadata.runtimeOption.value,
                    "%c%s%c", '\"', value, '\"');
            sGranuleHandle->metadata.psMetadata.runtimeOption.booleanFlag = TK_TRUE;
          }
          else
          {
              /* Size of value out of range in TKwriteMetadataChar.*/
              TKreportWarning(W_TK_BADVALUESIZEWC);
              return (W_TK_BADVALUESIZEWC);
          }
          break;

        case TK_ANOMALY_FLAG: /* Flag indicates the reason of empty granule */
          if (strlen(value) < TK_SZ_ELEMENT_101)
          {
            sprintf(sGranuleHandle->metadata.psMetadata.anomalyFlag.value,
                    "%c%s%c", '\"', value, '\"');
            sGranuleHandle->metadata.psMetadata.anomalyFlag.booleanFlag = TK_TRUE;
          }
          else
          {
              /* Size of value out of range in TKwriteMetadataChar.*/
              TKreportWarning(W_TK_BADVALUESIZEWC);
              return (W_TK_BADVALUESIZEWC);
          }
          break;

        case TK_TOOLKIT_VERSION: /* Version Number of the toolkit */
          if (strlen(value) < TK_SZ_ELEMENT_51)
          {
            sprintf(sGranuleHandle->metadata.psMetadata.toolkitVersion.value,
                    "%c%s%c", '\"', value, '\"');
            sGranuleHandle->metadata.psMetadata.toolkitVersion.booleanFlag = TK_TRUE;
          }
          else
          {
              /* Size of value out of range in TKwriteMetadataChar.*/
              TKreportWarning(W_TK_BADVALUESIZEWC);
              return (W_TK_BADVALUESIZEWC);
          }
          break;

        case TK_MIN_MAX_UNITS: /* Version Number of the toolkit */
          if (strlen(value) < TK_SZ_ELEMENT_51)
          {
            sprintf(sGranuleHandle->metadata.psMetadata.minMaxUnits.value,
                    "%c%s%c", '\"', value, '\"');
            sGranuleHandle->metadata.psMetadata.minMaxUnits.booleanFlag = TK_TRUE;
          }
          else
          {
              /* Size of value out of range in TKwriteMetadataChar.*/
              TKreportWarning(W_TK_BADVALUESIZEWC);
              return (W_TK_BADVALUESIZEWC);
          }
          break;

        case TK_ELLIPSOID_NAME: /* Name of the ellipsoid for the TRMM mission */
          if (strlen(value) < TK_SZ_ELEMENT_51)
          {
            sprintf(sGranuleHandle->metadata.coreMetadata.ellipsoidName.value,
                    "%c%s%c", '\"', value, '\"');
            sGranuleHandle->metadata.coreMetadata.ellipsoidName.booleanFlag = TK_TRUE;
          }
          else
          {
              /* Size of value out of range in TKwriteMetadataChar.*/
              TKreportWarning(W_TK_BADVALUESIZEWC);
              return (W_TK_BADVALUESIZEWC);
          }
          break;

        case TK_TOTAL_QUALITY_CODE: 
          if (strlen(value) < TK_SZ_ELEMENT_51)
          {
            sprintf(sGranuleHandle->metadata.psMetadata.totalQualityCode.value,
                    "%c%s%c", '\"', value, '\"');
            sGranuleHandle->metadata.psMetadata.totalQualityCode.booleanFlag = TK_TRUE;
          }
          else
          {
              /* Size of value out of range in TKwriteMetadataChar.*/
              TKreportWarning(W_TK_BADVALUESIZEWC);
              return (W_TK_BADVALUESIZEWC);
          }
          break;

        case TK_SOLAR_GAINS: 
          if (strlen(value) < TK_SZ_ELEMENT_51)
          {
            sprintf(sGranuleHandle->metadata.psMetadata.solarGains.value,
                    "%c%s%c", '\"', value, '\"');
            sGranuleHandle->metadata.psMetadata.solarGains.booleanFlag = TK_TRUE;
          }
          else
          {
              /* Size of value out of range in TKwriteMetadataChar.*/
              TKreportWarning(W_TK_BADVALUESIZEWC);
              return (W_TK_BADVALUESIZEWC);
          }
          break;


        case TK_TMI_ROLLOVER_COEF:
          if (strlen(value) < TK_SZ_ELEMENT_301)
          {
            sprintf(sGranuleHandle->metadata.psMetadata.tmiRolloverCoef.value,
                    "%c%s%c", '\"', value, '\"');
            sGranuleHandle->metadata.psMetadata.tmiRolloverCoef.booleanFlag = TK_TRUE;
          }
          else
          {
              /* Size of value out of range in TKwriteMetadataChar.*/
              TKreportWarning(W_TK_BADVALUESIZEWC);
              return (W_TK_BADVALUESIZEWC);
          }
          break;


        case TK_SOFTWARE_VERSION:
          if (strlen(value) < TK_SZ_ELEMENT_301)
          {
            sprintf(sGranuleHandle->metadata.psMetadata.softwareVersion.value,
                    "%c%s%c", '\"', value, '\"');
            sGranuleHandle->metadata.psMetadata.softwareVersion.booleanFlag = TK_TRUE;
          }
          else
          {
              /* Size of value out of range in TKwriteMetadataChar.*/
              TKreportWarning(W_TK_BADVALUESIZEWC);
              return (W_TK_BADVALUESIZEWC);
          }
          break;


        case TK_LATITUDE_RES : /* latitude resolution */
          if (strlen(value) < TK_SZ_ELEMENT_51)
          {
            sprintf(sGranuleHandle->metadata.coreMetadata.latitudeRes.value,
                    "%c%s%c", '\"', value, '\"');
            sGranuleHandle->metadata.coreMetadata.latitudeRes.booleanFlag = TK_TRUE;
          }
          else
          {
              /* Size of value out of range in TKwriteMetadataChar.*/
              TKreportWarning(W_TK_BADVALUESIZEWC);
              return (W_TK_BADVALUESIZEWC);
          }
          break;

        case TK_LONGITUDE_RES : /* longitude resolution */
          if (strlen(value) < TK_SZ_ELEMENT_51)
          {
            sprintf(sGranuleHandle->metadata.coreMetadata.longitudeRes.value,
                    "%c%s%c", '\"', value, '\"');
            sGranuleHandle->metadata.coreMetadata.longitudeRes.booleanFlag = TK_TRUE;
          }
          else
          {
              /* Size of value out of range in TKwriteMetadataChar.*/
              TKreportWarning(W_TK_BADVALUESIZEWC);
              return (W_TK_BADVALUESIZEWC);
          }
          break;

	default :
	  /* Invalid parameter in TKwriteMetadataChar. */
	  TKreportWarning(W_TK_BADPARMWC);
          return(W_TK_BADPARMWC);
      }
  }
  else
  {
      /* Invalid filemode in TKwriteMetadataChar. */
      TKreportWarning(W_TK_BADFILEMODEWC);
      return(W_TK_BADFILEMODEWC);
  }
  return(TK_SUCCESS);
}

/************************************************************************************
*
*  FUNCTION STATEMENT:
*       TKclose(IO_HANDLE *sGranuleHandle)
*
*  DESCRIPTION: 
*       This routine is used to close a data product file. 
*
*  INPUT PARAMETERS:
*       Parameter Name  	Description
*       --------------  	-----------
*       sGranuleHandle  	A structure containing information about the file
*                       	which is to be closed.  sGranuleHandle is returned
*                       	by TKopen().
*
*  OUTPUT PARAMETERS:   	None
*
*  CALLED BY:           	main program
*
*  RETURN VALUES: 		W_TK_FAILENDCLS, W_TK_FAILCLS,
*                               W_TK_FAILDLGHEL, W_TK_FAILDTCL, TK_SUCCESS
*
*  ROUTINES CALLED:
*	Routine Called		Description
*	--------------		-----------
*	TKreportWarning()	This routine is used for warnings and informational
*				messages.  Calling this routine will send an error
*				message to a central log file and return control to
*				the calling routine.
*	attachObjects		This routine recursively attaches vdata and sds objects
*				into their vgroup.
*	detachObjects		This routine recursively detaches vdata and sds objects
*				from their vgroup.
*	manageFiles		This procedure performs add and delete files from the list
*				of files depending on the operation type.
*	manageL1GVtemplate	This routines performs a requested action.  The requestion
*			        is described by opType.
*	deallocateCFG_STR
*
**************************************************************************************/

int TKclose (IO_HANDLE *sGranuleHandle)
{
  int32	l1gvFlag;
  struct stat statbuf;
  time_t      timep;
  struct tm   *tp;
  VGROUP_LINK *lastVgroup;
  int status = TK_SUCCESS;


  static int numberOfCalls = 0;

#ifndef TSU_ENV
  /*
   *  IM defines for updating the start and stop times
   */
  int IMstatus;
  IMsession *sSession;
  IMgranule_Update_Times_Struct *sStart_and_End_Times;
#endif

  numberOfCalls++;                   /* used to fix a memory management problem */
  /*
  ** If productID represents for level 1 GV product, then set l1gvFlag to 1,
  ** otherwise set it 0.
  */
  l1gvFlag = ((sGranuleHandle->productID == TK_L1B_GV) || 
              (sGranuleHandle->productID == TK_L1C_GV)) ? 1 : 0;


  /* 
  ** If the file mode is writing, then attach vdata and sds objects 
  ** to their vgroup.  Get the file size and output metadata to file.
  */
  if (sGranuleHandle->mode == TK_NEW_FILE)
  {
    writeSwathRadarMetadata ( sGranuleHandle );
    attachObjects(sGranuleHandle->cfgSTR->vGroup);   
      
    /* system call to get filesize */
    if (stat(sGranuleHandle->dataFileName, &statbuf) != TK_SUCCESS )
      /* Unable to get file information. */
/*
      TKreportWarning(W_TK_FAILSTAT);
*/
      TKreportWarningParm(W_TK_FAILSTAT,sGranuleHandle->dataFileName);

    /* Convert bytes to MB */
    sprintf(sGranuleHandle->fsize, "%f", statbuf.st_size/TK_BYTE_CONVERT_MB);

    /* Get current processing time; store as EOSDIS ascii code A format */
    if (time( &timep ) == -1)
      /* Unable to get current processing time. */
      TKreportWarning(W_TK_FAILTIME);

    if ( (tp = gmtime(&timep)) == NULL)
      /* Unable to get Greenwich mean time. */ 
      TKreportWarning(W_TK_FAILGMTIME);

    if (strftime(sGranuleHandle->genDate,25,"%Y-%m-%dT%H:%M:%S.000Z",tp)==0)
      /* Unable to store date and time in string. */
      TKreportWarning(W_TK_FAILSTRFTIME);
    
    /*
     * The call to finalizeMetadata creates PVL for each metadata element,
     * appends the PVL to an attribute string and writes the string to 
     * the hdf file.  This is done separately for core metadata and
     * ps metadata.
     */
    status = finalizeMetadata(sGranuleHandle);

  }
  else if ((l1gvFlag) && (sGranuleHandle->mode == TK_APPEND))
  {
      
    /* system call to get filesize */
    if (stat(sGranuleHandle->dataFileName, &statbuf) != TK_SUCCESS )
      /* Unable to get file information. */
/*
      TKreportWarning(W_TK_FAILSTAT);
*/
      TKreportWarningParm(W_TK_FAILSTAT,sGranuleHandle->dataFileName);
    
    /* Convert bytes to MB */
    sprintf(sGranuleHandle->fsize, "%f", statbuf.st_size/TK_BYTE_CONVERT_MB);
    
    /* Get current processing time; store as EOSDIS ascii code A format */
    if (time( &timep ) == -1)
      /* Unable to get current processing time. */
      TKreportWarning(W_TK_FAILTIME);
    
    if ( (tp = gmtime(&timep)) == NULL)
      /* Unable to get Greenwich mean time. */ 
      TKreportWarning(W_TK_FAILGMTIME);
    
    if (strftime(sGranuleHandle->genDate,25,"%Y-%m-%dT%H:%M:%S.000Z",tp)==0)
      /* Unable to store date and time in string. */
      TKreportWarning(W_TK_FAILSTRFTIME);
    
    /*
     ** Find the vGroup corresponding to the appending VOS.
     */
    lastVgroup = sGranuleHandle->cfgSTR->vGroup->subVgroup;
    while (lastVgroup->next != NULL)
      lastVgroup = lastVgroup->next;
    
    attachObjects(lastVgroup);
    status = finalizeMetadata(sGranuleHandle);
  }
  
  if ((sGranuleHandle->mode == TK_READ_ONLY)&&(numberOfCalls>12))
  {
    metaFree (sGranuleHandle); /* solve memory leak - TK version 5.7.2 */
  }

  if (sGranuleHandle->granuleFlag == TK_FALSE)
    {
      /*
       ** This routine detaches all the vdata objects from the vgroup.
       */
      detachVdata(sGranuleHandle->cfgSTR->vGroup);
    }
  else if ((l1gvFlag) && (sGranuleHandle->mode == TK_APPEND))
    {
      /*
       ** For TK_APPEND, only the lastVgroup was attached.
       */
      detachObjects(lastVgroup);
    }
  else
    {
      /*
       ** This routine detaches all the vdata and sds objects from their
       ** vgroup.  A HDF routine which detaches from the current vdata
       ** thereby termination further access to that vdata.
       */
      detachObjects(sGranuleHandle->cfgSTR->vGroup);
    }
  

  /*
  ** If the productID represents for level 1 gv or filemode is writing, then 
  ** detach all the vgroups from the HDF file.  TKopen attaches vgroups whether
  ** it is reading or writing into the HDF file for level 1 GV processing.  
  ** That's the reason why if it is for level 1 GV processing, detachVgroup 
  ** has to be called. 
  */
  if ((sGranuleHandle->mode == TK_NEW_FILE) || l1gvFlag)
  {
      detachVgroup(sGranuleHandle->cfgSTR->vGroup);   
  }

  /*
  ** SDend closes the file and cleans up memory.
  */
  if (SDend(sGranuleHandle->cfgSTR->sdStartID) != TK_SUCCESS)
  { 
	/* SDend failed in TKclose */ 
	TKreportWarning(W_TK_FAILENDCLS);
      	return(W_TK_FAILENDCLS);
  }

  /*
  ** Release internal data structures for HDF files containing Vdata or Vgroups.
  */
  Vend(sGranuleHandle->cfgSTR->hOpenID);

  /*
  ** Closes the access path to the file.
  */
  if (Hclose(sGranuleHandle->cfgSTR->hOpenID) != TK_SUCCESS)
  { 
	/* Hclose failed in TKclose */ 
	TKreportWarning(W_TK_FAILCLS);
      	return(W_TK_FAILCLS);
  }

  /*
  ** manageFiles with the parameter DELETE_FILE takes out the
  ** opened HDF file information from the internal list of files. 
  */
  if (manageFiles(sGranuleHandle, 0, DELETE_FILE) != TK_SUCCESS)
  {
	/* Deleting sGranuleHandle from error list failed */ 
	TKreportWarning(W_TK_FAILDLGHEL);
	return(W_TK_FAILDLGHEL);
  }

  manageFiles(sGranuleHandle, 0, DELETE_ALL_LISTS);

  /*
  ** if the productID represents for level 1 GV product, then delete
  ** the level 1 GV template from the level 1 GV template list using
  ** hOpenID.
  */
  if (l1gvFlag)
  {
       if (manageL1GVtemplate(DELETE_L1GV_TEMPLATE, sGranuleHandle->cfgSTR->hOpenID, 
                              '\0', NULL, -1, -1) != TK_SUCCESS)
       {
	/* Deleting a L1-GV template failed. */
	TKreportWarning(W_TK_FAILDTCL);
	return(W_TK_FAILDTCL);
       }
  }

  /* 
  ** Deallocate all the memory allocated by parsing. The parsing
  ** procedure allocates memory in its procedure and they are
  ** used through out the program.  TKclose frees all the memory
  ** allocated by parse.
  */

  deallocateCFG_STR(&sGranuleHandle->cfgSTR);

  /*
  ** If there does not exist any error condition, return TK_SUCCESS.
  */
  return(status);
}



/***********************************************************************************
*
*  FUNCTION STATEMENT:
*       TKseek(IO_HANDLE *sGranuleHandle, int offset, int type)
*
*  DESCRIPTION:
*       This routine is used to seek a requested position of vdata and sds
*	on HDF file.
*
*  INPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       sGranuleHandle          A structure containing information about the file 
*                               and the file pointers.
*	offset			An offset is used to interpret the relative position
*				from the current postion.
*	type			Type is used to select a specific TKseek to be performed.
*
*  OUTPUT PARAMETERS:           
*       Parameter Name          Description
*       --------------          -----------
*	sGranuleHandle		This structure contains the new currNumOfScanl position.
*
*  CALLED BY:                   main program
*
*  RETURN VALUES:               W_TK_BADOFSET, W_TK_BADTYPSK, 
*                               W_TK_BADMODES, TK_SUCCESS
*
*  ROUTINES CALLED:
*	Routine Called		Description
*	--------------		-----------
*       TKreportWarning()       This routine is used for warnings and informational
*                               messages.  Calling this routine will send an error
*                               message to a central log file and return control to
*                               the calling routine.
*	resetVgroup()
*
***********************************************************************************/

int TKseek(IO_HANDLE *sGranuleHandle, int offset, int type)
{
  int offsetPos;

  /* 
   *  Check if the granule is empty.  If it is, then return to the calling
   *  application.  Otherwise, do the seek.
   */
  if ( sGranuleHandle->granuleFlag == TK_TRUE )
    {
      switch(type)
	{  
	case TK_ABS_SCAN_OFF : 
	  /**
	   ** If type is TK_ABS_SCAN_OFF, offset is an integer specifying
	   **	the scan line relative to the beginning of the orbit. 
	   **/
	  
	  if ((sGranuleHandle->productID == TK_L1B_11)|| 
	      (sGranuleHandle->productID == TK_L2A_12))
	    {
	      offsetPos = TK_OSS + offset;
	    }
	  else
	    {    
	      offsetPos = offset;
	    }
	  break;
	  
	case TK_REL_SCAN_OFF :
	  /**
	   ** If type is TK_REL_SCAN_OFF, offset is an integer specifying
	   ** the number of scan lines to move, relative to the current
	   ** scan.
	   **
	   ** Calculate offset position and check if they are out of
	   ** range.
	   **/
	  offsetPos = sGranuleHandle->currNumOfScanl + offset;
	  
	  /*
	   ** Once the metadata is finalized, the scanline number will	
	   ** be stored on the metadata content.  By using its number
	   ** to check if the offset position is greater than the existing
	   ** number of scanlines.  If it is the case, echo appropriate 
	   ** error message.
	   */
	  
	  break;
	  
	default:
	  /* Undefined type in TKseek  */
	  TKreportWarning(W_TK_BADTYPSK); 
	  return(W_TK_BADTYPSK);
	  
	} /* End of Switch on Type */
      
      if (offsetPos < 0)
	{
	  /* Invalid offset */
	  TKreportWarning(W_TK_BADOFSET);
	  return(W_TK_BADOFSET);
	}
      if ((sGranuleHandle->productID == TK_L1B_GV ||
	   sGranuleHandle->productID == TK_L1C_GV))
	{
	  resetVgroup(sGranuleHandle->cfgSTR->vGroup, 0);
	}
      else
	resetVgroup(sGranuleHandle->cfgSTR->vGroup->subVgroup, offsetPos);
      
      sGranuleHandle->currNumOfScanl = offsetPos;
      sGranuleHandle->nRecords = -1;
    }
  else 
    return ( W_TK_NOGRANULEDATA );

  return(TK_SUCCESS);
}



/***************************************************************************************
*
*  FUNCTION STATEMENT:
*	TKendOfFile(IO_HANDLE *sGranuleHandle)
*
*  DESCRIPTION:
*	This routine finds the number of records in the HDF file the first time when
*       it is called.  The number of records is compared with the number of current
*	scanlines.  If they are same, then it returns TK_EOF which indicates that 
*	it is at the end of file., Otherwise it return TK_FAIL which indicates that
*	it is not at the end of file.
*
*  INPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       sGranuleHandle		A structure containing information about the file
*				from which data can be obtained.  sGranuleHandle
*				is returned by TKopen(). 
*
*  OUTPUT PARAMETERS:		None
*
*  CALLED BY:                   main program
*
*  RETURN VALUES:               TK_EOF if is at the end of file.
*				W_TK_BADMODEEF, W_TK_FAILVSQCEF, W_TK_FAILSDGIEF
*                               W_TK_EMPTYHDFEF, TK_FAIL
*
*  ROUTINES CALLED:
*       Routine Called          Description
*       --------------          -----------
*       TKreportWarning()	This routine is used to process Warnings and Errors.
*
*	SDgetinfo		This routine gets the name, rank, dimension sizes,
*				number type and attribute count for specified data set.
*
*	VSQuerycount		This routine finds the number of records in Vdata.
*	
****************************************************************************************/
int TKendOfFile(IO_HANDLE *sGranuleHandle)
{
  int32 tempRank[1];
  int32 tempNT[1];
  int32 tempNattr[1];
  int32 tempDimSize[MAX_RANK];
  char  tempSDSname[MAX_SIZE];
  int32 tempID;


  if (sGranuleHandle->mode != TK_READ_ONLY)
  {
      /* Incorrect file mode in TKendOfFile. */
      TKreportWarning(W_TK_BADMODEEF);
      return(W_TK_BADMODEEF);
  }


  if (sGranuleHandle->granuleFlag == TK_FALSE)
	return(TK_EOF);


  /* If this is the first time calling this routine, then find the number of records
  ** stored in the HDF file.
  */
  if (sGranuleHandle->nRecords == -1)
  {
      /* if the productID is L1 GV, then find the number of VOS which represents,
      ** the number records.
      */
      if ((sGranuleHandle->productID == TK_L1B_GV) ||
	  (sGranuleHandle->productID == TK_L1C_GV))
      {
	   sGranuleHandle->nRecords = TKgetNvos(sGranuleHandle);
      }
      else
      {
           /* If there is at least one vdata object, then use its ID to find the number 
           ** of records.
           */
           if (sGranuleHandle->cfgSTR->vGroup->subVgroup->vdata != NULL)
           {
               tempID = sGranuleHandle->cfgSTR->vGroup->subVgroup->vdata->vdataID;
               if (VSQuerycount(tempID, &sGranuleHandle->nRecords) == TK_HDF_FAIL)
               {
                   TKreportWarning(W_TK_FAILVSQCEF);
		   return(W_TK_FAILVSQCEF);
               }
           }
           else
           {
               /* If there is at least one sds object, then use its ID to find the
               ** number of records.
               */
               if (sGranuleHandle->cfgSTR->vGroup->subVgroup->sds != NULL)
               {
                   tempID = sGranuleHandle->cfgSTR->vGroup->subVgroup->sds->sdsID;
                   if (SDgetinfo(tempID, tempSDSname, tempRank, tempDimSize, tempNT, 
                                 tempNattr) == TK_HDF_FAIL)
                   {
                       TKreportWarning(W_TK_FAILSDGIEF);
		       return(W_TK_FAILSDGIEF);
                   }
                   sGranuleHandle->nRecords = tempDimSize[0];
               }
               else
               {
	           TKreportWarning(W_TK_EMPTYHDFEF);
		   return(W_TK_EMPTYHDFEF);
               }
           }
      }
  }

  /* The following code handles the end of an orbit for a TMI instrument 
  ** If the algorithm is 1A-11, 1B-11 or 2A-12, the file pointer will point
  ** to the end of the orbit instead of end of the file since these 
  ** algorithms are products with overlaps.
  ** the code will return TK_EOO if the file pointer is at the end of an
  ** orbit, else it will return TK_FAIL.
  */

  if((sGranuleHandle->productID == TK_L1B_11)||
     (sGranuleHandle->productID == TK_L2A_12))
  {
     if (sGranuleHandle->currNumOfScanl == (sGranuleHandle->nRecords) - TK_OSS)
     {
       return(TK_EOO);
     }
     else
     {
       if (sGranuleHandle->nRecords == sGranuleHandle->currNumOfScanl)
       {
	   if(sGranuleHandle->nRecords >= 100)
	   {
           	return(TK_EOF);
	   }
	   else
		return(TK_EOO);
       }
       else
       {
           return (TK_FAIL);
       }
     }
  }
  /* 
  ** If the number of records matches wtih currNumOfScanl , then return to a
  ** caller that it is at the end of file.
  */
  
  if (sGranuleHandle->nRecords == sGranuleHandle->currNumOfScanl)
  {
     return(TK_EOF);
  }

  /* 
  ** If the number of records does not match with currNumOfScanl, then return 
  ** to a caller that it is not at the end of file by returning TK_FAIL.
  */
  else
  {
      return(TK_FAIL);
  }
}





/*****************************************************************************
*
*  FUNCTION STATEMENT:
*	TKgetNvos(IO_HANDLE *sGranuleHandle)
*
*  DESCRIPTION:
*       This routine returns the number of volume scans for a given 
*	sGranuleHandle.
*
*  INPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*	sGranuleHandle		A structure containing information about the file.
*                               sGranuleHandle is returned by TKopen().
*
*  OUTPUT PARAMETERS:           None.
*
*  CALLED BY:                   main program
*
*  RETURN VALUES:               The number of volume scans.
*
*  ROUTINES CALLED:
*       Routine Name            Description
*       ------------            -----------
*       manageL1GVtemplate      This routine performs a requested action.  The 
*                               requestion is described by opType.
*
******************************************************************************/

int32 TKgetNvos(IO_HANDLE *sGranuleHandle)
{
  /*
  ** Call manageL1GVtemplate in order to find the number of volume scans.
  ** TKgetNvos is defined in order to provide easy aceess to get
  ** number of volume scans.
  */
  return (manageL1GVtemplate(GET_L1GV_NUM_OF_VOS, sGranuleHandle->cfgSTR->hOpenID, 
			     '\0', NULL,  -1, -1));
}

/***************************************************************************** 
*
*  FUNCTION STATEMENT:
*       TKgetNumNetDesc(IO_HANDLE *sGranuleHandle)
*
*  DESCRIPTION:
*       This routine returns the number of network descriptor headers for a    
*       given sGranuleHandle.
*
*  INPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       sGranuleHandle          A structure containing information about the file.
*                               sGranuleHandle is returned by TKopen().
*
*
*  OUTPUT PARAMETERS:           None.
*
*  CALLED BY:                   main program
*
*  RETURN VALUES:               The number of network descriptor headers
*
*  ROUTINES CALLED:             VSelts 
*
*****************************************************************************/
int TKgetNumNetDesc(IO_HANDLE *sGranuleHandle)
{
  return VSelts(sGranuleHandle->cfgSTR->vGroup->vdata->vdataID);
}


/*****************************************************************************
*
*  FUNCTION STATEMENT:
*       TKgetNsensor(IO_HANDLE *sGranueHandle)
*
*  DESCRIPTION:
*       This routine returns the number of sensors for each volume scans.
*	Since there is only one sensor for every volume scan, it always
*	return 1.
*
*  INPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       sGranuleHandle          A structure containing information about the file.
*                               sGranuleHandle is returned by TKopen().
*
*  OUTPUT PARAMETERS:           None.
*
*  CALLED BY:                   main program
*
*  RETURN VALUES:               The number of sensor.
*
*  ROUTINES CALLED:		NONE
*
******************************************************************************/

int32 TKgetNsensor(IO_HANDLE *sGranueHandle)
{
  /*
  ** Since there is only one sensor for every volume scan, this routine always
  ** returns 1.  If the number of sensor is more one than per a volume scan, 
  ** this routine needs to be modified.
  */
  return (1);
}


/*****************************************************************************
*
*  FUNCTION STATEMENT:
*	 TKgetNparm(IO_HANDLE *sGranuleHandle, int32 vosNumber)
*
*  DESCRIPTION:
*       This routine returns the number of parameter for a given volume
*	scan number.
*
*  INPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       sGranuleHandle          A structure containing information about the file.
*                               sGranuleHandle is returned by TKopen().
*	vosNumber		The volume scan number.
*
*  OUTPUT PARAMETERS:           None
*
*  CALLED BY:                   main program
*
*  RETURN VALUES:               The number of prameters for a given volume scan
*				number.
*
*  ROUTINES CALLED:
*       Routine Name            Description
*       ------------            -----------
*       manageL1GVtemplate      This routine performs a requested action.  The 
*                               requestion is described by opType.
*
******************************************************************************/

int32 TKgetNparm(IO_HANDLE *sGranuleHandle, int32 vosNumber)
{
  /*
  ** Call manageL1GVtemplate in order to find the number of parmeters for
  ** the volume scan number.  TKgetNUmOFParm is defined in order to provide 
  ** easy aceess to get number of parameters.
  */
  return (manageL1GVtemplate(GET_L1GV_NUM_OF_PARM, sGranuleHandle->cfgSTR->hOpenID,
	  		     '\0', NULL, vosNumber, -1));
}


/*****************************************************************************
*
*  FUNCTION STATEMENT:
*	TKgetNcell(IO_HANDLE *sGranuleHandle, int32 vosNumber, int32 parmNumber)
*
*  DESCRIPTION:
*       This routine returns the number of cells for a given volume
*       scan number and a parameter number.
*
*  INPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       sGranuleHandle          A structure containing information about the file.
*                               sGranuleHandle is returned by TKopen().
*       vosNumber              The volume scan number.
*	parmNumber		The parameter number for the given volume scan number.
*
*  OUTPUT PARAMETERS:           None
*
*  CALLED BY:                   main program
*
*  RETURN VALUES:               The number of cell for the given volume scan
*                               number and the given parameter number.
*
*  ROUTINES CALLED:
*       Routine Name            Description
*       ------------            -----------
*       manageL1GVtemplate      This routine performs a requested action.  The 
*                               requestion is described by opType.
*
******************************************************************************/

int32 TKgetNcell(IO_HANDLE *sGranuleHandle, int32 vosNumber, int32 parmNumber)
{
  /*
  ** Call manageL1GVtemplate in order to find the number of cells for 
  ** the given volume scan number and parameter number.  TKgetNcell is defined
  ** in order to provide easy access to get number of cells.
  */
  return (manageL1GVtemplate(GET_L1GV_NCELL, sGranuleHandle->cfgSTR->hOpenID, 
	   		     '\0', NULL, vosNumber, parmNumber));
}


/*****************************************************************************
*
*  FUNCTION STATEMENT:
*	TKgetNray(IO_HANDLE *sGranuleHandle,  int32 vosNumber)
*
*  DESCRIPTION:
*       This routine returns the number of rays for a given volume scan number.
*
*  INPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       sGranuleHandle          A structure containing information about the file.
*                               sGranuleHandle is returned by TKopen().
*       vosNumber               The volume scan number.
*
*  OUTPUT PARAMETERS:           None.
*
*  CALLED BY:                   main program
*
*  RETURN VALUES:               The number of rays for a given volume scan
*                               number.
*
*  ROUTINES CALLED:
*       Routine Name            Description
*       ------------            -----------
*       manageL1GVtemplate      This routine performs a requested action.  The 
*                               requestion is described by opType.
*
******************************************************************************/

int32 TKgetNray(IO_HANDLE *sGranuleHandle,  int32 vosNumber)
{
  /*
  ** Call mangeL1GVtemplate in order to get the number of rays for the given
  ** volume scan number.  TKgetNray is used to provide easy access to get
  ** the number of rays.
  */
  return (manageL1GVtemplate(GET_L1GV_NRAY, sGranuleHandle->cfgSTR->hOpenID, 
			     '\0', NULL, vosNumber, -1));
}


/*****************************************************************************
*
*  FUNCTION STATEMENT:
*	 TKgetNsweep(IO_HANDLE *sGranuleHandle, int32 vosNumber)
*
*  DESCRIPTION:
*       This routine returns the number of sweeps for a given volume scan number.
*
*  INPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       sGranuleHandle          A structure containing information about the file.
*                               sGranuleHandle is returned by TKopen().
*       vosNumber               The volume scan number.
*
*  OUTPUT PARAMETERS:           None.
*
*  CALLED BY:                   main program
*
*  RETURN VALUES:               The number of sweeps for a given volume scan
*                               number.
*  ROUTINES CALLED:
*       Routine Name            Description
*       ------------            -----------
*       manageL1GVtemplate      This routine performs a requested action.  The 
*                               requestion is described by opType.
*
******************************************************************************/

int32 TKgetNsweep(IO_HANDLE *sGranuleHandle, int32 vosNumber)
{
  /* 
  ** Call manageL1GVtemplate to get the number of sweeps for the given volume
  ** scan number.  TKgetNsweep is used to prvoide easy access to find the
  ** number of sweeps.
  */
 
  return (manageL1GVtemplate(GET_L1GV_NSWEEP, sGranuleHandle->cfgSTR->hOpenID, 
			     '\0', NULL, vosNumber, -1));
}





/***********************************************************************************
*
*  FUNCTION STATEMENT:
*       TKreadHeader(IO_HANDLE *sGranuleHandle, void *sHeader)
*
*  DESCRIPTION:
*       This routine is used to read product header data from a file and store them 
*	into the product data structure.
*
*  INPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       sGranuleHandle          A structure containing information about the file
*                               from which data can be obtained.  sGranuleHandle 
*                               is returned by TKopen().
*
*  OUTPUT PARAMETERS:           
*       Parameter Name          Description
*       --------------          -----------
*       sHeader			A structure containing the complete header data.
*                               This structure must be declared to correspond to
*                               the data file to be obtained.
*
*  CALLED BY:                   main program
*
*  RETURN VALUES:               TK_SUCCESS, W_TK_NOGRANULEDATA, W_TK_BADPIDRH,
*				W_TK_BADFILEMODERH
*
*  ROUTINES CALLED:
*	readL1B21_L1C21Header(), readL2A25Header(), TKreportWarning()
*
***********************************************************************************/

int TKreadHeader(IO_HANDLE *sGranuleHandle, void *sHeader)
{

  if (sGranuleHandle->mode == TK_READ_ONLY)
  {
    /**
     ** Check for empty granule status.  If granuleFlag equals TK_TRUE, file 
     ** contains scan info.  If TK_FALSE, that is an empty granule file.
     **/
    if (sGranuleHandle->granuleFlag == TK_TRUE)
    {
      switch (sGranuleHandle->productID)
      {
	case TK_L1B_21:
	case TK_L1C_21:
	  return(readL1B21_L1C21Header(sGranuleHandle, sHeader));

	case TK_L2A_25:
	case TK_L2N_25:
	  return(readL2A25Header(sGranuleHandle, sHeader));

	default:
	  /* Invalid product ID in TKreadHeader. */
	  TKreportWarning(W_TK_BADPIDRH);
	  return(W_TK_BADPIDRH);
      }
    }
    else
	return(W_TK_NOGRANULEDATA);
  }
  else
  {
    /* Invalid filemode in TKreadHeader. */
    TKreportWarning(W_TK_BADFILEMODERH);
    return(W_TK_BADFILEMODERH);
  }

  return(TK_SUCCESS);
}



/***********************************************************************************
*
*  FUNCTION STATEMENT:
*       TKwriteHeader(IO_HANDLE *sGranuleHandle, void *sHeader)
*
*  DESCRIPTION:
*       This routine is used to write product header data to a hdf file.
*
*  INPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       sGranuleHandle          A structure containing information about the file
*                               from which data being written.  sGranuleHandle 
*                               is returned by TKopen().
*       sHeader			A structure containing the complete header data.
*                               This structure must be declared to correspond to 
*                               the data file being written. 
*
*  OUTPUT PARAMETERS:           None
*
*  CALLED BY:                   main program
*
*  RETURN VALUES:               TK_SUCCESS, W_TK_BADPIDWH, W-TK_BADFILEMODEWH
*
*  ROUTINES CALLED:
*	writeL1B21_L1C21Header(), writeL2A25Header(), TKreportWarning()
*
***********************************************************************************/

int TKwriteHeader(IO_HANDLE *sGranuleHandle, void *sHeader)
{

  if (sGranuleHandle->mode == TK_NEW_FILE)
  {
    switch(sGranuleHandle->productID)
    {
	case TK_L1B_21:
	case TK_L1C_21:
	  return(writeL1B21_L1C21Header(sGranuleHandle, sHeader)); 

	case TK_L2A_25:
	case TK_L2N_25:
	  return(writeL2A25Header(sGranuleHandle, sHeader));

	default:
	  /* Invalid product ID in TKwriteHeader. */
	  TKreportWarning(W_TK_BADPIDWH);
	  return(W_TK_BADPIDWH);
    }
  }
  else
  {
    /* Invalid filemode in TKwriteHeader. */
    TKreportWarning(W_TK_BADFILEMODEWH);
    return(W_TK_BADFILEMODEWH);
  }

  return(TK_SUCCESS);
}


/***********************************************************************************
*
*  FUNCTION STATEMENT:
*	TKwriteNetHeader(IO_HANDLE *sGranuleHandle, int nnet, void *sNetDesc)
*
*  DESCRIPTION:
*       This routine is used to write L2A56 or L2A57 Network Descriptor header data 
*	to a hdf file.
*
*  INPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       sGranuleHandle          A structure containing information about the file
*                               from which data being written.  sGranuleHandle
*                               is returned by TKopen().
*	nnet			The number of networks at a radar site.
*       sNetDesc		A structure containing the complete header data.
*                               This structure must be declared to correspond to 
*                               the data file being written. 
*
*  OUTPUT PARAMETERS:           None
*
*  CALLED BY:                   main program
*
*  RETURN VALUES:               TK_SUCCESS, W_TK_BADPIDNETHDR, W_TK_BADFMODENETHDR
*
*  ROUTINES CALLED:
*       writeNetworkDesc(), TKreportWarning()
*
***********************************************************************************/

int TKwriteNetHeader(IO_HANDLE *sGranuleHandle, int nnet, void *sNetDesc)
{

  if (sGranuleHandle->mode == TK_NEW_FILE)
  {
    switch(sGranuleHandle->productID)
    {
        case TK_L2A_56:
        case TK_L2A_57:
          return(writeNetworkDesc(sGranuleHandle, nnet, sNetDesc));

        default:
	  /* Invalid product identifier for TKwriteNetHeader. */
          TKreportWarning(W_TK_BADPIDNETHDR);
          return(W_TK_BADPIDNETHDR);
    }
  }
  else
  {
    /* Invalid filemode for TKwriteNetHeader. */
    TKreportWarning(W_TK_BADFMODENETHDR);
    return(W_TK_BADFMODENETHDR);
  }

  return(TK_SUCCESS);
}



/***********************************************************************************
*
*  FUNCTION STATEMENT:
*       TKreadNetHeader(IO_HANDLE *sGranuleHandle, int nnet, void *sNetDesc)
*
*  DESCRIPTION:
*       This routine is used to read L2A56 or L2A57 Network Descriptor header data
*       to a hdf file.
*
*  INPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       sGranuleHandle          A structure containing information about the file
*                               from which data being written.  sGranuleHandle
*                               is returned by TKopen().
*       nnet                    The number of networks at a radar site.
*       sNetDesc                A structure containing the complete header data.
*                               This structure must be declared to correspond to
*                               the data file being written.
*
*  OUTPUT PARAMETERS:           None.
*
*  CALLED BY:                   main program
*
*  RETURN VALUES:               TK_SUCCESS, W_TK_BADPIDRNETHDR,
*                               W_TK_BADFMODERNETHDR, W_TK_NOGRANULEDATA
*
*  ROUTINES CALLED:
*       readNetworkDesc(),TKreportWarning()
***********************************************************************************/

int TKreadNetHeader(IO_HANDLE *sGranuleHandle, int nnet, void *sNetDesc)        
{  

  if (sGranuleHandle->mode == TK_READ_ONLY)
  {
    if (sGranuleHandle->granuleFlag == TK_TRUE)
    {
      switch(sGranuleHandle->productID)
      {
        case TK_L2A_56:
        case TK_L2A_57:
          return(readNetworkDesc(sGranuleHandle, nnet, sNetDesc));
        default:
          TKreportWarning(W_TK_BADPIDRNETHDR);
          return(W_TK_BADPIDRNETHDR);
       }
     }
     else
       return(W_TK_NOGRANULEDATA);
   }
  else
  {
     TKreportWarning(W_TK_BADFMODERNETHDR);
     return(W_TK_BADFMODERNETHDR);
  }
  return(TK_SUCCESS);
}



/***********************************************************************************
*
*  FUNCTION STATEMENT:
*	TKwriteGauge(IO_HANDLE *sGranuleHandle, void *sGauge_Disdrometer)
*
*  DESCRIPTION:
*       This routine is used to write L2A56 or L2A57 data to a hdf file.
*
*  INPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*       sGranuleHandle          A structure containing information about the file
*                               from which data being written.  sGranuleHandle
*                               is returned by TKopen().
*       sGauge_Disdrometer	A structure containing the complete header data.
*                               This structure must be declared to correspond to
*                               the data file being written.
*
*  OUTPUT PARAMETERS:           None
*
*  CALLED BY:                   main program
*
*  RETURN VALUES:               TK_SUCCESS, W_TK_BADPIDWTGAUGE, W_TK_BADFMODEWTGAUGE
*
*  ROUTINES CALLED:
*       writeGauge(), writeDisdrometer(), TKreportWarning()
*
***********************************************************************************/

int TKwriteGauge(IO_HANDLE *sGranuleHandle, void *sGauge_Disdrometer)
{

  if (sGranuleHandle->mode == TK_NEW_FILE)
  {
    switch(sGranuleHandle->productID)
    {
        case TK_L2A_56:
          return(writeGauge(sGranuleHandle, sGauge_Disdrometer));

        case TK_L2A_57:
          return(writeDisdrometer(sGranuleHandle, sGauge_Disdrometer));

        default:
          /* Invalid product identifier for TKwriteHeader. */
          TKreportWarning(W_TK_BADPIDWTGAUGE);
          return(W_TK_BADPIDWTGAUGE);
    }
  }
  else
  {
    /* Invalid filemode for TKwriteGauge. */
    TKreportWarning(W_TK_BADFMODEWTGAUGE);
    return(W_TK_BADFMODEWTGAUGE);
  }

  return(TK_SUCCESS);
}


/***********************************************************************************
*
*  FUNCTION STATEMENT:
*       TKreadGauge(IO_HANDLE *sGranuleHandle,void *sGauge_Disdrometer)
*
*  DESCRIPTION:
*       This routine is used to read L2A56 and L2A57 data from an HDF file.
*
*  INPUT PARAMETERS:
*       Parameter Name           Description
*       --------------           -----------
*       sGranuleHandle           A structure containing information about the file 
*                                from which data being written.  sGranuleHandle
*                                is returned by TKopen().
*       sGauge_Disdrometer       A structure containing the complete header data.
*                                This structure must be declared to correspond to
*                                the data file being written.
*
*  OUTPUT PARAMETERS:            None.
*
*  CALLED BY:                    main program
*
*  RETURN VALUES:                TK_SUCCESS, W_TK_BADPIDRDGAUGE
*                                W_TK_NOGRANULEDATA,W_TK_BADFMODERDGAUGE
*
*  ROUTINES CALLED:
*       readGauge(),readDisdrometer(),TKreportWarning() 
*
***********************************************************************************/

int TKreadGauge(IO_HANDLE *sGranuleHandle, void *sGauge_Disdrometer)
{
  if (sGranuleHandle->mode ==  TK_READ_ONLY)
  {
    if (sGranuleHandle->granuleFlag == TK_TRUE)
    {
      switch (sGranuleHandle->productID)
      {
    
        case TK_L2A_56 :
          return(readGauge(sGranuleHandle, sGauge_Disdrometer));

        case TK_L2A_57 :
          return(readDisdrometer(sGranuleHandle, sGauge_Disdrometer));

        default:
          /* Invalid product identifier for TKreadHeader */
          TKreportWarning(W_TK_BADPIDRDGAUGE);
          return(W_TK_BADPIDRDGAUGE);
      } 
    }
    else
      return(W_TK_NOGRANULEDATA);
  }
  else
  {
       /* Invalid file mode for TKreadGauge */
       TKreportWarning(W_TK_BADFMODERDGAUGE);
       return(W_TK_BADFMODERDGAUGE);
  }
      
  return(TK_SUCCESS);

}

/***********************************************************************************
*
*  FUNCTION STATEMENT:
*        int TimesCompared ( DATE_STR *sStartDate, TIME_STR *sStartTime, 
*		             struct tm *sTimeCA, DATE_STR *sEndDate, 
*		             TIME_STR *sEndTime ) 
*
*  DESCRIPTION:
*       This routine will compare the beginning and ending time to the time of
*       closest approach.  If the time of closest approach is in the middle, then
*       the routine will return a success.
*
*  INPUT PARAMETERS:
*       Parameter Name           Description
*       --------------           -----------
*       sStartDate               The beginning date.
*       sStartTime               The beginning time.
*       sEndDate                 The ending date.
*       sEndTime                 The ending time.
*       sTimeCA                  The time of closest approach.
*
*  OUTPUT PARAMETERS:            None.
*
*  CALLED BY:                    TKqueryGVCoincidence().
*
*  RETURN VALUES:                TK_SUCCESS, TK_FAIL
*
*  ROUTINES CALLED:              None.
*
***********************************************************************************/
int TimesCompared ( DATE_STR *sStartDate, TIME_STR *sStartTime, 
		   struct tm *sTimeCA, DATE_STR *sEndDate, 
		   TIME_STR *sEndTime ) 
{
  struct tm sStartDateTime, sStopDateTime;
  time_t startSecs, stopSecs, caSecs;
  int status;

  sStartDateTime.tm_year = sStartDate->tkyear;
  sStartDateTime.tm_year -= 1900;
  sStartDateTime.tm_mon = sStartDate->tkmonth;
  sStartDateTime.tm_mon--;
  sStartDateTime.tm_mday = sStartDate->tkday;
  sStartDateTime.tm_hour = sStartTime->tkhour;
  sStartDateTime.tm_min = sStartTime->tkminute;
  sStartDateTime.tm_sec = sStartTime->tksecond;
  sStartDateTime.tm_wday = 0;
  sStartDateTime.tm_yday = 0;
  sStartDateTime.tm_isdst = -1;
  startSecs = mktime ( &sStartDateTime );

  sStopDateTime.tm_year = sEndDate->tkyear;
  sStopDateTime.tm_year -= 1900;
  sStopDateTime.tm_mon = sEndDate->tkmonth;
  sStopDateTime.tm_mon--;
  sStopDateTime.tm_mday = sEndDate->tkday;
  sStopDateTime.tm_hour = sEndTime->tkhour;
  sStopDateTime.tm_min = sEndTime->tkminute;
  sStopDateTime.tm_sec = sEndTime->tksecond;
  sStopDateTime.tm_wday = 0;
  sStopDateTime.tm_yday = 0;
  sStopDateTime.tm_isdst = -1;
  stopSecs = mktime ( &sStopDateTime );

  sTimeCA->tm_year -= 1900;
  sTimeCA->tm_mon--;
  sTimeCA->tm_wday = 0;
  sTimeCA->tm_yday = 0;
  sTimeCA->tm_isdst = -1;
  caSecs = mktime ( sTimeCA );

  if ( ( difftime ( caSecs, startSecs ) > 0 ) &&
      ( difftime ( stopSecs, caSecs ) > 0 ) )
    status = TK_SUCCESS;
  else
    status = TK_FAIL;

  sTimeCA->tm_year += 1900;
  sTimeCA->tm_mon++;
  
  return status;
}

/***********************************************************************************
*
*  FUNCTION STATEMENT:
*             int TKqueryGVCoincidenceInfo ( int instrID, DATE_STR *sStartDate, 
*			              TIME_STR *sStartTime, DATE_STR *sEndDate,
*			              TIME_STR *sEndTime, char *coinFile,
*			              char *CoinDate, char *CoinTime,
*			              float *DistOfClosApp )
*
*  DESCRIPTION:
*	This routine is will retrieve GV coincidence information for the 2A52 
*       algorithm.  When the algorithm is running in TSDIS, it will query the
*       database;  when the algorithm is running at the science home site, it will
*       query the ASCII text file.
*
*  INPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*	instrID			GV site identifier
*       sStartDate              Starting date
*	sStartTime		Starting time
*       sEndDate                Ending date
*	sEndTime		Ending time
*       coinFile                The name of the coincidence file (only used in TSU_ENV
*                               mode).
*
*  OUTPUT PARAMETERS:		
*       Parameter Name          Description
*       --------------          -----------
*       CoinDate                The date of coincidence
*       CoinTime                The time of coincidence
*       DistOfClosApp           The distance of closest approach
*
*  CALLED BY:                   main program
*
*  RETURN VALUES:               TK_SUCCESS, TK_FAIL, TK_NO_RECORD
*
*  ROUTINES CALLED:
*       Routine Called          Description
*       --------------          -----------
*       TKreportWarning()       This routine is used to report warning message to
*                               the console.
*       IMallocateRec()         This routine is used to allocate memory for the 
*                               data structure
*       IMopen                  Routine used to open the Database
*       IMfreeRec()             Routine to free the memory allocated earlier
*       IMclose                 Routine to close the database
*       IMquery                 Routine to query the database
*
******************************************************************************/
int TKqueryGVCoincidenceInfo ( int instrID, DATE_STR *sStartDate, 
			      TIME_STR *sStartTime, DATE_STR *sEndDate,
			      TIME_STR *sEndTime, char *coinFile,
			      char *CoinDate, char *CoinTime,
			      float *DistOfClosApp )
{
  FILE *sFilePtr = NULL;
  struct tm sTimeCA;
  int lineCount;
  int orbitNumber, recordFound = TK_NO_RECORD;
  char buffer[TK_BUFFER_LENGTH];
  char radarID[TK_BUFFER_LENGTH], radarCode[TK_BUFFER_LENGTH]; 
  char timeCA[TK_BUFFER_LENGTH];
  char asciiTime[28];
  int year, mon, day, hour, min, sec, msec;
  
#ifndef TSU_ENV
  int IMstatus;
  IMsession *sSession;
  IMget_GVbrowse_Info_Struct *sCoincidenceInput = NULL;
  IMget_GVbrowse_Info_Return_Struct *sCoincidenceOutput = NULL;

  IMstatus = IMopen ( TK_IM_USER_ID, &sSession );
  if ( IMstatus != IM_SUCCESS )
    {
      TKreportWarning ( W_TK_FAILIMOPEN );
      return ( W_TK_FAILIMOPEN );
    }
  sCoincidenceInput = IMallocateRec ( IM_GET_GVBROWSE );
  if ( sCoincidenceInput == NULL )
    {
      IMclose ( sSession );
      TKreportWarning ( W_TK_FAILALLOCREC );
      return ( W_TK_FAILALLOCREC );
    }

  sCoincidenceInput->Desired_Start_Datim = ( struct tm * )
    calloc ( 1, sizeof ( struct tm ) );
  sCoincidenceInput->Desired_Stop_Datim = ( struct tm * )
    calloc ( 1, sizeof ( struct tm ) );
  if ( ( sCoincidenceInput->Desired_Start_Datim == NULL ) ||
      ( sCoincidenceInput->Desired_Stop_Datim == NULL ) )
    {
      if ( sCoincidenceInput != NULL )
	IMfreeRec ( sCoincidenceInput );
      TKreportWarning ( W_TK_BADMEMALLCAT );
      return ( W_TK_BADMEMALLCAT );
    }

  strcpy ( sCoincidenceInput->Instrument_ID, radarType ( instrID ) );
  sCoincidenceInput->Desired_Start_Datim->tm_year = sStartDate->tkyear;
  sCoincidenceInput->Desired_Start_Datim->tm_year -= 1900;
  sCoincidenceInput->Desired_Start_Datim->tm_mon = sStartDate->tkmonth;
  --(sCoincidenceInput->Desired_Start_Datim->tm_mon);
  sCoincidenceInput->Desired_Start_Datim->tm_mday = sStartDate->tkday;
  sCoincidenceInput->Desired_Start_Datim->tm_hour = (int) sStartTime->tkhour;
  sCoincidenceInput->Desired_Start_Datim->tm_min = (int) sStartTime->tkminute;
  sCoincidenceInput->Desired_Start_Datim->tm_sec = (int) sStartTime->tksecond;

  sCoincidenceInput->Desired_Stop_Datim->tm_year = sEndDate->tkyear;
  sCoincidenceInput->Desired_Stop_Datim->tm_year -= 1900;
  sCoincidenceInput->Desired_Stop_Datim->tm_mon = sEndDate->tkmonth;
  --(sCoincidenceInput->Desired_Stop_Datim->tm_mon);
  sCoincidenceInput->Desired_Stop_Datim->tm_mday = sEndDate->tkday;
  sCoincidenceInput->Desired_Stop_Datim->tm_hour = (int) sEndTime->tkhour;
  sCoincidenceInput->Desired_Stop_Datim->tm_min = (int) sEndTime->tkminute;
  sCoincidenceInput->Desired_Stop_Datim->tm_sec = (int) sEndTime->tksecond;

  IMstatus = IMquery ( sSession, ( IMdata * ) sCoincidenceInput,
		      ( IMreturn ** ) &sCoincidenceOutput );
  if ( IMstatus != IM_SUCCESS )
    {
      recordFound = TK_FAIL;
      if ( IMstatus == W_IM_QUERYRESULTS_NOTFOUND )
	recordFound = TK_NO_RECORD;
    }
  else 
    {
      recordFound = TK_RECORD_FOUND;
      *DistOfClosApp = sCoincidenceOutput->Closest_Approach;
      PGS_TD_TAItoUTC ( sCoincidenceOutput->Decimal_Time_Of_Closest_Approach,
		       asciiTime );
      sscanf ( asciiTime, "%d-%d-%dT%d:%d:%d.%d", &year, &mon, &day,
	      &hour, &min, &sec, &msec );
      sprintf ( CoinDate, "%04d-%02d-%02d", year, mon, day ); 
      sprintf ( CoinTime, "%02d:%02d:%02d.%3d", hour, min, sec, msec ); 
    }
      
	  
  if ( sCoincidenceInput->Desired_Start_Datim != NULL )
    free ( sCoincidenceInput->Desired_Start_Datim );
  if ( sCoincidenceInput->Desired_Stop_Datim != NULL )
    free ( sCoincidenceInput->Desired_Stop_Datim );
  if ( sCoincidenceInput != NULL )
    IMfreeRec ( sCoincidenceInput );
  IMclose ( sSession );
#else
  sFilePtr = fopen ( coinFile, "r" );
  if ( sFilePtr == NULL )
    {
      TKreportWarning ( W_TK_COIN_FILE_OPEN );
      return ( W_TK_COIN_FILE_OPEN );
    }
  
  for ( lineCount = 0; fgets ( buffer, TK_BUFFER_LENGTH, sFilePtr ) && recordFound;
       lineCount++ )
    {
      sscanf ( buffer, "%d %s %s %s %f", &orbitNumber, 
	      radarID, radarCode, timeCA, DistOfClosApp );
      if ( !strcmp ( radarCode, radarType ( instrID ) ) ) 
	{
	  sscanf ( timeCA, "%d-%d-%dT%d:%d:%d.%d", &sTimeCA.tm_year,
		  &sTimeCA.tm_mon, &sTimeCA.tm_mday, &sTimeCA.tm_hour,
		  &sTimeCA.tm_min, &sTimeCA.tm_sec, &msec );
	  if ( TimesCompared ( sStartDate, sStartTime, &sTimeCA,
			      sEndDate, sEndTime ) == TK_SUCCESS )
	    {
	      recordFound = TK_RECORD_FOUND;
	      sprintf ( CoinDate, "%04d-%02d-%02d", sTimeCA.tm_year,
		       sTimeCA.tm_mon, sTimeCA.tm_mday );
	      sprintf ( CoinTime, "%02d:%02d:%02d.%03d", sTimeCA.tm_hour,
		       sTimeCA.tm_min, sTimeCA.tm_sec, msec );
	    }
	}
    }
  fclose ( sFilePtr );
#endif
  if ( recordFound == TK_RECORD_FOUND )
    return TK_SUCCESS;
  else
    return recordFound;
}

/***********************************************************************************
*
*  FUNCTION STATEMENT:
*	TKwriteDBRainInfo(int instrID, struct tm *sStart_time, struct tm *sEnd_time,
*			  int rain_percent)
*
*  DESCRIPTION:
*	This routine is used to write the input information from 2A52 into TSDIS
*	database.  In order to insert data to TSDIS database, -DTSDIS_TK_ENV flag
*	has to be used while compiling.  For non-TSDIS environment, this routine
*	is always returning TK_SUCCESS.
*
*  INPUT PARAMETERS:
*       Parameter Name          Description
*       --------------          -----------
*	instrID			GV site identifier
*	sStart_time		Start time of VOS
*	sEnd_time		End time of VOS
*	rain_percent		Percent Rain
*
*  OUTPUT PARAMETERS:		None
*
*  CALLED BY:                   main program
*
*  RETURN VALUES:               TK_SUCCESS, W_TK_INVALIDGVID, W_TK_FAILIMOPEN,
*				W_TK_FAILIMINSERT
*
*  ROUTINES CALLED:
*       Routine Called          Description
*       --------------          -----------
*       TKreportWarning()       This routine is used to report warning message to
*                               the console.
*       IMallocateRec()         This routine is used to allocate memory for the 
*                               data structure
*       IMopen                  Routine used to open the Database
*       IMfreeRec()             Routine to free the memory allocated earlier
*       IMclose                 Routine to close the database
*
******************************************************************************/

int TKwriteDBRainInfo(int instrID, struct tm *sStart_time, struct tm *sEnd_time, 
	int rain_percent)
{
  int status = TK_SUCCESS;

#ifndef TSU_ENV

	/***********************************/
	/* Only used for TSDIS environment */
	/***********************************/

  IMsession		*sSession;
  IMgv_Rain_Insert_Struct *insertData;
  IMgv_Rain_Update_Struct *updateData;
  int  retcode;

  /* Open the Database for Insert operation */
  retcode = IMopen(TK_IM_USER_ID, &sSession);
  if (retcode != IM_SUCCESS)
  {
        TKreportWarning(W_TK_FAILIMOPEN);
        return(W_TK_FAILIMOPEN);
  }

  /* Allocate Memory for the data structure */
  insertData = IMallocateRec(GV_RAIN_INSERT);
  if (insertData == NULL)
  {
	TKreportWarning(W_TK_FAILALLOCREC);
	IMclose(sSession);
	return(W_TK_FAILALLOCREC);
  }

  switch(instrID)
  {
    case TK_DARW:
	strcpy(insertData->Instrument_ID, "DARW");
  	insertData->Percent_Rain = rain_percent;
  	insertData->Start_Date_Time = sStart_time;
  	insertData->Stop_Date_Time = sEnd_time;
	break;

    case TK_MELB:
        strcpy(insertData->Instrument_ID, "MELB");
  	insertData->Percent_Rain = rain_percent;
  	insertData->Start_Date_Time = sStart_time;
  	insertData->Stop_Date_Time = sEnd_time;
	break;

    case TK_KWAJ:
        strcpy(insertData->Instrument_ID, "KWAJ");
  	insertData->Percent_Rain = rain_percent;
  	insertData->Start_Date_Time = sStart_time;
  	insertData->Stop_Date_Time = sEnd_time;
	break;

    case TK_HSTN:
        strcpy(insertData->Instrument_ID, "HSTN");
	insertData->Percent_Rain = rain_percent;
  	insertData->Start_Date_Time = sStart_time;
  	insertData->Stop_Date_Time = sEnd_time;
	break;


    case TK_CORC:
    case TK_FLOR:
    case TK_GUAM:
    case TK_ISBN:
    case TK_KEYW:
    case TK_LKCH:
    case TK_MIAM:
    case TK_NWBR:
    case TK_SAOP:
    case TK_TAMP:
    case TK_TEXS:
    case TK_THOM:
    case TK_TWWF:
	IMfreeRec(insertData);
	IMclose(sSession);
	return(TK_SUCCESS);

    default:
	/* Invalid GV instrument ID */
	TKreportWarning(W_TK_INVALIDGVID);
	IMfreeRec(insertData);
	IMclose(sSession);
	return(W_TK_INVALIDGVID);
  }


  /* 
   * Inserting GV Rain data into the database 
   */
  retcode = IMinsert(sSession, (IMdata*)insertData);
  if (retcode == IM_SUCCESS)
  {
    IMfreeRec(insertData);
    IMclose(sSession);
  }
  else if (retcode == E_IM_ILLEGAL_DUPLICATE_KEY)  
  /* 
   * Duplicate record.  Update the record in database instead. 
   */
  {
    updateData = IMallocateRec(GV_RAIN_UPDATE);
    if (updateData == NULL)
    {
        IMfreeRec(insertData);
	IMclose(sSession);
        TKreportWarning(W_TK_FAILALLOCREC);
        return(W_TK_FAILALLOCREC);
    }
    else
    {
    	strcpy(updateData->Instrument_ID, insertData->Instrument_ID);
    	updateData->Percent_Rain = insertData->Percent_Rain;
    	updateData->Start_Date_Time = insertData->Start_Date_Time;
    	updateData->Stop_Date_Time = insertData->Stop_Date_Time;
    	updateData->Percent_Rain_Chg_Flag = 1;

    	retcode = IMupdate(sSession, (IMdata *)updateData);
    	if (retcode != IM_SUCCESS)
    	{
	  /* Unable to do update TSDIS database. */
	  TKreportWarning(W_TK_FAILIMUPDATE);
	  status = W_TK_FAILIMUPDATE;	
    	}
    	IMfreeRec(updateData);
	IMfreeRec(insertData);
	IMclose(sSession);
    }
  }
  else
  {     
	TKreportWarning(W_TK_FAILIMINSERT);
	IMfreeRec(insertData);
	IMclose(sSession);
        status = W_TK_FAILIMINSERT;
  }


#endif


  return(status);

}

/*********************************************************************************************
*
*   FUNCTION STATEMENT:
*        TKremoveQuotes (char *value)  
*
*   DESCRIPTION:
*        This function is used to strip the double quotes off of a string.
*
*   INPUT PARAMETERS:
*        Parameter Name           Description
*        --------------           -----------
*        value                    The string containing the metadata element
*                                 with possible surrounding quotes.
*
*   OUTPUT PARAMETERS:
*        Parameter Name           Description
*        --------------           -----------
*        value                    The string containing the metadata element   
*                                 without quotes.                      
*
*   CALLED BY:                    TKreadMetadataChar
*   
*   RETURN VALUES:                none
*
*   ROUTINES CALLED:              none
*
**************************************************************************************************/
int  TKremoveQuotes (char *value) 
{   
  char QUOTES = '\"';
  char *ptr1;           
  int i,size,count;
  
  size = strlen(value);
  ptr1 = value;
  count = size - 1;
  if ( ( ptr1[0] == QUOTES ) && ( ptr1[count] == QUOTES ) )
    {
      ptr1++;
      strncpy ( value, ptr1, --count );
      value[count] = '\0';
    }       
  return ( TK_SUCCESS );
}      

int TKgetAlgorithmID ( char *fileName )
{
  int statusCode = TK_SUCCESS;
  int32 hdfStartID;
  char metadataString[TK_MAX_SZ_ATTRIBUTE];
  char algorithmIDBuffer[256], radarSiteNameBuffer[256];

  hdfStartID = SDstart ( fileName, DFACC_RDONLY );
  if ( hdfStartID != TK_HDF_FAIL )
    {
      statusCode = readpvl_from_hdffile ( hdfStartID, "ArchiveMetadata.0",
                                         metadataString );
      if ( statusCode == TK_SUCCESS )
        {
          parse_pvl ( metadataString, "AlgorithmID", algorithmIDBuffer );
          TKremoveQuotes ( algorithmIDBuffer );
          parse_pvl ( metadataString, "RadarSiteName", radarSiteNameBuffer );
          TKremoveQuotes ( radarSiteNameBuffer );
          /*
          ** SDend closes the file and cleans up memory.
          */
          if (SDend(hdfStartID) != TK_SUCCESS)
          {
              TKreportWarning(W_TK_FAILENDCLS);
              return(W_TK_FAILENDCLS);
          }
          return findAlgorithmTKID ( algorithmIDBuffer, radarSiteNameBuffer );
        }
      else
        {
          TKreportWarning ( W_TK_READPVL );
          return -1;  /*  Since TK_FAIL is a valid TK algorithm ID (1), let's return -1 */
        }
    }
  else
    {
      TKreportWarning ( E_TK_FAILSDSTART );
      return -1;  /*  Since TK_FAIL is a valid TK algorithm ID (1), let's return -1 */
    }

}

char* TKgetTKversion ( char *fileName )
{
  int statusCode = TK_SUCCESS;
  int32 hdfStartID;
  char metadataString[TK_MAX_SZ_ATTRIBUTE];
  char toolkitVersion[100];

  hdfStartID = SDstart ( fileName, DFACC_RDONLY );
  if ( hdfStartID != TK_HDF_FAIL )
    {
      statusCode = readpvl_from_hdffile ( hdfStartID, "ArchiveMetadata.0",
					 metadataString );
      if ( statusCode == TK_SUCCESS )
	{
	  parse_pvl ( metadataString, "ToolkitVersion", toolkitVersion );
	  TKremoveQuotes ( toolkitVersion );
          /*
          ** SDend closes the file and cleans up memory.
          */
          if (SDend(hdfStartID) != TK_SUCCESS)
          {
              TKreportWarning(W_TK_FAILENDCLS);
              return NULL;
          }
	  return toolkitVersion;
	}
      else
	{
	  TKreportWarning ( W_TK_READPVL );
	  return NULL;  
	}
    }
  else
    {
      TKreportWarning ( E_TK_FAILSDSTART );
      return NULL;  
    }
}

/**********************************************************************************************
*   FUNCTION STATEMENT:
*   int     determineSubsetGranFlg (int dataType)
*
*   DESCRIPTION:
*        This function determines if this datatype is a real-time subsetted type 
*        or not. 
*
*   INPUT PARAMETERS:
*        Parameter Name           Description
*        --------------           -----------
*        dataType                 The data type of the granule.   
*
*   OUTPUT PARAMETERS:  None
*
*   CALLED BY:                    TKopen
*
*   RETURN VALUES:                TK_TRUE, TK_FALSE 
*
*   ROUTINES CALLED:              none
*
**************************************************************************************************/

int      determineSubsetGranFlg (int dataType)
{
  if ((dataType==TK_L1B_11_R1)||
      (dataType==TK_L2A_12_R1)||
      (dataType==TK_L2A_23_R1)||
      (dataType==TK_L2A_25_R1)||
      (dataType==TK_L2A_25_R2))
  {
      return TK_YES;
  }
  else
  {
      return TK_NO;
  }
}
 

 /**********************************************************************************************
 *   FUNCTION STATEMENT:
 *   int     versionCompare (char* ver1, char* ver2 )
 *
 *   DESCRIPTION:
 *        This function determines if the version of the data element (either 
 *        sds or vdata (ver1)) is before, equal to, or later than the current toolkit
 *        version (ver2). The purpose for this is for backwards compatability of the 
 *        Toolkit. For example 4.9.1 and 5.0 should return a negative number.
 *        But  41.4.2 and 5.4.3 should return a positive number. 
 *        5.0 and 5.0 should return 0.  
 *
 *   INPUT PARAMETERS:
 *        Parameter Name           Description
 *        --------------           -----------
 *        ver1                     the version of an sds or vdata   
 *        ver2                     the version of the current toolkit   
 *
 *   OUTPUT PARAMETERS:  None
 *
 *   CALLED BY:                    pushSDSnode, pushVdataFieldNode 
 *
 *   RETURN VALUES:                an integer comparison, either <,=,> 0 
 *
 *   ROUTINES CALLED:              none
 *
 **************************************************************************************************/
 
 int  versionCompare (char * const_ver1, char* const_ver2)
 {
  
 char ver1[50];
 char ver2[50];
 int ia1[25];
 int ia2[25];
 int i;
 char s1[]=".";
 char s2[]=".";
 char *p1;
 char *p2;
 
 if ((strlen(const_ver1)==0)&&(strlen(const_ver2)==0))
     return 0;

 if (strlen(const_ver1)==0)
     return -999;

 if (strlen(const_ver2)==0)
     return 999;

 strcpy(ver1,const_ver1);
 strcpy(ver2,const_ver2);
 
 for (i=0; i<25; i++) ia1[i]=0; 
 for (i=0; i<25; i++) ia2[i]=0; 
 
 p1=strtok(ver1,s1);
 ia1[0]=atoi(p1);
 i=1;
 while((p1=strtok(NULL,s1)) != NULL)
     ia1[i++]=atoi(p1);
   
 p2=strtok(ver2,s2);
 ia2[0]=atoi(p2);
 i=1;
 while((p2=strtok(NULL,s2)) != NULL)
     ia2[i++]=atoi(p2);
   
 for (i=0; i<25; i++) 
 {
     if (ia1[i]!=ia2[i])
         return (ia1[i]-ia2[i]); 
 }
  
 return 0;
 
 }


int TKwriteFileInfo(IO_HANDLE *sGranuleHandle, char *file_name, char *label)
{
    int32 sdstartID;
    FILE *fp;
    char line[256];        /* a line of text */
    char text[25600];      /* a buffer to hold all of the text */
    int c, textLength = 0; /* c is an int b/c it could be EOF */

   /* Let's not accept null pointers */
   if ((file_name==NULL)||(label==NULL)){
      TKreportWarningParm(W_TK_MAXSIZE,"Null pointer in argument list.");
      return(W_TK_MAXSIZE);
   }
   /* Let's not accept really big file names */
   if (strlen(label)>255) {
      TKreportWarningParm(W_TK_MAXSIZE,"The file name is too big.");
      return(W_TK_MAXSIZE);
   }
   /* Let's not accept empty file names*/
   if (strlen(label)==0) {
      TKreportWarningParm(W_TK_MAXSIZE,"The file name is empty.");
      return(W_TK_MAXSIZE);
   }
   /* Let's not accept really big labels */
   if (strlen(label)>255) {
      TKreportWarningParm(W_TK_MAXSIZE,"The label is too big.");
      return(W_TK_MAXSIZE);
   }
   /* Let's not accept empty labels */
   if (strlen(label)==0) {
      TKreportWarningParm(W_TK_MAXSIZE,"The label is empty.");
      return(W_TK_MAXSIZE);
   }

   /* Open the file */
   if ((fp=fopen(file_name,"r"))==NULL) {
      TKreportErrorParm(E_TK_OPENFAIL,file_name);    /* fopen failed */
      return(E_TK_OPENFAIL);
   }

   /* Get the contents of the text file */ 
   while ((c = getc(fp)) != EOF) {
       text[textLength++]=c; 

       /* Let's not accept really big files */
       if (textLength>=25500) {
          fclose(fp);
          TKreportWarningParm(W_TK_MAXSIZE,"The file is too big.");
          return(W_TK_MAXSIZE);
       }

   }

   /* write the text out to the HDF file  */ 

    sdstartID = sGranuleHandle->cfgSTR->sdStartID;

    if (SDsetattr(sdstartID, label, DFNT_CHAR8, textLength, (VOIDP)text) != TK_SUCCESS)
        {
          fclose(fp);
          TKreportWarning(W_TK_SETATTR);
          return(W_TK_SETATTR);
        }

   return(TK_SUCCESS);
}
 

int TKreadFileInfo(IO_HANDLE *sGranuleHandle, char *label, char *text)
{
    int32 attr_index, num_type, count, size_attr;
    int32 sdstartID;
    char attr_name[TK_FNAME_LEN];

   /* Let's not accept null pointers */
   if ((text==NULL)||(label==NULL)){
      TKreportWarningParm(W_TK_MAXSIZE,"Null pointer in argument list.");
      return(W_TK_MAXSIZE);
   }
   /* Let's not accept really big labels */
   if (strlen(label)>255) {
      TKreportWarningParm(W_TK_MAXSIZE,"The label is too big.");
      return(W_TK_MAXSIZE);
   }
   /* Let's not accept empty labels */
   if (strlen(label)==0) {
      TKreportWarningParm(W_TK_MAXSIZE,"The label is empty.");
      return(W_TK_MAXSIZE);
   }

    sdstartID = sGranuleHandle->cfgSTR->sdStartID;

    attr_index = SDfindattr(sdstartID, label);

    /* Get information about the file attribute */
    if (SDattrinfo(sdstartID, attr_index, attr_name, &num_type, &count) != TK_SUCCESS) {
      TKreportWarningParm(W_TK_ATTRINFO,label);
      strcpy(text,"");
      return(W_TK_ATTRINFO) ;
    }

    /* read the attribute data */
    if (SDreadattr(sdstartID, attr_index, text) != TK_SUCCESS) {
      TKreportWarningParm(W_TK_READATTR,label);
      strcpy(text,"");
      return(W_TK_READATTR) ;
    }

    return(TK_SUCCESS);
}


